#ifndef LIB_DBG_DEBUG_MQLAPI_TRACER_OVERWRITE_MACROS_MQH_INCLUDED
#define LIB_DBG_DEBUG_MQLAPI_TRACER_OVERWRITE_MACROS_MQH_INCLUDED
#property version "5.50"
/**********************************************************************************
 * Copyright (C) 2020 Dominik Egert <info@freie-netze.de>
 *
 * This file is the MQL-API MQL4+ and 5 replacement macros include file.
 *
 * Lisence applied: GPLv2
 *                  https://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 *
 * Author Dominik Egert / Freie Netze UG.
 **********************************************************************************
 *
 *  Version: 4120
 *  State: public
 *
 *  File information
 *  ================
 *
*/




//*********************************************************************************************************************************************************/
//  BEGIN MQLAPI tracer replacement macros
//


/////////////////////////////////////////////////////////////////////////////////////////////////////
//
// MT4/5 API function selective call tracing
//
#ifdef LIB_MQLAPI_TRACE_SELECTIVE_CALL_TRACING

    // VOID-Functions

        // MQL4 and MQL5 shared functions
        #ifndef DBG_MQLAPI_TRACE_Alert
            #define DBG_MQLAPI_NOTRACE_Alert
        #endif
        #ifndef DBG_MQLAPI_TRACE_Comment
            #define DBG_MQLAPI_NOTRACE_Comment
        #endif
        #ifndef DBG_MQLAPI_TRACE_Print
            #define DBG_MQLAPI_NOTRACE_Print
        #endif
        #ifndef DBG_MQLAPI_TRACE_printf
            #define DBG_MQLAPI_NOTRACE_printf
        #endif
        #ifndef DBG_MQLAPI_TRACE_PrintFormat
            #define DBG_MQLAPI_NOTRACE_PrintFormat
        #endif
        #ifndef DBG_MQLAPI_TRACE_ArrayFill
            #define DBG_MQLAPI_NOTRACE_ArrayFill
        #endif
        #ifndef DBG_MQLAPI_TRACE_ArrayFree
            #define DBG_MQLAPI_NOTRACE_ArrayFree
        #endif
        #ifndef DBG_MQLAPI_TRACE_ZeroMemory
            #define DBG_MQLAPI_NOTRACE_ZeroMemory
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartRedraw
            #define DBG_MQLAPI_NOTRACE_ChartRedraw
        #endif
        #ifndef DBG_MQLAPI_TRACE_DebugBreak
            #define DBG_MQLAPI_NOTRACE_DebugBreak
        #endif
        #ifndef DBG_MQLAPI_TRACE_EventKillTimer
            #define DBG_MQLAPI_NOTRACE_EventKillTimer
        #endif
        #ifndef DBG_MQLAPI_TRACE_ExpertRemove
            #define DBG_MQLAPI_NOTRACE_ExpertRemove
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileClose
            #define DBG_MQLAPI_NOTRACE_FileClose
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileFindClose
            #define DBG_MQLAPI_NOTRACE_FileFindClose
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileFlush
            #define DBG_MQLAPI_NOTRACE_FileFlush
        #endif
        #ifndef DBG_MQLAPI_TRACE_GlobalVariablesFlush
            #define DBG_MQLAPI_NOTRACE_GlobalVariablesFlush
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathSrand
            #define DBG_MQLAPI_NOTRACE_MathSrand
        #endif
        #ifndef DBG_MQLAPI_TRACE_ResetLastError
            #define DBG_MQLAPI_NOTRACE_ResetLastError
        #endif
        #ifndef DBG_MQLAPI_TRACE_SetReturnError
            #define DBG_MQLAPI_NOTRACE_SetReturnError
        #endif
        #ifndef DBG_MQLAPI_TRACE_SetUserError
            #define DBG_MQLAPI_NOTRACE_SetUserError
        #endif
        #ifndef DBG_MQLAPI_TRACE_Sleep
            #define DBG_MQLAPI_NOTRACE_Sleep
        #endif
        #ifndef DBG_MQLAPI_TRACE_srand
            #define DBG_MQLAPI_NOTRACE_srand
        #endif


        // MQL4 exclusive functions
        #ifdef __MQL4__
            #ifndef DBG_MQLAPI_TRACE_HideTestIndicators
                #define DBG_MQLAPI_NOTRACE_HideTestIndicators
            #endif
            #ifndef DBG_MQLAPI_TRACE_IndicatorDigits
                #define DBG_MQLAPI_NOTRACE_IndicatorDigits
            #endif
            #ifndef DBG_MQLAPI_TRACE_IndicatorShortName
                #define DBG_MQLAPI_NOTRACE_IndicatorShortName
            #endif
            #ifndef DBG_MQLAPI_TRACE_MQLSetInteger
                #define DBG_MQLAPI_NOTRACE_MQLSetInteger
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrderPrint
                #define DBG_MQLAPI_NOTRACE_OrderPrint
            #endif
            #ifndef DBG_MQLAPI_TRACE_SetIndexArrow
                #define DBG_MQLAPI_NOTRACE_SetIndexArrow
            #endif
            #ifndef DBG_MQLAPI_TRACE_SetIndexDrawBegin
                #define DBG_MQLAPI_NOTRACE_SetIndexDrawBegin
            #endif
            #ifndef DBG_MQLAPI_TRACE_SetIndexEmptyValue
                #define DBG_MQLAPI_NOTRACE_SetIndexEmptyValue
            #endif
            #ifndef DBG_MQLAPI_TRACE_SetIndexLabel
                #define DBG_MQLAPI_NOTRACE_SetIndexLabel
            #endif
            #ifndef DBG_MQLAPI_TRACE_SetIndexShift
                #define DBG_MQLAPI_NOTRACE_SetIndexShift
            #endif
            #ifndef DBG_MQLAPI_TRACE_SetIndexStyle
                #define DBG_MQLAPI_NOTRACE_SetIndexStyle
            #endif
            #ifndef DBG_MQLAPI_TRACE_SetLevelStyle
                #define DBG_MQLAPI_NOTRACE_SetLevelStyle
            #endif
            #ifndef DBG_MQLAPI_TRACE_SetLevelValue
                #define DBG_MQLAPI_NOTRACE_SetLevelValue
            #endif
            #ifndef DBG_MQLAPI_TRACE_WindowRedraw
                #define DBG_MQLAPI_NOTRACE_WindowRedraw
            #endif

        #endif


        // MQL5 exclusive functions
        #ifndef __MQL4__
            #ifndef DBG_MQLAPI_TRACE_ArrayPrint
                #define DBG_MQLAPI_NOTRACE_ArrayPrint
            #endif
            #ifndef DBG_MQLAPI_TRACE_CLBufferFree
                #define DBG_MQLAPI_NOTRACE_CLBufferFree
            #endif
            #ifndef DBG_MQLAPI_TRACE_CLContextFree
                #define DBG_MQLAPI_NOTRACE_CLContextFree
            #endif
            #ifndef DBG_MQLAPI_TRACE_CLKernelFree
                #define DBG_MQLAPI_NOTRACE_CLKernelFree
            #endif
            #ifndef DBG_MQLAPI_TRACE_CLProgramFree
                #define DBG_MQLAPI_NOTRACE_CLProgramFree
            #endif
            #ifndef DBG_MQLAPI_TRACE_DatabaseClose
                #define DBG_MQLAPI_NOTRACE_DatabaseClose
            #endif
            #ifndef DBG_MQLAPI_TRACE_DatabaseFinalize
                #define DBG_MQLAPI_NOTRACE_DatabaseFinalize
            #endif
            #ifndef DBG_MQLAPI_TRACE_TesterHideIndicators
                #define DBG_MQLAPI_NOTRACE_TesterHideIndicators
            #endif
            #ifndef DBG_MQLAPI_TRACE_TesterStop
                #define DBG_MQLAPI_NOTRACE_TesterStop
            #endif

        #endif


    // RETURN-Functions

        // MQL4 and MQL5 shared functions
        #ifndef DBG_MQLAPI_TRACE_AccountInfoDouble
            #define DBG_MQLAPI_NOTRACE_AccountInfoDouble
        #endif
        #ifndef DBG_MQLAPI_TRACE_AccountInfoString
            #define DBG_MQLAPI_NOTRACE_AccountInfoString
        #endif
        #ifndef DBG_MQLAPI_TRACE_acos
            #define DBG_MQLAPI_NOTRACE_acos
        #endif
        #ifndef DBG_MQLAPI_TRACE_ArrayBsearch
            #define DBG_MQLAPI_NOTRACE_ArrayBsearch
        #endif
        #ifndef DBG_MQLAPI_TRACE_ArrayCompare
            #define DBG_MQLAPI_NOTRACE_ArrayCompare
        #endif
        #ifndef DBG_MQLAPI_TRACE_ArrayCopy
            #define DBG_MQLAPI_NOTRACE_ArrayCopy
        #endif
        #ifndef DBG_MQLAPI_TRACE_ArrayGetAsSeries
            #define DBG_MQLAPI_NOTRACE_ArrayGetAsSeries
        #endif
        #ifndef DBG_MQLAPI_TRACE_ArrayInitialize
            #define DBG_MQLAPI_NOTRACE_ArrayInitialize
        #endif
        #ifndef DBG_MQLAPI_TRACE_ArrayIsDynamic
            #define DBG_MQLAPI_NOTRACE_ArrayIsDynamic
        #endif
        #ifndef DBG_MQLAPI_TRACE_ArrayIsSeries
            #define DBG_MQLAPI_NOTRACE_ArrayIsSeries
        #endif
        #ifndef DBG_MQLAPI_TRACE_ArrayMaximum
            #define DBG_MQLAPI_NOTRACE_ArrayMaximum
        #endif
        #ifndef DBG_MQLAPI_TRACE_ArrayMinimum
            #define DBG_MQLAPI_NOTRACE_ArrayMinimum
        #endif
        #ifndef DBG_MQLAPI_TRACE_ArrayRange
            #define DBG_MQLAPI_NOTRACE_ArrayRange
        #endif
        #ifndef DBG_MQLAPI_TRACE_ArrayResize
            #define DBG_MQLAPI_NOTRACE_ArrayResize
        #endif
        #ifndef DBG_MQLAPI_TRACE_ArraySetAsSeries
            #define DBG_MQLAPI_NOTRACE_ArraySetAsSeries
        #endif
        #ifndef DBG_MQLAPI_TRACE_ArraySize
            #define DBG_MQLAPI_NOTRACE_ArraySize
        #endif
        #ifndef DBG_MQLAPI_TRACE_ArraySort
            #define DBG_MQLAPI_NOTRACE_ArraySort
        #endif
        #ifndef DBG_MQLAPI_TRACE_asin
            #define DBG_MQLAPI_NOTRACE_asin
        #endif
        #ifndef DBG_MQLAPI_TRACE_atan
            #define DBG_MQLAPI_NOTRACE_atan
        #endif
        #ifndef DBG_MQLAPI_TRACE_ceil
            #define DBG_MQLAPI_NOTRACE_ceil
        #endif
        #ifndef DBG_MQLAPI_TRACE_CharArrayToString
            #define DBG_MQLAPI_NOTRACE_CharArrayToString
        #endif
        #ifndef DBG_MQLAPI_TRACE_CharToString
            #define DBG_MQLAPI_NOTRACE_CharToString
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartApplyTemplate
            #define DBG_MQLAPI_NOTRACE_ChartApplyTemplate
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartClose
            #define DBG_MQLAPI_NOTRACE_ChartClose
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartFirst
            #define DBG_MQLAPI_NOTRACE_ChartFirst
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartGetDouble
            #define DBG_MQLAPI_NOTRACE_ChartGetDouble
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartGetInteger
            #define DBG_MQLAPI_NOTRACE_ChartGetInteger
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartGetString
            #define DBG_MQLAPI_NOTRACE_ChartGetString
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartID
            #define DBG_MQLAPI_NOTRACE_ChartID
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartIndicatorDelete
            #define DBG_MQLAPI_NOTRACE_ChartIndicatorDelete
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartIndicatorName
            #define DBG_MQLAPI_NOTRACE_ChartIndicatorName
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartIndicatorsTotal
            #define DBG_MQLAPI_NOTRACE_ChartIndicatorsTotal
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartNavigate
            #define DBG_MQLAPI_NOTRACE_ChartNavigate
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartNext
            #define DBG_MQLAPI_NOTRACE_ChartNext
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartOpen
            #define DBG_MQLAPI_NOTRACE_ChartOpen
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartPeriod
            #define DBG_MQLAPI_NOTRACE_ChartPeriod
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartPriceOnDropped
            #define DBG_MQLAPI_NOTRACE_ChartPriceOnDropped
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartSaveTemplate
            #define DBG_MQLAPI_NOTRACE_ChartSaveTemplate
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartScreenShot
            #define DBG_MQLAPI_NOTRACE_ChartScreenShot
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartSetDouble
            #define DBG_MQLAPI_NOTRACE_ChartSetDouble
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartSetInteger
            #define DBG_MQLAPI_NOTRACE_ChartSetInteger
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartSetString
            #define DBG_MQLAPI_NOTRACE_ChartSetString
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartSetSymbolPeriod
            #define DBG_MQLAPI_NOTRACE_ChartSetSymbolPeriod
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartSymbol
            #define DBG_MQLAPI_NOTRACE_ChartSymbol
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartTimeOnDropped
            #define DBG_MQLAPI_NOTRACE_ChartTimeOnDropped
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartTimePriceToXY
            #define DBG_MQLAPI_NOTRACE_ChartTimePriceToXY
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartWindowFind
            #define DBG_MQLAPI_NOTRACE_ChartWindowFind
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartWindowOnDropped
            #define DBG_MQLAPI_NOTRACE_ChartWindowOnDropped
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartXOnDropped
            #define DBG_MQLAPI_NOTRACE_ChartXOnDropped
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartXYToTimePrice
            #define DBG_MQLAPI_NOTRACE_ChartXYToTimePrice
        #endif
        #ifndef DBG_MQLAPI_TRACE_ChartYOnDropped
            #define DBG_MQLAPI_NOTRACE_ChartYOnDropped
        #endif
        #ifndef DBG_MQLAPI_TRACE_CheckPointer
            #define DBG_MQLAPI_NOTRACE_CheckPointer
        #endif
        #ifndef DBG_MQLAPI_TRACE_ColorToARGB
            #define DBG_MQLAPI_NOTRACE_ColorToARGB
        #endif
        #ifndef DBG_MQLAPI_TRACE_ColorToString
            #define DBG_MQLAPI_NOTRACE_ColorToString
        #endif
        #ifndef DBG_MQLAPI_TRACE_CopyClose
            #define DBG_MQLAPI_NOTRACE_CopyClose
        #endif
        #ifndef DBG_MQLAPI_TRACE_CopyHigh
            #define DBG_MQLAPI_NOTRACE_CopyHigh
        #endif
        #ifndef DBG_MQLAPI_TRACE_CopyLow
            #define DBG_MQLAPI_NOTRACE_CopyLow
        #endif
        #ifndef DBG_MQLAPI_TRACE_CopyOpen
            #define DBG_MQLAPI_NOTRACE_CopyOpen
        #endif
        #ifndef DBG_MQLAPI_TRACE_CopyRates
            #define DBG_MQLAPI_NOTRACE_CopyRates
        #endif
        #ifndef DBG_MQLAPI_TRACE_CopyRealVolume
            #define DBG_MQLAPI_NOTRACE_CopyRealVolume
        #endif
        #ifndef DBG_MQLAPI_TRACE_CopySpread
            #define DBG_MQLAPI_NOTRACE_CopySpread
        #endif
        #ifndef DBG_MQLAPI_TRACE_CopyTickVolume
            #define DBG_MQLAPI_NOTRACE_CopyTickVolume
        #endif
        #ifndef DBG_MQLAPI_TRACE_CopyTime
            #define DBG_MQLAPI_NOTRACE_CopyTime
        #endif
        #ifndef DBG_MQLAPI_TRACE_cos
            #define DBG_MQLAPI_NOTRACE_cos
        #endif
        #ifndef DBG_MQLAPI_TRACE_CryptDecode
            #define DBG_MQLAPI_NOTRACE_CryptDecode
        #endif
        #ifndef DBG_MQLAPI_TRACE_CryptEncode
            #define DBG_MQLAPI_NOTRACE_CryptEncode
        #endif
        #ifndef DBG_MQLAPI_TRACE_DoubleToString
            #define DBG_MQLAPI_NOTRACE_DoubleToString
        #endif
        #ifndef DBG_MQLAPI_TRACE_EnumToString
            #define DBG_MQLAPI_NOTRACE_EnumToString
        #endif
        #ifndef DBG_MQLAPI_TRACE_EventChartCustom
            #define DBG_MQLAPI_NOTRACE_EventChartCustom
        #endif
        #ifndef DBG_MQLAPI_TRACE_EventSetMillisecondTimer
            #define DBG_MQLAPI_NOTRACE_EventSetMillisecondTimer
        #endif
        #ifndef DBG_MQLAPI_TRACE_EventSetTimer
            #define DBG_MQLAPI_NOTRACE_EventSetTimer
        #endif
        #ifndef DBG_MQLAPI_TRACE_exp
            #define DBG_MQLAPI_NOTRACE_exp
        #endif
        #ifndef DBG_MQLAPI_TRACE_fabs
            #define DBG_MQLAPI_NOTRACE_fabs
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileCopy
            #define DBG_MQLAPI_NOTRACE_FileCopy
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileDelete
            #define DBG_MQLAPI_NOTRACE_FileDelete
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileFindFirst
            #define DBG_MQLAPI_NOTRACE_FileFindFirst
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileFindNext
            #define DBG_MQLAPI_NOTRACE_FileFindNext
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileGetInteger
            #define DBG_MQLAPI_NOTRACE_FileGetInteger
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileIsEnding
            #define DBG_MQLAPI_NOTRACE_FileIsEnding
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileIsExist
            #define DBG_MQLAPI_NOTRACE_FileIsExist
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileIsLineEnding
            #define DBG_MQLAPI_NOTRACE_FileIsLineEnding
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileMove
            #define DBG_MQLAPI_NOTRACE_FileMove
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileOpen
            #define DBG_MQLAPI_NOTRACE_FileOpen
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileReadArray
            #define DBG_MQLAPI_NOTRACE_FileReadArray
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileReadBool
            #define DBG_MQLAPI_NOTRACE_FileReadBool
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileReadDatetime
            #define DBG_MQLAPI_NOTRACE_FileReadDatetime
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileReadDouble
            #define DBG_MQLAPI_NOTRACE_FileReadDouble
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileReadFloat
            #define DBG_MQLAPI_NOTRACE_FileReadFloat
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileReadInteger
            #define DBG_MQLAPI_NOTRACE_FileReadInteger
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileReadLong
            #define DBG_MQLAPI_NOTRACE_FileReadLong
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileReadNumber
            #define DBG_MQLAPI_NOTRACE_FileReadNumber
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileReadString
            #define DBG_MQLAPI_NOTRACE_FileReadString
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileReadStruct
            #define DBG_MQLAPI_NOTRACE_FileReadStruct
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileSeek
            #define DBG_MQLAPI_NOTRACE_FileSeek
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileSize
            #define DBG_MQLAPI_NOTRACE_FileSize
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileTell
            #define DBG_MQLAPI_NOTRACE_FileTell
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileWrite
            #define DBG_MQLAPI_NOTRACE_FileWrite
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileWriteArray
            #define DBG_MQLAPI_NOTRACE_FileWriteArray
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileWriteDouble
            #define DBG_MQLAPI_NOTRACE_FileWriteDouble
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileWriteFloat
            #define DBG_MQLAPI_NOTRACE_FileWriteFloat
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileWriteInteger
            #define DBG_MQLAPI_NOTRACE_FileWriteInteger
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileWriteLong
            #define DBG_MQLAPI_NOTRACE_FileWriteLong
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileWriteString
            #define DBG_MQLAPI_NOTRACE_FileWriteString
        #endif
        #ifndef DBG_MQLAPI_TRACE_FileWriteStruct
            #define DBG_MQLAPI_NOTRACE_FileWriteStruct
        #endif
        #ifndef DBG_MQLAPI_TRACE_floor
            #define DBG_MQLAPI_NOTRACE_floor
        #endif
        #ifndef DBG_MQLAPI_TRACE_fmax
            #define DBG_MQLAPI_NOTRACE_fmax
        #endif
        #ifndef DBG_MQLAPI_TRACE_fmin
            #define DBG_MQLAPI_NOTRACE_fmin
        #endif
        #ifndef DBG_MQLAPI_TRACE_fmod
            #define DBG_MQLAPI_NOTRACE_fmod
        #endif
        #ifndef DBG_MQLAPI_TRACE_FolderClean
            #define DBG_MQLAPI_NOTRACE_FolderClean
        #endif
        #ifndef DBG_MQLAPI_TRACE_FolderCreate
            #define DBG_MQLAPI_NOTRACE_FolderCreate
        #endif
        #ifndef DBG_MQLAPI_TRACE_FolderDelete
            #define DBG_MQLAPI_NOTRACE_FolderDelete
        #endif
        #ifndef DBG_MQLAPI_TRACE_GetLastError
            #define DBG_MQLAPI_NOTRACE_GetLastError
        #endif
        #ifndef DBG_MQLAPI_TRACE_GetMicrosecondCount
            #define DBG_MQLAPI_NOTRACE_GetMicrosecondCount
        #endif
        #ifndef DBG_MQLAPI_TRACE_GetPointer
            #define DBG_MQLAPI_NOTRACE_GetPointer
        #endif
        #ifndef DBG_MQLAPI_TRACE_GetTickCount
            #define DBG_MQLAPI_NOTRACE_GetTickCount
        #endif
        #ifndef DBG_MQLAPI_TRACE_GlobalVariableCheck
            #define DBG_MQLAPI_NOTRACE_GlobalVariableCheck
        #endif
        #ifndef DBG_MQLAPI_TRACE_GlobalVariableDel
            #define DBG_MQLAPI_NOTRACE_GlobalVariableDel
        #endif
        #ifndef DBG_MQLAPI_TRACE_GlobalVariableGet
            #define DBG_MQLAPI_NOTRACE_GlobalVariableGet
        #endif
        #ifndef DBG_MQLAPI_TRACE_GlobalVariableName
            #define DBG_MQLAPI_NOTRACE_GlobalVariableName
        #endif
        #ifndef DBG_MQLAPI_TRACE_GlobalVariablesDeleteAll
            #define DBG_MQLAPI_NOTRACE_GlobalVariablesDeleteAll
        #endif
        #ifndef DBG_MQLAPI_TRACE_GlobalVariableSet
            #define DBG_MQLAPI_NOTRACE_GlobalVariableSet
        #endif
        #ifndef DBG_MQLAPI_TRACE_GlobalVariableSetOnCondition
            #define DBG_MQLAPI_NOTRACE_GlobalVariableSetOnCondition
        #endif
        #ifndef DBG_MQLAPI_TRACE_GlobalVariablesTotal
            #define DBG_MQLAPI_NOTRACE_GlobalVariablesTotal
        #endif
        #ifndef DBG_MQLAPI_TRACE_GlobalVariableTemp
            #define DBG_MQLAPI_NOTRACE_GlobalVariableTemp
        #endif
        #ifndef DBG_MQLAPI_TRACE_GlobalVariableTime
            #define DBG_MQLAPI_NOTRACE_GlobalVariableTime
        #endif
        #ifndef DBG_MQLAPI_TRACE_iBars
            #define DBG_MQLAPI_NOTRACE_iBars
        #endif
        #ifndef DBG_MQLAPI_TRACE_iBarShift
            #define DBG_MQLAPI_NOTRACE_iBarShift
        #endif
        #ifndef DBG_MQLAPI_TRACE_iClose
            #define DBG_MQLAPI_NOTRACE_iClose
        #endif
        #ifndef DBG_MQLAPI_TRACE_iCustom
            #define DBG_MQLAPI_NOTRACE_iCustom
        #endif
        #ifndef DBG_MQLAPI_TRACE_iHigh
            #define DBG_MQLAPI_NOTRACE_iHigh
        #endif
        #ifndef DBG_MQLAPI_TRACE_iHighest
            #define DBG_MQLAPI_NOTRACE_iHighest
        #endif
        #ifndef DBG_MQLAPI_TRACE_iLow
            #define DBG_MQLAPI_NOTRACE_iLow
        #endif
        #ifndef DBG_MQLAPI_TRACE_iLowest
            #define DBG_MQLAPI_NOTRACE_iLowest
        #endif
        #ifndef DBG_MQLAPI_TRACE_iOpen
            #define DBG_MQLAPI_NOTRACE_iOpen
        #endif
        #ifndef DBG_MQLAPI_TRACE_iTime
            #define DBG_MQLAPI_NOTRACE_iTime
        #endif
        #ifndef DBG_MQLAPI_TRACE_iVolume
            #define DBG_MQLAPI_NOTRACE_iVolume
        #endif
        #ifndef DBG_MQLAPI_TRACE_iAC
            #define DBG_MQLAPI_NOTRACE_iAC
        #endif
        #ifndef DBG_MQLAPI_TRACE_iAD
            #define DBG_MQLAPI_NOTRACE_iAD
        #endif
        #ifndef DBG_MQLAPI_TRACE_iADX
            #define DBG_MQLAPI_NOTRACE_iADX
        #endif
        #ifndef DBG_MQLAPI_TRACE_iAlligator
            #define DBG_MQLAPI_NOTRACE_iAlligator
        #endif
        #ifndef DBG_MQLAPI_TRACE_iAO
            #define DBG_MQLAPI_NOTRACE_iAO
        #endif
        #ifndef DBG_MQLAPI_TRACE_iATR
            #define DBG_MQLAPI_NOTRACE_iATR
        #endif
        #ifndef DBG_MQLAPI_TRACE_iBands
            #define DBG_MQLAPI_NOTRACE_iBands
        #endif
        #ifndef DBG_MQLAPI_TRACE_iBearsPower
            #define DBG_MQLAPI_NOTRACE_iBearsPower
        #endif
        #ifndef DBG_MQLAPI_TRACE_iBullsPower
            #define DBG_MQLAPI_NOTRACE_iBullsPower
        #endif
        #ifndef DBG_MQLAPI_TRACE_iBWMFI
            #define DBG_MQLAPI_NOTRACE_iBWMFI
        #endif
        #ifndef DBG_MQLAPI_TRACE_iCCI
            #define DBG_MQLAPI_NOTRACE_iCCI
        #endif
        #ifndef DBG_MQLAPI_TRACE_iDeMarker
            #define DBG_MQLAPI_NOTRACE_iDeMarker
        #endif
        #ifndef DBG_MQLAPI_TRACE_iEnvelopes
            #define DBG_MQLAPI_NOTRACE_iEnvelopes
        #endif
        #ifndef DBG_MQLAPI_TRACE_iForce
            #define DBG_MQLAPI_NOTRACE_iForce
        #endif
        #ifndef DBG_MQLAPI_TRACE_iFractals
            #define DBG_MQLAPI_NOTRACE_iFractals
        #endif
        #ifndef DBG_MQLAPI_TRACE_iGator
            #define DBG_MQLAPI_NOTRACE_iGator
        #endif
        #ifndef DBG_MQLAPI_TRACE_iIchimoku
            #define DBG_MQLAPI_NOTRACE_iIchimoku
        #endif
        #ifndef DBG_MQLAPI_TRACE_iMA
            #define DBG_MQLAPI_NOTRACE_iMA
        #endif
        #ifndef DBG_MQLAPI_TRACE_iMACD
            #define DBG_MQLAPI_NOTRACE_iMACD
        #endif
        #ifndef DBG_MQLAPI_TRACE_iMFI
            #define DBG_MQLAPI_NOTRACE_iMFI
        #endif
        #ifndef DBG_MQLAPI_TRACE_iMomentum
            #define DBG_MQLAPI_NOTRACE_iMomentum
        #endif
        #ifndef DBG_MQLAPI_TRACE_IndicatorSetDouble
            #define DBG_MQLAPI_NOTRACE_IndicatorSetDouble
        #endif
        #ifndef DBG_MQLAPI_TRACE_IndicatorSetInteger
            #define DBG_MQLAPI_NOTRACE_IndicatorSetInteger
        #endif
        #ifndef DBG_MQLAPI_TRACE_IndicatorSetString
            #define DBG_MQLAPI_NOTRACE_IndicatorSetString
        #endif
        #ifndef DBG_MQLAPI_TRACE_IntegerToString
            #define DBG_MQLAPI_NOTRACE_IntegerToString
        #endif
        #ifndef DBG_MQLAPI_TRACE_iOBV
            #define DBG_MQLAPI_NOTRACE_iOBV
        #endif
        #ifndef DBG_MQLAPI_TRACE_iOsMA
            #define DBG_MQLAPI_NOTRACE_iOsMA
        #endif
        #ifndef DBG_MQLAPI_TRACE_iRSI
            #define DBG_MQLAPI_NOTRACE_iRSI
        #endif
        #ifndef DBG_MQLAPI_TRACE_iRVI
            #define DBG_MQLAPI_NOTRACE_iRVI
        #endif
        #ifndef DBG_MQLAPI_TRACE_iSAR
            #define DBG_MQLAPI_NOTRACE_iSAR
        #endif
        #ifndef DBG_MQLAPI_TRACE_IsStopped
            #define DBG_MQLAPI_NOTRACE_IsStopped
        #endif
        #ifndef DBG_MQLAPI_TRACE_iStdDev
            #define DBG_MQLAPI_NOTRACE_iStdDev
        #endif
        #ifndef DBG_MQLAPI_TRACE_iStochastic
            #define DBG_MQLAPI_NOTRACE_iStochastic
        #endif
        #ifndef DBG_MQLAPI_TRACE_iWPR
            #define DBG_MQLAPI_NOTRACE_iWPR
        #endif
        #ifndef DBG_MQLAPI_TRACE_log
            #define DBG_MQLAPI_NOTRACE_log
        #endif
        #ifndef DBG_MQLAPI_TRACE_log10
            #define DBG_MQLAPI_NOTRACE_log10
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathAbs
            #define DBG_MQLAPI_NOTRACE_MathAbs
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathArccos
            #define DBG_MQLAPI_NOTRACE_MathArccos
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathArcsin
            #define DBG_MQLAPI_NOTRACE_MathArcsin
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathArctan
            #define DBG_MQLAPI_NOTRACE_MathArctan
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathArctan2
            #define DBG_MQLAPI_NOTRACE_MathArctan2
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathClassify
            #define DBG_MQLAPI_NOTRACE_MathClassify
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathCeil
            #define DBG_MQLAPI_NOTRACE_MathCeil
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathCos
            #define DBG_MQLAPI_NOTRACE_MathCos
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathExp
            #define DBG_MQLAPI_NOTRACE_MathExp
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathFloor
            #define DBG_MQLAPI_NOTRACE_MathFloor
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathIsValidNumber
            #define DBG_MQLAPI_NOTRACE_MathIsValidNumber
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathLog
            #define DBG_MQLAPI_NOTRACE_MathLog
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathLog10
            #define DBG_MQLAPI_NOTRACE_MathLog10
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathMax
            #define DBG_MQLAPI_NOTRACE_MathMax
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathMin
            #define DBG_MQLAPI_NOTRACE_MathMin
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathMod
            #define DBG_MQLAPI_NOTRACE_MathMod
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathPow
            #define DBG_MQLAPI_NOTRACE_MathPow
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathRand
            #define DBG_MQLAPI_NOTRACE_MathRand
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathRound
            #define DBG_MQLAPI_NOTRACE_MathRound
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathSin
            #define DBG_MQLAPI_NOTRACE_MathSin
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathSqrt
            #define DBG_MQLAPI_NOTRACE_MathSqrt
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathTan
            #define DBG_MQLAPI_NOTRACE_MathTan
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathExpm1
            #define DBG_MQLAPI_NOTRACE_MathExpm1
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathLog1p
            #define DBG_MQLAPI_NOTRACE_MathLog1p
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathArccosh
            #define DBG_MQLAPI_NOTRACE_MathArccosh
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathArcsinh
            #define DBG_MQLAPI_NOTRACE_MathArcsinh
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathArctanh
            #define DBG_MQLAPI_NOTRACE_MathArctanh
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathCosh
            #define DBG_MQLAPI_NOTRACE_MathCosh
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathSinh
            #define DBG_MQLAPI_NOTRACE_MathSinh
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathSwap
            #define DBG_MQLAPI_NOTRACE_MathSwap
        #endif
        #ifndef DBG_MQLAPI_TRACE_MathTanh
            #define DBG_MQLAPI_NOTRACE_MathTanh
        #endif
        #ifndef DBG_MQLAPI_TRACE_MessageBox
            #define DBG_MQLAPI_NOTRACE_MessageBox
        #endif
        #ifndef DBG_MQLAPI_TRACE_MQLInfoString
            #define DBG_MQLAPI_NOTRACE_MQLInfoString
        #endif
        #ifndef DBG_MQLAPI_TRACE_NormalizeDouble
            #define DBG_MQLAPI_NOTRACE_NormalizeDouble
        #endif
        #ifndef DBG_MQLAPI_TRACE_ObjectCreate
            #define DBG_MQLAPI_NOTRACE_ObjectCreate
        #endif
        #ifndef DBG_MQLAPI_TRACE_ObjectDelete
            #define DBG_MQLAPI_NOTRACE_ObjectDelete
        #endif
        #ifndef DBG_MQLAPI_TRACE_ObjectFind
            #define DBG_MQLAPI_NOTRACE_ObjectFind
        #endif
        #ifndef DBG_MQLAPI_TRACE_ObjectGetDouble
            #define DBG_MQLAPI_NOTRACE_ObjectGetDouble
        #endif
        #ifndef DBG_MQLAPI_TRACE_ObjectGetInteger
            #define DBG_MQLAPI_NOTRACE_ObjectGetInteger
        #endif
        #ifndef DBG_MQLAPI_TRACE_ObjectGetString
            #define DBG_MQLAPI_NOTRACE_ObjectGetString
        #endif
        #ifndef DBG_MQLAPI_TRACE_ObjectGetTimeByValue
            #define DBG_MQLAPI_NOTRACE_ObjectGetTimeByValue
        #endif
        #ifndef DBG_MQLAPI_TRACE_ObjectGetValueByTime
            #define DBG_MQLAPI_NOTRACE_ObjectGetValueByTime
        #endif
        #ifndef DBG_MQLAPI_TRACE_ObjectMove
            #define DBG_MQLAPI_NOTRACE_ObjectMove
        #endif
        #ifndef DBG_MQLAPI_TRACE_ObjectName
            #define DBG_MQLAPI_NOTRACE_ObjectName
        #endif
        #ifndef DBG_MQLAPI_TRACE_ObjectsDeleteAll
            #define DBG_MQLAPI_NOTRACE_ObjectsDeleteAll
        #endif
        #ifndef DBG_MQLAPI_TRACE_ObjectSetDouble
            #define DBG_MQLAPI_NOTRACE_ObjectSetDouble
        #endif
        #ifndef DBG_MQLAPI_TRACE_ObjectSetInteger
            #define DBG_MQLAPI_NOTRACE_ObjectSetInteger
        #endif
        #ifndef DBG_MQLAPI_TRACE_ObjectSetString
            #define DBG_MQLAPI_NOTRACE_ObjectSetString
        #endif
        #ifndef DBG_MQLAPI_TRACE_ObjectsTotal
            #define DBG_MQLAPI_NOTRACE_ObjectsTotal
        #endif
        #ifndef DBG_MQLAPI_TRACE_OrderGetDouble
            #define DBG_MQLAPI_NOTRACE_OrderGetDouble
        #endif
        #ifndef DBG_MQLAPI_TRACE_OrderSelect
            #define DBG_MQLAPI_NOTRACE_OrderSelect
        #endif
        #ifndef DBG_MQLAPI_TRACE_OrderSend
            #define DBG_MQLAPI_NOTRACE_OrderSend
        #endif
        #ifndef DBG_MQLAPI_TRACE_Period
            #define DBG_MQLAPI_NOTRACE_Period
        #endif
        #ifndef DBG_MQLAPI_TRACE_PeriodSeconds
            #define DBG_MQLAPI_NOTRACE_PeriodSeconds
        #endif
        #ifndef DBG_MQLAPI_TRACE_PlaySound
            #define DBG_MQLAPI_NOTRACE_PlaySound
        #endif
        #ifndef DBG_MQLAPI_TRACE_PlotIndexGetInteger
            #define DBG_MQLAPI_NOTRACE_PlotIndexGetInteger
        #endif
        #ifndef DBG_MQLAPI_TRACE_PlotIndexSetDouble
            #define DBG_MQLAPI_NOTRACE_PlotIndexSetDouble
        #endif
        #ifndef DBG_MQLAPI_TRACE_PlotIndexSetInteger
            #define DBG_MQLAPI_NOTRACE_PlotIndexSetInteger
        #endif
        #ifndef DBG_MQLAPI_TRACE_PlotIndexSetString
            #define DBG_MQLAPI_NOTRACE_PlotIndexSetString
        #endif
        #ifndef DBG_MQLAPI_TRACE_Point
            #define DBG_MQLAPI_NOTRACE_Point
        #endif
        #ifndef DBG_MQLAPI_TRACE_pow
            #define DBG_MQLAPI_NOTRACE_pow
        #endif
        #ifndef DBG_MQLAPI_TRACE_rand
            #define DBG_MQLAPI_NOTRACE_rand
        #endif
        #ifndef DBG_MQLAPI_TRACE_ResourceCreate
            #define DBG_MQLAPI_NOTRACE_ResourceCreate
        #endif
        #ifndef DBG_MQLAPI_TRACE_ResourceFree
            #define DBG_MQLAPI_NOTRACE_ResourceFree
        #endif
        #ifndef DBG_MQLAPI_TRACE_ResourceReadImage
            #define DBG_MQLAPI_NOTRACE_ResourceReadImage
        #endif
        #ifndef DBG_MQLAPI_TRACE_ResourceSave
            #define DBG_MQLAPI_NOTRACE_ResourceSave
        #endif
        #ifndef DBG_MQLAPI_TRACE_round
            #define DBG_MQLAPI_NOTRACE_round
        #endif
        #ifndef DBG_MQLAPI_TRACE_SendFTP
            #define DBG_MQLAPI_NOTRACE_SendFTP
        #endif
        #ifndef DBG_MQLAPI_TRACE_SendMail
            #define DBG_MQLAPI_NOTRACE_SendMail
        #endif
        #ifndef DBG_MQLAPI_TRACE_SendNotification
            #define DBG_MQLAPI_NOTRACE_SendNotification
        #endif
        #ifndef DBG_MQLAPI_TRACE_SeriesInfoInteger
            #define DBG_MQLAPI_NOTRACE_SeriesInfoInteger
        #endif
        #ifndef DBG_MQLAPI_TRACE_SetIndexBuffer
            #define DBG_MQLAPI_NOTRACE_SetIndexBuffer
        #endif
        #ifndef DBG_MQLAPI_TRACE_ShortArrayToString
            #define DBG_MQLAPI_NOTRACE_ShortArrayToString
        #endif
        #ifndef DBG_MQLAPI_TRACE_ShortToString
            #define DBG_MQLAPI_NOTRACE_ShortToString
        #endif
        #ifndef DBG_MQLAPI_TRACE_SignalBaseGetDouble
            #define DBG_MQLAPI_NOTRACE_SignalBaseGetDouble
        #endif
        #ifndef DBG_MQLAPI_TRACE_SignalBaseGetInteger
            #define DBG_MQLAPI_NOTRACE_SignalBaseGetInteger
        #endif
        #ifndef DBG_MQLAPI_TRACE_SignalBaseGetString
            #define DBG_MQLAPI_NOTRACE_SignalBaseGetString
        #endif
        #ifndef DBG_MQLAPI_TRACE_SignalBaseSelect
            #define DBG_MQLAPI_NOTRACE_SignalBaseSelect
        #endif
        #ifndef DBG_MQLAPI_TRACE_SignalBaseTotal
            #define DBG_MQLAPI_NOTRACE_SignalBaseTotal
        #endif
        #ifndef DBG_MQLAPI_TRACE_SignalInfoGetDouble
            #define DBG_MQLAPI_NOTRACE_SignalInfoGetDouble
        #endif
        #ifndef DBG_MQLAPI_TRACE_SignalInfoGetInteger
            #define DBG_MQLAPI_NOTRACE_SignalInfoGetInteger
        #endif
        #ifndef DBG_MQLAPI_TRACE_SignalInfoGetString
            #define DBG_MQLAPI_NOTRACE_SignalInfoGetString
        #endif
        #ifndef DBG_MQLAPI_TRACE_SignalInfoSetDouble
            #define DBG_MQLAPI_NOTRACE_SignalInfoSetDouble
        #endif
        #ifndef DBG_MQLAPI_TRACE_SignalInfoSetInteger
            #define DBG_MQLAPI_NOTRACE_SignalInfoSetInteger
        #endif
        #ifndef DBG_MQLAPI_TRACE_SignalSubscribe
            #define DBG_MQLAPI_NOTRACE_SignalSubscribe
        #endif
        #ifndef DBG_MQLAPI_TRACE_SignalUnsubscribe
            #define DBG_MQLAPI_NOTRACE_SignalUnsubscribe
        #endif
        #ifndef DBG_MQLAPI_TRACE_sin
            #define DBG_MQLAPI_NOTRACE_sin
        #endif
        #ifndef DBG_MQLAPI_TRACE_sqrt
            #define DBG_MQLAPI_NOTRACE_sqrt
        #endif
        #ifndef DBG_MQLAPI_TRACE_StringAdd
            #define DBG_MQLAPI_NOTRACE_StringAdd
        #endif
        #ifndef DBG_MQLAPI_TRACE_StringBufferLen
            #define DBG_MQLAPI_NOTRACE_StringBufferLen
        #endif
        #ifndef DBG_MQLAPI_TRACE_StringCompare
            #define DBG_MQLAPI_NOTRACE_StringCompare
        #endif
        #ifndef DBG_MQLAPI_TRACE_StringConcatenate
            #define DBG_MQLAPI_NOTRACE_StringConcatenate
        #endif
        #ifndef DBG_MQLAPI_TRACE_StringFill
            #define DBG_MQLAPI_NOTRACE_StringFill
        #endif
        #ifndef DBG_MQLAPI_TRACE_StringFind
            #define DBG_MQLAPI_NOTRACE_StringFind
        #endif
        #ifndef DBG_MQLAPI_TRACE_StringFormat
            #define DBG_MQLAPI_NOTRACE_StringFormat
        #endif
        #ifndef DBG_MQLAPI_TRACE_StringGetCharacter
            #define DBG_MQLAPI_NOTRACE_StringGetCharacter
        #endif
        #ifndef DBG_MQLAPI_TRACE_StringInit
            #define DBG_MQLAPI_NOTRACE_StringInit
        #endif
        #ifndef DBG_MQLAPI_TRACE_StringLen
            #define DBG_MQLAPI_NOTRACE_StringLen
        #endif
        #ifndef DBG_MQLAPI_TRACE_StringReserve
            #define DBG_MQLAPI_NOTRACE_StringReserve
        #endif
        #ifndef DBG_MQLAPI_TRACE_StringReplace
            #define DBG_MQLAPI_NOTRACE_StringReplace
        #endif
        #ifndef DBG_MQLAPI_TRACE_StringSetCharacter
            #define DBG_MQLAPI_NOTRACE_StringSetCharacter
        #endif
        #ifndef DBG_MQLAPI_TRACE_StringSetLength
            #define DBG_MQLAPI_NOTRACE_StringSetLength
        #endif
        #ifndef DBG_MQLAPI_TRACE_StringSplit
            #define DBG_MQLAPI_NOTRACE_StringSplit
        #endif
        #ifndef DBG_MQLAPI_TRACE_StringSubstr
            #define DBG_MQLAPI_NOTRACE_StringSubstr
        #endif
        #ifndef DBG_MQLAPI_TRACE_StringToCharArray
            #define DBG_MQLAPI_NOTRACE_StringToCharArray
        #endif
        #ifndef DBG_MQLAPI_TRACE_StringToColor
            #define DBG_MQLAPI_NOTRACE_StringToColor
        #endif
        #ifndef DBG_MQLAPI_TRACE_StringToDouble
            #define DBG_MQLAPI_NOTRACE_StringToDouble
        #endif
        #ifndef DBG_MQLAPI_TRACE_StringToInteger
            #define DBG_MQLAPI_NOTRACE_StringToInteger
        #endif
        #ifndef DBG_MQLAPI_TRACE_StringToLower
            #define DBG_MQLAPI_NOTRACE_StringToLower
        #endif
        #ifndef DBG_MQLAPI_TRACE_StringToShortArray
            #define DBG_MQLAPI_NOTRACE_StringToShortArray
        #endif
        #ifndef DBG_MQLAPI_TRACE_StringToTime
            #define DBG_MQLAPI_NOTRACE_StringToTime
        #endif
        #ifndef DBG_MQLAPI_TRACE_StringToUpper
            #define DBG_MQLAPI_NOTRACE_StringToUpper
        #endif
        #ifndef DBG_MQLAPI_TRACE_StringTrimLeft
            #define DBG_MQLAPI_NOTRACE_StringTrimLeft
        #endif
        #ifndef DBG_MQLAPI_TRACE_StringTrimRight
            #define DBG_MQLAPI_NOTRACE_StringTrimRight
        #endif
        #ifndef DBG_MQLAPI_TRACE_StructToCharArray
            #define DBG_MQLAPI_NOTRACE_StructToCharArray
        #endif
        #ifndef DBG_MQLAPI_TRACE_StructToTime
            #define DBG_MQLAPI_NOTRACE_StructToTime
        #endif
        #ifndef DBG_MQLAPI_TRACE_Symbol
            #define DBG_MQLAPI_NOTRACE_Symbol
        #endif
        #ifndef DBG_MQLAPI_TRACE_SymbolExist
            #define DBG_MQLAPI_NOTRACE_SymbolExist
        #endif
        #ifndef DBG_MQLAPI_TRACE_SymbolInfoDouble
            #define DBG_MQLAPI_NOTRACE_SymbolInfoDouble
        #endif
        #ifndef DBG_MQLAPI_TRACE_SymbolInfoInteger
            #define DBG_MQLAPI_NOTRACE_SymbolInfoInteger
        #endif
        #ifndef DBG_MQLAPI_TRACE_SymbolInfoSessionQuote
            #define DBG_MQLAPI_NOTRACE_SymbolInfoSessionQuote
        #endif
        #ifndef DBG_MQLAPI_TRACE_SymbolInfoSessionTrade
            #define DBG_MQLAPI_NOTRACE_SymbolInfoSessionTrade
        #endif
        #ifndef DBG_MQLAPI_TRACE_SymbolInfoString
            #define DBG_MQLAPI_NOTRACE_SymbolInfoString
        #endif
        #ifndef DBG_MQLAPI_TRACE_SymbolInfoTick
            #define DBG_MQLAPI_NOTRACE_SymbolInfoTick
        #endif
        #ifndef DBG_MQLAPI_TRACE_SymbolIsSynchronized
            #define DBG_MQLAPI_NOTRACE_SymbolIsSynchronized
        #endif
        #ifndef DBG_MQLAPI_TRACE_SymbolName
            #define DBG_MQLAPI_NOTRACE_SymbolName
        #endif
        #ifndef DBG_MQLAPI_TRACE_SymbolSelect
            #define DBG_MQLAPI_NOTRACE_SymbolSelect
        #endif
        #ifndef DBG_MQLAPI_TRACE_SymbolsTotal
            #define DBG_MQLAPI_NOTRACE_SymbolsTotal
        #endif
        #ifndef DBG_MQLAPI_TRACE_tan
            #define DBG_MQLAPI_NOTRACE_tan
        #endif
        #ifndef DBG_MQLAPI_TRACE_TerminalClose
            #define DBG_MQLAPI_NOTRACE_TerminalClose
        #endif
        #ifndef DBG_MQLAPI_TRACE_TerminalInfoDouble
            #define DBG_MQLAPI_NOTRACE_TerminalInfoDouble
        #endif
        #ifndef DBG_MQLAPI_TRACE_TerminalInfoString
            #define DBG_MQLAPI_NOTRACE_TerminalInfoString
        #endif
        #ifndef DBG_MQLAPI_TRACE_TesterStatistics
            #define DBG_MQLAPI_NOTRACE_TesterStatistics
        #endif
        #ifndef DBG_MQLAPI_TRACE_TextGetSize
            #define DBG_MQLAPI_NOTRACE_TextGetSize
        #endif
        #ifndef DBG_MQLAPI_TRACE_TextOut
            #define DBG_MQLAPI_NOTRACE_TextOut
        #endif
        #ifndef DBG_MQLAPI_TRACE_TextSetFont
            #define DBG_MQLAPI_NOTRACE_TextSetFont
        #endif
        #ifndef DBG_MQLAPI_TRACE_TimeCurrent
            #define DBG_MQLAPI_NOTRACE_TimeCurrent
        #endif
        #ifndef DBG_MQLAPI_TRACE_TimeDaylightSavings
            #define DBG_MQLAPI_NOTRACE_TimeDaylightSavings
        #endif
        #ifndef DBG_MQLAPI_TRACE_TimeGMT
            #define DBG_MQLAPI_NOTRACE_TimeGMT
        #endif
        #ifndef DBG_MQLAPI_TRACE_TimeGMTOffset
            #define DBG_MQLAPI_NOTRACE_TimeGMTOffset
        #endif
        #ifndef DBG_MQLAPI_TRACE_TimeLocal
            #define DBG_MQLAPI_NOTRACE_TimeLocal
        #endif
        #ifndef DBG_MQLAPI_TRACE_TimeToString
            #define DBG_MQLAPI_NOTRACE_TimeToString
        #endif
        #ifndef DBG_MQLAPI_TRACE_TimeToStruct
            #define DBG_MQLAPI_NOTRACE_TimeToStruct
        #endif
        #ifndef DBG_MQLAPI_TRACE_TranslateKey
            #define DBG_MQLAPI_NOTRACE_TranslateKey
        #endif
        #ifndef DBG_MQLAPI_TRACE_UninitializeReason
            #define DBG_MQLAPI_NOTRACE_UninitializeReason
        #endif
        #ifndef DBG_MQLAPI_TRACE_WebRequest
            #define DBG_MQLAPI_NOTRACE_WebRequest
        #endif        


        // MQL4 exclusive functions
        #ifdef __MQL4__
            #ifndef DBG_MQLAPI_TRACE_AccountBalance
                #define DBG_MQLAPI_NOTRACE_AccountBalance
            #endif
            #ifndef DBG_MQLAPI_TRACE_AccountCompany
                #define DBG_MQLAPI_NOTRACE_AccountCompany
            #endif
            #ifndef DBG_MQLAPI_TRACE_AccountCredit
                #define DBG_MQLAPI_NOTRACE_AccountCredit
            #endif
            #ifndef DBG_MQLAPI_TRACE_AccountCurrency
                #define DBG_MQLAPI_NOTRACE_AccountCurrency
            #endif
            #ifndef DBG_MQLAPI_TRACE_AccountEquity
                #define DBG_MQLAPI_NOTRACE_AccountEquity
            #endif
            #ifndef DBG_MQLAPI_TRACE_AccountFreeMargin
                #define DBG_MQLAPI_NOTRACE_AccountFreeMargin
            #endif
            #ifndef DBG_MQLAPI_TRACE_AccountFreeMarginCheck
                #define DBG_MQLAPI_NOTRACE_AccountFreeMarginCheck
            #endif
            #ifndef DBG_MQLAPI_TRACE_AccountFreeMarginMode
                #define DBG_MQLAPI_NOTRACE_AccountFreeMarginMode
            #endif
            #ifndef DBG_MQLAPI_TRACE_AccountLeverage
                #define DBG_MQLAPI_NOTRACE_AccountLeverage
            #endif
            #ifndef DBG_MQLAPI_TRACE_AccountMargin
                #define DBG_MQLAPI_NOTRACE_AccountMargin
            #endif
            #ifndef DBG_MQLAPI_TRACE_AccountName
                #define DBG_MQLAPI_NOTRACE_AccountName
            #endif
            #ifndef DBG_MQLAPI_TRACE_AccountNumber
                #define DBG_MQLAPI_NOTRACE_AccountNumber
            #endif
            #ifndef DBG_MQLAPI_TRACE_AccountProfit
                #define DBG_MQLAPI_NOTRACE_AccountProfit
            #endif
            #ifndef DBG_MQLAPI_TRACE_AccountServer
                #define DBG_MQLAPI_NOTRACE_AccountServer
            #endif
            #ifndef DBG_MQLAPI_TRACE_AccountStopoutLevel
                #define DBG_MQLAPI_NOTRACE_AccountStopoutLevel
            #endif
            #ifndef DBG_MQLAPI_TRACE_AccountStopoutMode
                #define DBG_MQLAPI_NOTRACE_AccountStopoutMode
            #endif
            #ifndef DBG_MQLAPI_TRACE_ArrayCopyRates
                #define DBG_MQLAPI_NOTRACE_ArrayCopyRates
            #endif
            #ifndef DBG_MQLAPI_TRACE_ArrayCopySeries
                #define DBG_MQLAPI_NOTRACE_ArrayCopySeries
            #endif
            #ifndef DBG_MQLAPI_TRACE_ArrayDimension
                #define DBG_MQLAPI_NOTRACE_ArrayDimension
            #endif
            #ifndef DBG_MQLAPI_TRACE_CharToStr
                #define DBG_MQLAPI_NOTRACE_CharToStr
            #endif
            #ifndef DBG_MQLAPI_TRACE_Day
                #define DBG_MQLAPI_NOTRACE_Day
            #endif
            #ifndef DBG_MQLAPI_TRACE_DayOfWeek
                #define DBG_MQLAPI_NOTRACE_DayOfWeek
            #endif
            #ifndef DBG_MQLAPI_TRACE_DayOfYear
                #define DBG_MQLAPI_NOTRACE_DayOfYear
            #endif
            #ifndef DBG_MQLAPI_TRACE_DoubleToStr
                #define DBG_MQLAPI_NOTRACE_DoubleToStr
            #endif
            #ifndef DBG_MQLAPI_TRACE_FileOpenHistory
                #define DBG_MQLAPI_NOTRACE_FileOpenHistory
            #endif
            #ifndef DBG_MQLAPI_TRACE_Hour
                #define DBG_MQLAPI_NOTRACE_Hour
            #endif
            #ifndef DBG_MQLAPI_TRACE_iBandsOnArray
                #define DBG_MQLAPI_NOTRACE_iBandsOnArray
            #endif
            #ifndef DBG_MQLAPI_TRACE_iCCIOnArray
                #define DBG_MQLAPI_NOTRACE_iCCIOnArray
            #endif
            #ifndef DBG_MQLAPI_TRACE_iEnvelopesOnArray
                #define DBG_MQLAPI_NOTRACE_iEnvelopesOnArray
            #endif
            #ifndef DBG_MQLAPI_TRACE_iMAOnArray
                #define DBG_MQLAPI_NOTRACE_iMAOnArray
            #endif
            #ifndef DBG_MQLAPI_TRACE_iMomentumOnArray
                #define DBG_MQLAPI_NOTRACE_iMomentumOnArray
            #endif
            #ifndef DBG_MQLAPI_TRACE_IndicatorBuffers
                #define DBG_MQLAPI_NOTRACE_IndicatorBuffers
            #endif
            #ifndef DBG_MQLAPI_TRACE_IndicatorCounted
                #define DBG_MQLAPI_NOTRACE_IndicatorCounted
            #endif
            #ifndef DBG_MQLAPI_TRACE_iRSIOnArray
                #define DBG_MQLAPI_NOTRACE_iRSIOnArray
            #endif
            #ifndef DBG_MQLAPI_TRACE_IsConnected
                #define DBG_MQLAPI_NOTRACE_IsConnected
            #endif
            #ifndef DBG_MQLAPI_TRACE_IsDemo
                #define DBG_MQLAPI_NOTRACE_IsDemo
            #endif
            #ifndef DBG_MQLAPI_TRACE_IsDllsAllowed
                #define DBG_MQLAPI_NOTRACE_IsDllsAllowed
            #endif
            #ifndef DBG_MQLAPI_TRACE_IsExpertEnabled
                #define DBG_MQLAPI_NOTRACE_IsExpertEnabled
            #endif
            #ifndef DBG_MQLAPI_TRACE_IsLibrariesAllowed
                #define DBG_MQLAPI_NOTRACE_IsLibrariesAllowed
            #endif
            #ifndef DBG_MQLAPI_TRACE_IsOptimization
                #define DBG_MQLAPI_NOTRACE_IsOptimization
            #endif
            #ifndef DBG_MQLAPI_TRACE_iStdDevOnArray
                #define DBG_MQLAPI_NOTRACE_iStdDevOnArray
            #endif
            #ifndef DBG_MQLAPI_TRACE_IsTesting
                #define DBG_MQLAPI_NOTRACE_IsTesting
            #endif
            #ifndef DBG_MQLAPI_TRACE_IsTradeAllowed
                #define DBG_MQLAPI_NOTRACE_IsTradeAllowed
            #endif
            #ifndef DBG_MQLAPI_TRACE_IsTradeContextBusy
                #define DBG_MQLAPI_NOTRACE_IsTradeContextBusy
            #endif
            #ifndef DBG_MQLAPI_TRACE_IsVisualMode
                #define DBG_MQLAPI_NOTRACE_IsVisualMode
            #endif
            #ifndef DBG_MQLAPI_TRACE_MarketInfo
                #define DBG_MQLAPI_NOTRACE_MarketInfo
            #endif
            #ifndef DBG_MQLAPI_TRACE_Minute
                #define DBG_MQLAPI_NOTRACE_Minute
            #endif
            #ifndef DBG_MQLAPI_TRACE_Month
                #define DBG_MQLAPI_NOTRACE_Month
            #endif
            #ifndef DBG_MQLAPI_TRACE_ObjectDescription
                #define DBG_MQLAPI_NOTRACE_ObjectDescription
            #endif
            #ifndef DBG_MQLAPI_TRACE_ObjectGet
                #define DBG_MQLAPI_NOTRACE_ObjectGet
            #endif
            #ifndef DBG_MQLAPI_TRACE_ObjectGetFiboDescription
                #define DBG_MQLAPI_NOTRACE_ObjectGetFiboDescription
            #endif
            #ifndef DBG_MQLAPI_TRACE_ObjectGetShiftByValue
                #define DBG_MQLAPI_NOTRACE_ObjectGetShiftByValue
            #endif
            #ifndef DBG_MQLAPI_TRACE_ObjectGetValueByShift
                #define DBG_MQLAPI_NOTRACE_ObjectGetValueByShift
            #endif
            #ifndef DBG_MQLAPI_TRACE_ObjectSet
                #define DBG_MQLAPI_NOTRACE_ObjectSet
            #endif
            #ifndef DBG_MQLAPI_TRACE_ObjectSetFiboDescription
                #define DBG_MQLAPI_NOTRACE_ObjectSetFiboDescription
            #endif
            #ifndef DBG_MQLAPI_TRACE_ObjectSetText
                #define DBG_MQLAPI_NOTRACE_ObjectSetText
            #endif
            #ifndef DBG_MQLAPI_TRACE_ObjectType
                #define DBG_MQLAPI_NOTRACE_ObjectType
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrderClose
                #define DBG_MQLAPI_NOTRACE_OrderClose
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrderCloseBy
                #define DBG_MQLAPI_NOTRACE_OrderCloseBy
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrderClosePrice
                #define DBG_MQLAPI_NOTRACE_OrderClosePrice
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrderCloseTime
                #define DBG_MQLAPI_NOTRACE_OrderCloseTime
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrderComment
                #define DBG_MQLAPI_NOTRACE_OrderComment
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrderCommission
                #define DBG_MQLAPI_NOTRACE_OrderCommission
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrderDelete
                #define DBG_MQLAPI_NOTRACE_OrderDelete
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrderExpiration
                #define DBG_MQLAPI_NOTRACE_OrderExpiration
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrderLots
                #define DBG_MQLAPI_NOTRACE_OrderLots
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrderMagicNumber
                #define DBG_MQLAPI_NOTRACE_OrderMagicNumber
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrderModify
                #define DBG_MQLAPI_NOTRACE_OrderModify
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrderOpenPrice
                #define DBG_MQLAPI_NOTRACE_OrderOpenPrice
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrderOpenTime
                #define DBG_MQLAPI_NOTRACE_OrderOpenTime
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrderProfit
                #define DBG_MQLAPI_NOTRACE_OrderProfit
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrdersHistoryTotal
                #define DBG_MQLAPI_NOTRACE_OrdersHistoryTotal
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrderStopLoss
                #define DBG_MQLAPI_NOTRACE_OrderStopLoss
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrderSwap
                #define DBG_MQLAPI_NOTRACE_OrderSwap
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrderSymbol
                #define DBG_MQLAPI_NOTRACE_OrderSymbol
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrderTakeProfit
                #define DBG_MQLAPI_NOTRACE_OrderTakeProfit
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrderTicket
                #define DBG_MQLAPI_NOTRACE_OrderTicket
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrderType
                #define DBG_MQLAPI_NOTRACE_OrderType
            #endif
            #ifndef DBG_MQLAPI_TRACE_RefreshRates
                #define DBG_MQLAPI_NOTRACE_RefreshRates
            #endif
            #ifndef DBG_MQLAPI_TRACE_Seconds
                #define DBG_MQLAPI_NOTRACE_Seconds
            #endif
            #ifndef DBG_MQLAPI_TRACE_StringGetChar
                #define DBG_MQLAPI_NOTRACE_StringGetChar
            #endif
            #ifndef DBG_MQLAPI_TRACE_StringSetChar
                #define DBG_MQLAPI_NOTRACE_StringSetChar
            #endif
            #ifndef DBG_MQLAPI_TRACE_StrToDouble
                #define DBG_MQLAPI_NOTRACE_StrToDouble
            #endif
            #ifndef DBG_MQLAPI_TRACE_StrToInteger
                #define DBG_MQLAPI_NOTRACE_StrToInteger
            #endif
            #ifndef DBG_MQLAPI_TRACE_StrToTime
                #define DBG_MQLAPI_NOTRACE_StrToTime
            #endif
            #ifndef DBG_MQLAPI_TRACE_TerminalCompany
                #define DBG_MQLAPI_NOTRACE_TerminalCompany
            #endif
            #ifndef DBG_MQLAPI_TRACE_TerminalName
                #define DBG_MQLAPI_NOTRACE_TerminalName
            #endif
            #ifndef DBG_MQLAPI_TRACE_TerminalPath
                #define DBG_MQLAPI_NOTRACE_TerminalPath
            #endif
            #ifndef DBG_MQLAPI_TRACE_TimeDay
                #define DBG_MQLAPI_NOTRACE_TimeDay
            #endif
            #ifndef DBG_MQLAPI_TRACE_TimeDayOfWeek
                #define DBG_MQLAPI_NOTRACE_TimeDayOfWeek
            #endif
            #ifndef DBG_MQLAPI_TRACE_TimeDayOfYear
                #define DBG_MQLAPI_NOTRACE_TimeDayOfYear
            #endif
            #ifndef DBG_MQLAPI_TRACE_TimeHour
                #define DBG_MQLAPI_NOTRACE_TimeHour
            #endif
            #ifndef DBG_MQLAPI_TRACE_TimeMinute
                #define DBG_MQLAPI_NOTRACE_TimeMinute
            #endif
            #ifndef DBG_MQLAPI_TRACE_TimeMonth
                #define DBG_MQLAPI_NOTRACE_TimeMonth
            #endif
            #ifndef DBG_MQLAPI_TRACE_TimeSeconds
                #define DBG_MQLAPI_NOTRACE_TimeSeconds
            #endif
            #ifndef DBG_MQLAPI_TRACE_TimeToStr
                #define DBG_MQLAPI_NOTRACE_TimeToStr
            #endif
            #ifndef DBG_MQLAPI_TRACE_TimeYear
                #define DBG_MQLAPI_NOTRACE_TimeYear
            #endif
            #ifndef DBG_MQLAPI_TRACE_WindowBarsPerChart
                #define DBG_MQLAPI_NOTRACE_WindowBarsPerChart
            #endif
            #ifndef DBG_MQLAPI_TRACE_WindowExpertName
                #define DBG_MQLAPI_NOTRACE_WindowExpertName
            #endif
            #ifndef DBG_MQLAPI_TRACE_WindowFind
                #define DBG_MQLAPI_NOTRACE_WindowFind
            #endif
            #ifndef DBG_MQLAPI_TRACE_WindowFirstVisibleBar
                #define DBG_MQLAPI_NOTRACE_WindowFirstVisibleBar
            #endif
            #ifndef DBG_MQLAPI_TRACE_WindowHandle
                #define DBG_MQLAPI_NOTRACE_WindowHandle
            #endif
            #ifndef DBG_MQLAPI_TRACE_WindowIsVisible
                #define DBG_MQLAPI_NOTRACE_WindowIsVisible
            #endif
            #ifndef DBG_MQLAPI_TRACE_WindowOnDropped
                #define DBG_MQLAPI_NOTRACE_WindowOnDropped
            #endif
            #ifndef DBG_MQLAPI_TRACE_WindowPriceMax
                #define DBG_MQLAPI_NOTRACE_WindowPriceMax
            #endif
            #ifndef DBG_MQLAPI_TRACE_WindowPriceMin
                #define DBG_MQLAPI_NOTRACE_WindowPriceMin
            #endif
            #ifndef DBG_MQLAPI_TRACE_WindowPriceOnDropped
                #define DBG_MQLAPI_NOTRACE_WindowPriceOnDropped
            #endif
            #ifndef DBG_MQLAPI_TRACE_WindowScreenShot
                #define DBG_MQLAPI_NOTRACE_WindowScreenShot
            #endif
            #ifndef DBG_MQLAPI_TRACE_WindowsTotal
                #define DBG_MQLAPI_NOTRACE_WindowsTotal
            #endif
            #ifndef DBG_MQLAPI_TRACE_WindowTimeOnDropped
                #define DBG_MQLAPI_NOTRACE_WindowTimeOnDropped
            #endif
            #ifndef DBG_MQLAPI_TRACE_WindowXOnDropped
                #define DBG_MQLAPI_NOTRACE_WindowXOnDropped
            #endif
            #ifndef DBG_MQLAPI_TRACE_WindowYOnDropped
                #define DBG_MQLAPI_NOTRACE_WindowYOnDropped
            #endif
            #ifndef DBG_MQLAPI_TRACE_Year
                #define DBG_MQLAPI_NOTRACE_Year
            #endif

        #endif


        // MQL5 exclusive functions
        #ifndef __MQL4__
            #ifndef DBG_MQLAPI_TRACE_AccountInfoInteger
                #define DBG_MQLAPI_NOTRACE_AccountInfoInteger
            #endif
            #ifndef DBG_MQLAPI_TRACE_ArrayInsert
                #define DBG_MQLAPI_NOTRACE_ArrayInsert
            #endif
            #ifndef DBG_MQLAPI_TRACE_ArrayRemove
                #define DBG_MQLAPI_NOTRACE_ArrayRemove
            #endif
            #ifndef DBG_MQLAPI_TRACE_ArrayReverse
                #define DBG_MQLAPI_NOTRACE_ArrayReverse
            #endif
            #ifndef DBG_MQLAPI_TRACE_ArraySwap
                #define DBG_MQLAPI_NOTRACE_ArraySwap
            #endif
            #ifndef DBG_MQLAPI_TRACE_Bars
                #define DBG_MQLAPI_NOTRACE_Bars
            #endif
            #ifndef DBG_MQLAPI_TRACE_BarsCalculated
                #define DBG_MQLAPI_NOTRACE_BarsCalculated
            #endif
            #ifndef DBG_MQLAPI_TRACE_CalendarCountryById
                #define DBG_MQLAPI_NOTRACE_CalendarCountryById
            #endif
            #ifndef DBG_MQLAPI_TRACE_CalendarEventById
                #define DBG_MQLAPI_NOTRACE_CalendarEventById
            #endif
            #ifndef DBG_MQLAPI_TRACE_CalendarValueById
                #define DBG_MQLAPI_NOTRACE_CalendarValueById
            #endif
            #ifndef DBG_MQLAPI_TRACE_CalendarCountries
                #define DBG_MQLAPI_NOTRACE_CalendarCountries
            #endif
            #ifndef DBG_MQLAPI_TRACE_CalendarEventByCountry
                #define DBG_MQLAPI_NOTRACE_CalendarEventByCountry
            #endif
            #ifndef DBG_MQLAPI_TRACE_CalendarEventByCurrency
                #define DBG_MQLAPI_NOTRACE_CalendarEventByCurrency
            #endif
            #ifndef DBG_MQLAPI_TRACE_CalendarValueHistoryByEvent
                #define DBG_MQLAPI_NOTRACE_CalendarValueHistoryByEvent
            #endif
            #ifndef DBG_MQLAPI_TRACE_CalendarValueHistory
                #define DBG_MQLAPI_NOTRACE_CalendarValueHistory
            #endif
            #ifndef DBG_MQLAPI_TRACE_CalendarValueLastByEvent
                #define DBG_MQLAPI_NOTRACE_CalendarValueLastByEvent
            #endif
            #ifndef DBG_MQLAPI_TRACE_CalendarValueLast
                #define DBG_MQLAPI_NOTRACE_CalendarValueLast
            #endif
            #ifndef DBG_MQLAPI_TRACE_CharArrayToStruct
                #define DBG_MQLAPI_NOTRACE_CharArrayToStruct
            #endif
            #ifndef DBG_MQLAPI_TRACE_ChartIndicatorAdd
                #define DBG_MQLAPI_NOTRACE_ChartIndicatorAdd
            #endif
            #ifndef DBG_MQLAPI_TRACE_ChartIndicatorGet
                #define DBG_MQLAPI_NOTRACE_ChartIndicatorGet
            #endif
            #ifndef DBG_MQLAPI_TRACE_CLBufferCreate
                #define DBG_MQLAPI_NOTRACE_CLBufferCreate
            #endif
            #ifndef DBG_MQLAPI_TRACE_CLBufferRead
                #define DBG_MQLAPI_NOTRACE_CLBufferRead
            #endif
            #ifndef DBG_MQLAPI_TRACE_CLBufferWrite
                #define DBG_MQLAPI_NOTRACE_CLBufferWrite
            #endif
            #ifndef DBG_MQLAPI_TRACE_CLContextCreate
                #define DBG_MQLAPI_NOTRACE_CLContextCreate
            #endif
            #ifndef DBG_MQLAPI_TRACE_CLExecute
                #define DBG_MQLAPI_NOTRACE_CLExecute
            #endif
            #ifndef DBG_MQLAPI_TRACE_CLGetDeviceInfo
                #define DBG_MQLAPI_NOTRACE_CLGetDeviceInfo
            #endif
            #ifndef DBG_MQLAPI_TRACE_CLGetInfoString
                #define DBG_MQLAPI_NOTRACE_CLGetInfoString
            #endif
            #ifndef DBG_MQLAPI_TRACE_CLGetInfoInteger
                #define DBG_MQLAPI_NOTRACE_CLGetInfoInteger
            #endif
            #ifndef DBG_MQLAPI_TRACE_CLHandleType
                #define DBG_MQLAPI_NOTRACE_CLHandleType
            #endif
            #ifndef DBG_MQLAPI_TRACE_CLKernelCreate
                #define DBG_MQLAPI_NOTRACE_CLKernelCreate
            #endif
            #ifndef DBG_MQLAPI_TRACE_CLProgramCreate
                #define DBG_MQLAPI_NOTRACE_CLProgramCreate
            #endif
            #ifndef DBG_MQLAPI_TRACE_CLSetKernelArg
                #define DBG_MQLAPI_NOTRACE_CLSetKernelArg
            #endif
            #ifndef DBG_MQLAPI_TRACE_CLSetKernelArgMem
                #define DBG_MQLAPI_NOTRACE_CLSetKernelArgMem
            #endif
            #ifndef DBG_MQLAPI_TRACE_CLSetKernelArgMemLocal
                #define DBG_MQLAPI_NOTRACE_CLSetKernelArgMemLocal
            #endif
            #ifndef DBG_MQLAPI_TRACE_CopyBuffer
                #define DBG_MQLAPI_NOTRACE_CopyBuffer
            #endif
            #ifndef DBG_MQLAPI_TRACE_CopySeries
                #define DBG_MQLAPI_NOTRACE_CopySeries
            #endif
            #ifndef DBG_MQLAPI_TRACE_CopyTicks
                #define DBG_MQLAPI_NOTRACE_CopyTicks
            #endif
            #ifndef DBG_MQLAPI_TRACE_CopyTicksRange
                #define DBG_MQLAPI_NOTRACE_CopyTicksRange
            #endif
            #ifndef DBG_MQLAPI_TRACE_CustomSymbolCreate
                #define DBG_MQLAPI_NOTRACE_CustomSymbolCreate
            #endif
            #ifndef DBG_MQLAPI_TRACE_CustomSymbolDelete
                #define DBG_MQLAPI_NOTRACE_CustomSymbolDelete
            #endif
            #ifndef DBG_MQLAPI_TRACE_CustomSymbolSetInteger
                #define DBG_MQLAPI_NOTRACE_CustomSymbolSetInteger
            #endif
            #ifndef DBG_MQLAPI_TRACE_CustomSymbolSetDouble
                #define DBG_MQLAPI_NOTRACE_CustomSymbolSetDouble
            #endif
            #ifndef DBG_MQLAPI_TRACE_CustomSymbolSetString
                #define DBG_MQLAPI_NOTRACE_CustomSymbolSetString
            #endif
            #ifndef DBG_MQLAPI_TRACE_CustomSymbolSetMarginRate
                #define DBG_MQLAPI_NOTRACE_CustomSymbolSetMarginRate
            #endif
            #ifndef DBG_MQLAPI_TRACE_CustomSymbolSetSessionQuote
                #define DBG_MQLAPI_NOTRACE_CustomSymbolSetSessionQuote
            #endif
            #ifndef DBG_MQLAPI_TRACE_CustomSymbolSetSessionTrade
                #define DBG_MQLAPI_NOTRACE_CustomSymbolSetSessionTrade
            #endif
            #ifndef DBG_MQLAPI_TRACE_CustomRatesDelete
                #define DBG_MQLAPI_NOTRACE_CustomRatesDelete
            #endif
            #ifndef DBG_MQLAPI_TRACE_CustomRatesReplace
                #define DBG_MQLAPI_NOTRACE_CustomRatesReplace
            #endif
            #ifndef DBG_MQLAPI_TRACE_CustomRatesUpdate
                #define DBG_MQLAPI_NOTRACE_CustomRatesUpdate
            #endif
            #ifndef DBG_MQLAPI_TRACE_CustomTicksAdd
                #define DBG_MQLAPI_NOTRACE_CustomTicksAdd
            #endif
            #ifndef DBG_MQLAPI_TRACE_CustomTicksDelete
                #define DBG_MQLAPI_NOTRACE_CustomTicksDelete
            #endif
            #ifndef DBG_MQLAPI_TRACE_CustomTicksReplace
                #define DBG_MQLAPI_NOTRACE_CustomTicksReplace
            #endif
            #ifndef DBG_MQLAPI_TRACE_CustomBookAdd
                #define DBG_MQLAPI_NOTRACE_CustomBookAdd
            #endif
            #ifndef DBG_MQLAPI_TRACE_DatabaseOpen
                #define DBG_MQLAPI_NOTRACE_DatabaseOpen
            #endif
            #ifndef DBG_MQLAPI_TRACE_DatabaseImport
                #define DBG_MQLAPI_NOTRACE_DatabaseImport
            #endif
            #ifndef DBG_MQLAPI_TRACE_DatabaseExport
                #define DBG_MQLAPI_NOTRACE_DatabaseExport
            #endif
            #ifndef DBG_MQLAPI_TRACE_DatabasePrint
                #define DBG_MQLAPI_NOTRACE_DatabasePrint
            #endif
            #ifndef DBG_MQLAPI_TRACE_DatabaseTableExists
                #define DBG_MQLAPI_NOTRACE_DatabaseTableExists
            #endif
            #ifndef DBG_MQLAPI_TRACE_DatabaseExecute
                #define DBG_MQLAPI_NOTRACE_DatabaseExecute
            #endif
            #ifndef DBG_MQLAPI_TRACE_DatabasePrepare
                #define DBG_MQLAPI_NOTRACE_DatabasePrepare
            #endif
            #ifndef DBG_MQLAPI_TRACE_DatabaseReset
                #define DBG_MQLAPI_NOTRACE_DatabaseReset
            #endif
            #ifndef DBG_MQLAPI_TRACE_DatabaseBind
                #define DBG_MQLAPI_NOTRACE_DatabaseBind
            #endif
            #ifndef DBG_MQLAPI_TRACE_DatabaseBindArray
                #define DBG_MQLAPI_NOTRACE_DatabaseBindArray
            #endif
            #ifndef DBG_MQLAPI_TRACE_DatabaseRead
                #define DBG_MQLAPI_NOTRACE_DatabaseRead
            #endif
            #ifndef DBG_MQLAPI_TRACE_DatabaseReadBind
                #define DBG_MQLAPI_NOTRACE_DatabaseReadBind
            #endif
            #ifndef DBG_MQLAPI_TRACE_DatabaseTransactionBegin
                #define DBG_MQLAPI_NOTRACE_DatabaseTransactionBegin
            #endif
            #ifndef DBG_MQLAPI_TRACE_DatabaseTransactionCommit
                #define DBG_MQLAPI_NOTRACE_DatabaseTransactionCommit
            #endif
            #ifndef DBG_MQLAPI_TRACE_DatabaseTransactionRollback
                #define DBG_MQLAPI_NOTRACE_DatabaseTransactionRollback
            #endif
            #ifndef DBG_MQLAPI_TRACE_DatabaseColumnsCount
                #define DBG_MQLAPI_NOTRACE_DatabaseColumnsCount
            #endif
            #ifndef DBG_MQLAPI_TRACE_DatabaseColumnName
                #define DBG_MQLAPI_NOTRACE_DatabaseColumnName
            #endif
            #ifndef DBG_MQLAPI_TRACE_DatabaseColumnType
                #define DBG_MQLAPI_NOTRACE_DatabaseColumnType
            #endif
            #ifndef DBG_MQLAPI_TRACE_DatabaseColumnSize
                #define DBG_MQLAPI_NOTRACE_DatabaseColumnSize
            #endif
            #ifndef DBG_MQLAPI_TRACE_DatabaseColumnText
                #define DBG_MQLAPI_NOTRACE_DatabaseColumnText
            #endif
            #ifndef DBG_MQLAPI_TRACE_DatabaseColumnInteger
                #define DBG_MQLAPI_NOTRACE_DatabaseColumnInteger
            #endif
            #ifndef DBG_MQLAPI_TRACE_DatabaseColumnLong
                #define DBG_MQLAPI_NOTRACE_DatabaseColumnLong
            #endif
            #ifndef DBG_MQLAPI_TRACE_DatabaseColumnDouble
                #define DBG_MQLAPI_NOTRACE_DatabaseColumnDouble
            #endif
            #ifndef DBG_MQLAPI_TRACE_DatabaseColumnBlob
                #define DBG_MQLAPI_NOTRACE_DatabaseColumnBlob
            #endif
            #ifndef DBG_MQLAPI_TRACE_Digits
                #define DBG_MQLAPI_NOTRACE_Digits
            #endif
            #ifndef DBG_MQLAPI_TRACE_DXContextCreate
                #define DBG_MQLAPI_NOTRACE_DXContextCreate
            #endif
            #ifndef DBG_MQLAPI_TRACE_DXContextSetSize
                #define DBG_MQLAPI_NOTRACE_DXContextSetSize
            #endif
            #ifndef DBG_MQLAPI_TRACE_DXContextGetSize
                #define DBG_MQLAPI_NOTRACE_DXContextGetSize
            #endif
            #ifndef DBG_MQLAPI_TRACE_DXContextClearColors
                #define DBG_MQLAPI_NOTRACE_DXContextClearColors
            #endif
            #ifndef DBG_MQLAPI_TRACE_DXContextClearDepth
                #define DBG_MQLAPI_NOTRACE_DXContextClearDepth
            #endif
            #ifndef DBG_MQLAPI_TRACE_DXContextGetColors
                #define DBG_MQLAPI_NOTRACE_DXContextGetColors
            #endif
            #ifndef DBG_MQLAPI_TRACE_DXContextGetDepth
                #define DBG_MQLAPI_NOTRACE_DXContextGetDepth
            #endif
            #ifndef DBG_MQLAPI_TRACE_DXBufferCreate
                #define DBG_MQLAPI_NOTRACE_DXBufferCreate
            #endif
            #ifndef DBG_MQLAPI_TRACE_DXTextureCreate
                #define DBG_MQLAPI_NOTRACE_DXTextureCreate
            #endif
            #ifndef DBG_MQLAPI_TRACE_DXInputCreate
                #define DBG_MQLAPI_NOTRACE_DXInputCreate
            #endif
            #ifndef DBG_MQLAPI_TRACE_DXInputSet
                #define DBG_MQLAPI_NOTRACE_DXInputSet
            #endif
            #ifndef DBG_MQLAPI_TRACE_DXShaderCreate
                #define DBG_MQLAPI_NOTRACE_DXShaderCreate
            #endif
            #ifndef DBG_MQLAPI_TRACE_DXShaderSetLayout
                #define DBG_MQLAPI_NOTRACE_DXShaderSetLayout
            #endif
            #ifndef DBG_MQLAPI_TRACE_DXShaderInputsSet
                #define DBG_MQLAPI_NOTRACE_DXShaderInputsSet
            #endif
            #ifndef DBG_MQLAPI_TRACE_DXShaderTexturesSet
                #define DBG_MQLAPI_NOTRACE_DXShaderTexturesSet
            #endif
            #ifndef DBG_MQLAPI_TRACE_DXDraw
                #define DBG_MQLAPI_NOTRACE_DXDraw
            #endif
            #ifndef DBG_MQLAPI_TRACE_DXDrawIndexed
                #define DBG_MQLAPI_NOTRACE_DXDrawIndexed
            #endif
            #ifndef DBG_MQLAPI_TRACE_DXPrimiveTopologySet
                #define DBG_MQLAPI_NOTRACE_DXPrimiveTopologySet
            #endif
            #ifndef DBG_MQLAPI_TRACE_DXBufferSet
                #define DBG_MQLAPI_NOTRACE_DXBufferSet
            #endif
            #ifndef DBG_MQLAPI_TRACE_DXShaderSet
                #define DBG_MQLAPI_NOTRACE_DXShaderSet
            #endif
            #ifndef DBG_MQLAPI_TRACE_DXHandleType
                #define DBG_MQLAPI_NOTRACE_DXHandleType
            #endif
            #ifndef DBG_MQLAPI_TRACE_DXRelease
                #define DBG_MQLAPI_NOTRACE_DXRelease
            #endif
            #ifndef DBG_MQLAPI_TRACE_FrameAdd
                #define DBG_MQLAPI_NOTRACE_FrameAdd
            #endif
            #ifndef DBG_MQLAPI_TRACE_FrameFilter
                #define DBG_MQLAPI_NOTRACE_FrameFilter
            #endif
            #ifndef DBG_MQLAPI_TRACE_FrameFirst
                #define DBG_MQLAPI_NOTRACE_FrameFirst
            #endif
            #ifndef DBG_MQLAPI_TRACE_FrameInputs
                #define DBG_MQLAPI_NOTRACE_FrameInputs
            #endif
            #ifndef DBG_MQLAPI_TRACE_FrameNext
                #define DBG_MQLAPI_NOTRACE_FrameNext
            #endif
            #ifndef DBG_MQLAPI_TRACE_GetTickCount64
                #define DBG_MQLAPI_NOTRACE_GetTickCount64
            #endif
            #ifndef DBG_MQLAPI_TRACE_HistoryDealGetDouble
                #define DBG_MQLAPI_NOTRACE_HistoryDealGetDouble
            #endif
            #ifndef DBG_MQLAPI_TRACE_HistoryDealGetInteger
                #define DBG_MQLAPI_NOTRACE_HistoryDealGetInteger
            #endif
            #ifndef DBG_MQLAPI_TRACE_HistoryDealGetString
                #define DBG_MQLAPI_NOTRACE_HistoryDealGetString
            #endif
            #ifndef DBG_MQLAPI_TRACE_HistoryDealGetTicket
                #define DBG_MQLAPI_NOTRACE_HistoryDealGetTicket
            #endif
            #ifndef DBG_MQLAPI_TRACE_HistoryDealSelect
                #define DBG_MQLAPI_NOTRACE_HistoryDealSelect
            #endif
            #ifndef DBG_MQLAPI_TRACE_HistoryDealsTotal
                #define DBG_MQLAPI_NOTRACE_HistoryDealsTotal
            #endif
            #ifndef DBG_MQLAPI_TRACE_HistoryOrderGetDouble
                #define DBG_MQLAPI_NOTRACE_HistoryOrderGetDouble
            #endif
            #ifndef DBG_MQLAPI_TRACE_HistoryOrderGetInteger
                #define DBG_MQLAPI_NOTRACE_HistoryOrderGetInteger
            #endif
            #ifndef DBG_MQLAPI_TRACE_HistoryOrderGetString
                #define DBG_MQLAPI_NOTRACE_HistoryOrderGetString
            #endif
            #ifndef DBG_MQLAPI_TRACE_HistoryOrderGetTicket
                #define DBG_MQLAPI_NOTRACE_HistoryOrderGetTicket
            #endif
            #ifndef DBG_MQLAPI_TRACE_HistoryOrderSelect
                #define DBG_MQLAPI_NOTRACE_HistoryOrderSelect
            #endif
            #ifndef DBG_MQLAPI_TRACE_HistoryOrdersTotal
                #define DBG_MQLAPI_NOTRACE_HistoryOrdersTotal
            #endif
            #ifndef DBG_MQLAPI_TRACE_HistorySelect
                #define DBG_MQLAPI_NOTRACE_HistorySelect
            #endif
            #ifndef DBG_MQLAPI_TRACE_HistorySelectByPosition
                #define DBG_MQLAPI_NOTRACE_HistorySelectByPosition
            #endif
            #ifndef DBG_MQLAPI_TRACE_iTickVolume
                #define DBG_MQLAPI_NOTRACE_iTickVolume
            #endif
            #ifndef DBG_MQLAPI_TRACE_iRealVolume
                #define DBG_MQLAPI_NOTRACE_iRealVolume
            #endif
            #ifndef DBG_MQLAPI_TRACE_iSpread
                #define DBG_MQLAPI_NOTRACE_iSpread
            #endif
            #ifndef DBG_MQLAPI_TRACE_iADXWilder
                #define DBG_MQLAPI_NOTRACE_iADXWilder
            #endif
            #ifndef DBG_MQLAPI_TRACE_iAMA
                #define DBG_MQLAPI_NOTRACE_iAMA
            #endif
            #ifndef DBG_MQLAPI_TRACE_iChaikin
                #define DBG_MQLAPI_NOTRACE_iChaikin
            #endif
            #ifndef DBG_MQLAPI_TRACE_iDEMA
                #define DBG_MQLAPI_NOTRACE_iDEMA
            #endif
            #ifndef DBG_MQLAPI_TRACE_iFrAMA
                #define DBG_MQLAPI_NOTRACE_iFrAMA
            #endif
            #ifndef DBG_MQLAPI_TRACE_IndicatorCreate
                #define DBG_MQLAPI_NOTRACE_IndicatorCreate
            #endif
            #ifndef DBG_MQLAPI_TRACE_IndicatorParameters
                #define DBG_MQLAPI_NOTRACE_IndicatorParameters
            #endif
            #ifndef DBG_MQLAPI_TRACE_IndicatorRelease
                #define DBG_MQLAPI_NOTRACE_IndicatorRelease
            #endif
            #ifndef DBG_MQLAPI_TRACE_iTEMA
                #define DBG_MQLAPI_NOTRACE_iTEMA
            #endif
            #ifndef DBG_MQLAPI_TRACE_iTriX
                #define DBG_MQLAPI_NOTRACE_iTriX
            #endif
            #ifndef DBG_MQLAPI_TRACE_iVIDyA
                #define DBG_MQLAPI_NOTRACE_iVIDyA
            #endif
            #ifndef DBG_MQLAPI_TRACE_iVolumes
                #define DBG_MQLAPI_NOTRACE_iVolumes
            #endif
            #ifndef DBG_MQLAPI_TRACE_MarketBookAdd
                #define DBG_MQLAPI_NOTRACE_MarketBookAdd
            #endif
            #ifndef DBG_MQLAPI_TRACE_MarketBookGet
                #define DBG_MQLAPI_NOTRACE_MarketBookGet
            #endif
            #ifndef DBG_MQLAPI_TRACE_MarketBookRelease
                #define DBG_MQLAPI_NOTRACE_MarketBookRelease
            #endif
            #ifndef DBG_MQLAPI_TRACE_MQLInfoInteger
                #define DBG_MQLAPI_NOTRACE_MQLInfoInteger
            #endif
            #ifndef DBG_MQLAPI_TRACE_OnnxCreate
                #define DBG_MQLAPI_NOTRACE_OnnxCreate
            #endif
            #ifndef DBG_MQLAPI_TRACE_OnnxCreateFromBuffer
                #define DBG_MQLAPI_NOTRACE_OnnxCreateFromBuffer
            #endif
            #ifndef DBG_MQLAPI_TRACE_OnnxRelease
                #define DBG_MQLAPI_NOTRACE_OnnxRelease
            #endif
            #ifndef DBG_MQLAPI_TRACE_OnnxRun
                #define DBG_MQLAPI_NOTRACE_OnnxRun
            #endif
            #ifndef DBG_MQLAPI_TRACE_OnnxGetInputCount
                #define DBG_MQLAPI_NOTRACE_OnnxGetInputCount
            #endif
            #ifndef DBG_MQLAPI_TRACE_OnnxGetOutputCount
                #define DBG_MQLAPI_NOTRACE_OnnxGetOutputCount
            #endif
            #ifndef DBG_MQLAPI_TRACE_OnnxGetInputName
                #define DBG_MQLAPI_NOTRACE_OnnxGetInputName
            #endif
            #ifndef DBG_MQLAPI_TRACE_OnnxGetOutputName
                #define DBG_MQLAPI_NOTRACE_OnnxGetOutputName
            #endif
            #ifndef DBG_MQLAPI_TRACE_OnnxGetInputTypeInfo
                #define DBG_MQLAPI_NOTRACE_OnnxGetInputTypeInfo
            #endif
            #ifndef DBG_MQLAPI_TRACE_OnnxGetOutputTypeInfo
                #define DBG_MQLAPI_NOTRACE_OnnxGetOutputTypeInfo
            #endif
            #ifndef DBG_MQLAPI_TRACE_OnnxSetInputShape
                #define DBG_MQLAPI_NOTRACE_OnnxSetInputShape
            #endif
            #ifndef DBG_MQLAPI_TRACE_OnnxSetOutputShape
                #define DBG_MQLAPI_NOTRACE_OnnxSetOutputShape
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrderCalcMargin
                #define DBG_MQLAPI_NOTRACE_OrderCalcMargin
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrderCalcProfit
                #define DBG_MQLAPI_NOTRACE_OrderCalcProfit
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrderCheck
                #define DBG_MQLAPI_NOTRACE_OrderCheck
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrderGetInteger
                #define DBG_MQLAPI_NOTRACE_OrderGetInteger
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrderGetString
                #define DBG_MQLAPI_NOTRACE_OrderGetString
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrderGetTicket
                #define DBG_MQLAPI_NOTRACE_OrderGetTicket
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrderSendAsync
                #define DBG_MQLAPI_NOTRACE_OrderSendAsync
            #endif
            #ifndef DBG_MQLAPI_TRACE_OrdersTotal
                #define DBG_MQLAPI_NOTRACE_OrdersTotal
            #endif
            #ifndef DBG_MQLAPI_TRACE_ParameterGetRange
                #define DBG_MQLAPI_NOTRACE_ParameterGetRange
            #endif
            #ifndef DBG_MQLAPI_TRACE_ParameterSetRange
                #define DBG_MQLAPI_NOTRACE_ParameterSetRange
            #endif
            #ifndef DBG_MQLAPI_TRACE_PositionGetDouble
                #define DBG_MQLAPI_NOTRACE_PositionGetDouble
            #endif
            #ifndef DBG_MQLAPI_TRACE_PositionGetInteger
                #define DBG_MQLAPI_NOTRACE_PositionGetInteger
            #endif
            #ifndef DBG_MQLAPI_TRACE_PositionGetString
                #define DBG_MQLAPI_NOTRACE_PositionGetString
            #endif
            #ifndef DBG_MQLAPI_TRACE_PositionGetSymbol
                #define DBG_MQLAPI_NOTRACE_PositionGetSymbol
            #endif
            #ifndef DBG_MQLAPI_TRACE_PositionGetTicket
                #define DBG_MQLAPI_NOTRACE_PositionGetTicket
            #endif
            #ifndef DBG_MQLAPI_TRACE_PositionSelect
                #define DBG_MQLAPI_NOTRACE_PositionSelect
            #endif
            #ifndef DBG_MQLAPI_TRACE_PositionSelectByTicket
                #define DBG_MQLAPI_NOTRACE_PositionSelectByTicket
            #endif
            #ifndef DBG_MQLAPI_TRACE_PositionsTotal
                #define DBG_MQLAPI_NOTRACE_PositionsTotal
            #endif
            #ifndef DBG_MQLAPI_TRACE_SocketCreate
                #define DBG_MQLAPI_NOTRACE_SocketCreate
            #endif
            #ifndef DBG_MQLAPI_TRACE_SocketClose
                #define DBG_MQLAPI_NOTRACE_SocketClose
            #endif
            #ifndef DBG_MQLAPI_TRACE_SocketConnect
                #define DBG_MQLAPI_NOTRACE_SocketConnect
            #endif
            #ifndef DBG_MQLAPI_TRACE_SocketIsConnected
                #define DBG_MQLAPI_NOTRACE_SocketIsConnected
            #endif
            #ifndef DBG_MQLAPI_TRACE_SocketIsReadable
                #define DBG_MQLAPI_NOTRACE_SocketIsReadable
            #endif
            #ifndef DBG_MQLAPI_TRACE_SocketIsWritable
                #define DBG_MQLAPI_NOTRACE_SocketIsWritable
            #endif
            #ifndef DBG_MQLAPI_TRACE_SocketTimeouts
                #define DBG_MQLAPI_NOTRACE_SocketTimeouts
            #endif
            #ifndef DBG_MQLAPI_TRACE_SocketRead
                #define DBG_MQLAPI_NOTRACE_SocketRead
            #endif
            #ifndef DBG_MQLAPI_TRACE_SocketSend
                #define DBG_MQLAPI_NOTRACE_SocketSend
            #endif
            #ifndef DBG_MQLAPI_TRACE_SocketTlsHandshake
                #define DBG_MQLAPI_NOTRACE_SocketTlsHandshake
            #endif
            #ifndef DBG_MQLAPI_TRACE_SocketTlsCertificate
                #define DBG_MQLAPI_NOTRACE_SocketTlsCertificate
            #endif
            #ifndef DBG_MQLAPI_TRACE_SocketTlsRead
                #define DBG_MQLAPI_NOTRACE_SocketTlsRead
            #endif
            #ifndef DBG_MQLAPI_TRACE_SocketTlsReadAvailable
                #define DBG_MQLAPI_NOTRACE_SocketTlsReadAvailable
            #endif
            #ifndef DBG_MQLAPI_TRACE_SocketTlsSend
                #define DBG_MQLAPI_NOTRACE_SocketTlsSend
            #endif
            #ifndef DBG_MQLAPI_TRACE_SymbolInfoMarginRate
                #define DBG_MQLAPI_NOTRACE_SymbolInfoMarginRate
            #endif
            #ifndef DBG_MQLAPI_TRACE_TerminalInfoInteger
                #define DBG_MQLAPI_NOTRACE_TerminalInfoInteger
            #endif
            #ifndef DBG_MQLAPI_TRACE_TesterDeposit
                #define DBG_MQLAPI_NOTRACE_TesterDeposit
            #endif
            #ifndef DBG_MQLAPI_TRACE_TesterWithdrawal
                #define DBG_MQLAPI_NOTRACE_TesterWithdrawal
            #endif
            #ifndef DBG_MQLAPI_TRACE_TimeTradeServer
                #define DBG_MQLAPI_NOTRACE_TimeTradeServer
            #endif

        #endif

#endif
//
/////////////////////////////////////////////////////////////////////////////////////////////////////




/////////////////////////////////////////////////////////////////////////////////////////////////////
//
// MT4/5 API function call tracing rewrite macros
//
#ifndef LIB_MQLAPI_CALL_TRACING_DISABLE

    // VOID-Functions

        // MQL4 and MQL5 shared functions
        #ifndef Alert
                #ifndef DBG_MQLAPI_NOTRACE_Alert
                    #define Alert                                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_unify_input,                                   DBG_MQL_API_TRACING_FUNCTION_ID_ALERT)
            #endif
        #endif
        #ifndef Comment
                #ifndef DBG_MQLAPI_NOTRACE_Comment
                    #define Comment                                                                                         DBG_MSG_MQLFUNC(dbg_mqlapi_trace_unify_input,                                   DBG_MQL_API_TRACING_FUNCTION_ID_COMMENT)
            #endif
        #endif
        #ifndef Print
                #ifndef DBG_MQLAPI_NOTRACE_Print
                    #define Print                                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_unify_input,                                   DBG_MQL_API_TRACING_FUNCTION_ID_PRINT)
            #endif
        #endif
        #ifndef printf
                #ifndef DBG_MQLAPI_NOTRACE_printf
                    #define printf                                                                                          DBG_MSG_MQLFUNC(dbg_mqlapi_trace_unify_input_format,                            DBG_MQL_API_TRACING_FUNCTION_ID_PRINTF)
            #endif
        #endif
        #ifndef PrintFormat
                #ifndef DBG_MQLAPI_NOTRACE_PrintFormat
                    #define PrintFormat                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_unify_input_format,                            DBG_MQL_API_TRACING_FUNCTION_ID_PRINTFORMAT)
            #endif
        #endif
        #ifndef ArrayFill
                #ifndef DBG_MQLAPI_NOTRACE_ArrayFill
                    #define ArrayFill                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ArrayFill,                                0)
            #endif
        #endif
        #ifndef ArrayFree
                #ifndef DBG_MQLAPI_NOTRACE_ArrayFree
                    #define ArrayFree                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ArrayFree,                                0)
            #endif
        #endif
        #ifndef ZeroMemory
                #ifndef DBG_MQLAPI_NOTRACE_ZeroMemory
                    #define ZeroMemory                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ZeroMemory,                               0)
            #endif
        #endif
        #ifndef ChartRedraw
                #ifndef DBG_MQLAPI_NOTRACE_ChartRedraw
                    #define ChartRedraw                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartRedraw,                              0)
            #endif
        #endif
        #ifndef DebugBreak
                #ifndef DBG_MQLAPI_NOTRACE_DebugBreak
                    #define DebugBreak                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DebugBreak,                               0)
            #endif
        #endif
        #ifndef EventKillTimer
                #ifndef DBG_MQLAPI_NOTRACE_EventKillTimer
                    #define EventKillTimer                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_EventKillTimer,                           0)
            #endif
        #endif
        #ifndef ExpertRemove
                #ifndef DBG_MQLAPI_NOTRACE_ExpertRemove
                    #define ExpertRemove                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ExpertRemove,                             0)
            #endif
        #endif
        #ifndef FileClose
                #ifndef DBG_MQLAPI_NOTRACE_FileClose
                    #define FileClose                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileClose,                                0)
            #endif
        #endif
        #ifndef FileFindClose
                #ifndef DBG_MQLAPI_NOTRACE_FileFindClose
                    #define FileFindClose                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileFindClose,                            0)
            #endif
        #endif
        #ifndef FileFlush
                #ifndef DBG_MQLAPI_NOTRACE_FileFlush
                    #define FileFlush                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileFlush,                                0)
            #endif
        #endif
        #ifndef GlobalVariablesFlush
                #ifndef DBG_MQLAPI_NOTRACE_GlobalVariablesFlush
                    #define GlobalVariablesFlush                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_GlobalVariablesFlush,                     0)
            #endif
        #endif
        #ifndef MathSrand
                #ifndef DBG_MQLAPI_NOTRACE_MathSrand
                    #define MathSrand                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathSrand,                                0)
            #endif
        #endif
        #ifndef ResetLastError
                #ifndef DBG_MQLAPI_NOTRACE_ResetLastError
                    #define ResetLastError                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ResetLastError,                           0)
            #endif
        #endif
        #ifndef SetReturnError
                #ifndef DBG_MQLAPI_NOTRACE_SetReturnError
                    #define SetReturnError                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SetReturnError,                           0)
            #endif
        #endif
        #ifndef SetUserError
                #ifndef DBG_MQLAPI_NOTRACE_SetUserError
                    #define SetUserError                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SetUserError,                             0)
            #endif
        #endif
        #ifndef Sleep
                #ifndef DBG_MQLAPI_NOTRACE_Sleep
                    #define Sleep                                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_Sleep,                                    0)
            #endif
        #endif
        #ifndef srand
                #ifndef DBG_MQLAPI_NOTRACE_srand
                    #define srand                                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_srand,                                    DBG_MQL_API_TRACING_FUNCTION_ID_SRAND)
            #endif
        #endif

        // MQL4 exclusive functions
        #ifdef __MQL4__
            #ifndef HideTestIndicators
                #ifndef DBG_MQLAPI_NOTRACE_HideTestIndicators
                    #define HideTestIndicators                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_HideTestIndicators,                       0)
                #endif
            #endif
            #ifndef IndicatorDigits
                #ifndef DBG_MQLAPI_NOTRACE_IndicatorDigits
                    #define IndicatorDigits                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_IndicatorDigits,                          0)
                #endif
            #endif
            #ifndef IndicatorShortName
                #ifndef DBG_MQLAPI_NOTRACE_IndicatorShortName
                    #define IndicatorShortName                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_IndicatorShortName,                       0)
                #endif
            #endif
            #ifndef MQLSetInteger
                #ifndef DBG_MQLAPI_NOTRACE_MQLSetInteger
                    #define MQLSetInteger                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MQLSetInteger,                            0)
                #endif
            #endif
            #ifndef OrderPrint
                #ifndef DBG_MQLAPI_NOTRACE_OrderPrint
                    #define OrderPrint                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderPrint,                               0)
                #endif
            #endif
            #ifndef SetIndexArrow
                #ifndef DBG_MQLAPI_NOTRACE_SetIndexArrow
                    #define SetIndexArrow                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SetIndexArrow,                            0)
                #endif
            #endif
            #ifndef SetIndexDrawBegin
                #ifndef DBG_MQLAPI_NOTRACE_SetIndexDrawBegin
                    #define SetIndexDrawBegin                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SetIndexDrawBegin,                        0)
                #endif
            #endif
            #ifndef SetIndexEmptyValue
                #ifndef DBG_MQLAPI_NOTRACE_SetIndexEmptyValue
                    #define SetIndexEmptyValue                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SetIndexEmptyValue,                       0)
                #endif
            #endif
            #ifndef SetIndexLabel
                #ifndef DBG_MQLAPI_NOTRACE_SetIndexLabel
                    #define SetIndexLabel                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SetIndexLabel,                            0)
                #endif
            #endif
            #ifndef SetIndexShift
                #ifndef DBG_MQLAPI_NOTRACE_SetIndexShift
                    #define SetIndexShift                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SetIndexShift,                            0)
                #endif
            #endif
            #ifndef SetIndexStyle
                #ifndef DBG_MQLAPI_NOTRACE_SetIndexStyle
                    #define SetIndexStyle                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SetIndexStyle,                            0)
                #endif
            #endif
            #ifndef SetLevelStyle
                #ifndef DBG_MQLAPI_NOTRACE_SetLevelStyle
                    #define SetLevelStyle                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SetLevelStyle,                            0)
                #endif
            #endif
            #ifndef SetLevelValue
                #ifndef DBG_MQLAPI_NOTRACE_SetLevelValue
                    #define SetLevelValue                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SetLevelValue,                            0)
                #endif
            #endif
            #ifndef WindowRedraw
                #ifndef DBG_MQLAPI_NOTRACE_WindowRedraw
                    #define WindowRedraw                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_WindowRedraw,                             0)
                #endif
            #endif

        #endif

        // MQL5 exclusive functions
        #ifndef __MQL4__
            #ifndef ArrayPrint
                #ifndef DBG_MQLAPI_NOTRACE_ArrayPrint
                    #define ArrayPrint                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ArrayPrint,                               0)
                #endif
            #endif
            #ifndef CLBufferFree
                #ifndef DBG_MQLAPI_NOTRACE_CLBufferFree
                    #define CLBufferFree                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CLBufferFree,                             0)
                #endif
            #endif
            #ifndef CLContextFree
                #ifndef DBG_MQLAPI_NOTRACE_CLContextFree
                    #define CLContextFree                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CLContextFree,                            0)
                #endif
            #endif
            #ifndef CLKernelFree
                #ifndef DBG_MQLAPI_NOTRACE_CLKernelFree
                    #define CLKernelFree                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CLKernelFree,                             0)
                #endif
            #endif
            #ifndef CLProgramFree
                #ifndef DBG_MQLAPI_NOTRACE_CLProgramFree
                    #define CLProgramFree                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CLProgramFree,                            0)
                #endif
            #endif
            #ifndef DatabaseClose
                #ifndef DBG_MQLAPI_NOTRACE_DatabaseClose
                    #define DatabaseClose                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DatabaseClose,                            0)
                #endif
            #endif
            #ifndef DatabaseFinalize
                #ifndef DBG_MQLAPI_NOTRACE_DatabaseFinalize
                    #define DatabaseFinalize                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DatabaseFinalize,                         0)
                #endif
            #endif
            #ifndef TesterHideIndicators
                #ifndef DBG_MQLAPI_NOTRACE_TesterHideIndicators
                    #define TesterHideIndicators                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TesterHideIndicators,                     0)
                #endif
            #endif
            #ifndef TesterStop
                #ifndef DBG_MQLAPI_NOTRACE_TesterStop
                    #define TesterStop                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TesterStop,                               0)
                #endif
            #endif

        #endif


    // RETURN-Functions

        // MQL4 and MQL5 shared functions
        #ifndef AccountInfoDouble
                #ifndef DBG_MQLAPI_NOTRACE_AccountInfoDouble
                    #define AccountInfoDouble                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_AccountInfoDouble,                        0)
            #endif
        #endif
        #ifndef AccountInfoString
                #ifndef DBG_MQLAPI_NOTRACE_AccountInfoString
                    #define AccountInfoString                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_AccountInfoString,                        0)
            #endif
        #endif
        #ifndef acos
                #ifndef DBG_MQLAPI_NOTRACE_acos
                    #define acos                                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathArccos,                               DBG_MQL_API_TRACING_FUNCTION_ID_ACOS)
            #endif
        #endif
        #ifndef ArrayBsearch
                #ifndef DBG_MQLAPI_NOTRACE_ArrayBsearch
                    #define ArrayBsearch                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ArrayBsearch,                             0)
            #endif
        #endif
        #ifndef ArrayCompare
                #ifndef DBG_MQLAPI_NOTRACE_ArrayCompare
                    #define ArrayCompare                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ArrayCompare,                             0)
            #endif
        #endif
        #ifndef ArrayCopy
                #ifndef DBG_MQLAPI_NOTRACE_ArrayCopy
                    #define ArrayCopy                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ArrayCopy,                                0)
            #endif
        #endif
        #ifndef ArrayGetAsSeries
                #ifndef DBG_MQLAPI_NOTRACE_ArrayGetAsSeries
                    #define ArrayGetAsSeries                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ArrayGetAsSeries,                         0)
            #endif
        #endif
        #ifndef ArrayInitialize
                #ifndef DBG_MQLAPI_NOTRACE_ArrayInitialize
                    #define ArrayInitialize                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ArrayInitialize,                          0)
            #endif
        #endif
        #ifndef ArrayIsDynamic
                #ifndef DBG_MQLAPI_NOTRACE_ArrayIsDynamic
                    #define ArrayIsDynamic                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ArrayIsDynamic,                           0)
            #endif
        #endif
        #ifndef ArrayIsSeries
                #ifndef DBG_MQLAPI_NOTRACE_ArrayIsSeries
                    #define ArrayIsSeries                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ArrayIsSeries,                            0)
            #endif
        #endif
        #ifndef ArrayMaximum
                #ifndef DBG_MQLAPI_NOTRACE_ArrayMaximum
                    #define ArrayMaximum                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ArrayMaximum,                             0)
            #endif
        #endif
        #ifndef ArrayMinimum
                #ifndef DBG_MQLAPI_NOTRACE_ArrayMinimum
                    #define ArrayMinimum                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ArrayMinimum,                             0)
            #endif
        #endif
        #ifndef ArrayRange
                #ifndef DBG_MQLAPI_NOTRACE_ArrayRange
                    #define ArrayRange                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ArrayRange,                               0)
            #endif
        #endif
        #ifndef ArrayResize
                #ifndef DBG_MQLAPI_NOTRACE_ArrayResize
                    #define ArrayResize                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ArrayResize,                              0)
            #endif
        #endif
        #ifndef ArraySetAsSeries
                #ifndef DBG_MQLAPI_NOTRACE_ArraySetAsSeries
                    #define ArraySetAsSeries                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ArraySetAsSeries,                         0)
            #endif
        #endif
        #ifndef ArraySize
                #ifndef DBG_MQLAPI_NOTRACE_ArraySize
                    #define ArraySize                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ArraySize,                                0)
            #endif
        #endif
        #ifndef ArraySort
                #ifndef DBG_MQLAPI_NOTRACE_ArraySort
                    #define ArraySort                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ArraySort,                                0)
            #endif
        #endif
        #ifndef asin
                #ifndef DBG_MQLAPI_NOTRACE_asin
                    #define asin                                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathArcsin,                               DBG_MQL_API_TRACING_FUNCTION_ID_ASIN)
            #endif
        #endif
        #ifndef atan
                #ifndef DBG_MQLAPI_NOTRACE_atan
                    #define atan                                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathArctan,                               DBG_MQL_API_TRACING_FUNCTION_ID_ATAN)
            #endif
        #endif
        #ifndef ceil
                #ifndef DBG_MQLAPI_NOTRACE_ceil
                    #define ceil                                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathCeil,                                 DBG_MQL_API_TRACING_FUNCTION_ID_CEIL)
            #endif
        #endif
        #ifndef CharArrayToString
                #ifndef DBG_MQLAPI_NOTRACE_CharArrayToString
                    #define CharArrayToString                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CharArrayToString,                        0)
            #endif
        #endif
        #ifndef CharToString
                #ifndef DBG_MQLAPI_NOTRACE_CharToString
                    #define CharToString                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CharToString,                             0)
            #endif
        #endif
        #ifndef ChartApplyTemplate
                #ifndef DBG_MQLAPI_NOTRACE_ChartApplyTemplate
                    #define ChartApplyTemplate                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartApplyTemplate,                       0)
            #endif
        #endif
        #ifndef ChartClose
                #ifndef DBG_MQLAPI_NOTRACE_ChartClose
                    #define ChartClose                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartClose,                               0)
            #endif
        #endif
        #ifndef ChartFirst
                #ifndef DBG_MQLAPI_NOTRACE_ChartFirst
                    #define ChartFirst                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartFirst,                               0)
            #endif
        #endif
        #ifndef ChartGetDouble
                #ifndef DBG_MQLAPI_NOTRACE_ChartGetDouble
                    #define ChartGetDouble                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartGetDouble,                           0)
            #endif
        #endif
        #ifndef ChartGetInteger
                #ifndef DBG_MQLAPI_NOTRACE_ChartGetInteger
                    #define ChartGetInteger                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartGetInteger,                          0)
            #endif
        #endif
        #ifndef ChartGetString
                #ifndef DBG_MQLAPI_NOTRACE_ChartGetString
                    #define ChartGetString                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartGetString,                           0)
            #endif
        #endif
        #ifndef ChartID
                #ifndef DBG_MQLAPI_NOTRACE_ChartID
                    #define ChartID                                                                                         DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartID,                                  0)
            #endif
        #endif
        #ifndef ChartIndicatorDelete
                #ifndef DBG_MQLAPI_NOTRACE_ChartIndicatorDelete
                    #define ChartIndicatorDelete                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartIndicatorDelete,                     0)
            #endif
        #endif
        #ifndef ChartIndicatorName
                #ifndef DBG_MQLAPI_NOTRACE_ChartIndicatorName
                    #define ChartIndicatorName                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartIndicatorName,                       0)
            #endif
        #endif
        #ifndef ChartIndicatorsTotal
                #ifndef DBG_MQLAPI_NOTRACE_ChartIndicatorsTotal
                    #define ChartIndicatorsTotal                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartIndicatorsTotal,                     0)
            #endif
        #endif
        #ifndef ChartNavigate
                #ifndef DBG_MQLAPI_NOTRACE_ChartNavigate
                    #define ChartNavigate                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartNavigate,                            0)
            #endif
        #endif
        #ifndef ChartNext
                #ifndef DBG_MQLAPI_NOTRACE_ChartNext
                    #define ChartNext                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartNext,                                0)
            #endif
        #endif
        #ifndef ChartOpen
                #ifndef DBG_MQLAPI_NOTRACE_ChartOpen
                    #define ChartOpen                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartOpen,                                0)
            #endif
        #endif
        #ifndef ChartPeriod
                #ifndef DBG_MQLAPI_NOTRACE_ChartPeriod
                    #define ChartPeriod                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartPeriod,                              0)
            #endif
        #endif
        #ifndef ChartPriceOnDropped
                #ifndef DBG_MQLAPI_NOTRACE_ChartPriceOnDropped
                    #define ChartPriceOnDropped                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartPriceOnDropped,                      0)
            #endif
        #endif
        #ifndef ChartSaveTemplate
                #ifndef DBG_MQLAPI_NOTRACE_ChartSaveTemplate
                    #define ChartSaveTemplate                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartSaveTemplate,                        0)
            #endif
        #endif
        #ifndef ChartScreenShot
                #ifndef DBG_MQLAPI_NOTRACE_ChartScreenShot
                    #define ChartScreenShot                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartScreenShot,                          0)
            #endif
        #endif
        #ifndef ChartSetDouble
                #ifndef DBG_MQLAPI_NOTRACE_ChartSetDouble
                    #define ChartSetDouble                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartSetDouble,                           0)
            #endif
        #endif
        #ifndef ChartSetInteger
                #ifndef DBG_MQLAPI_NOTRACE_ChartSetInteger
                    #define ChartSetInteger                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartSetInteger,                          0)
            #endif
        #endif
        #ifndef ChartSetString
                #ifndef DBG_MQLAPI_NOTRACE_ChartSetString
                    #define ChartSetString                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartSetString,                           0)
            #endif
        #endif
        #ifndef ChartSetSymbolPeriod
                #ifndef DBG_MQLAPI_NOTRACE_ChartSetSymbolPeriod
                    #define ChartSetSymbolPeriod                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartSetSymbolPeriod,                     0)
            #endif
        #endif
        #ifndef ChartSymbol
                #ifndef DBG_MQLAPI_NOTRACE_ChartSymbol
                    #define ChartSymbol                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartSymbol,                              0)
            #endif
        #endif
        #ifndef ChartTimeOnDropped
                #ifndef DBG_MQLAPI_NOTRACE_ChartTimeOnDropped
                    #define ChartTimeOnDropped                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartTimeOnDropped,                       0)
            #endif
        #endif
        #ifndef ChartTimePriceToXY
                #ifndef DBG_MQLAPI_NOTRACE_ChartTimePriceToXY
                    #define ChartTimePriceToXY                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartTimePriceToXY,                       0)
            #endif
        #endif
        #ifndef ChartWindowFind
                #ifndef DBG_MQLAPI_NOTRACE_ChartWindowFind
                    #define ChartWindowFind                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartWindowFind,                          0)
            #endif
        #endif
        #ifndef ChartWindowOnDropped
                #ifndef DBG_MQLAPI_NOTRACE_ChartWindowOnDropped
                    #define ChartWindowOnDropped                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartWindowOnDropped,                     0)
            #endif
        #endif
        #ifndef ChartXOnDropped
                #ifndef DBG_MQLAPI_NOTRACE_ChartXOnDropped
                    #define ChartXOnDropped                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartXOnDropped,                          0)
            #endif
        #endif
        #ifndef ChartXYToTimePrice
                #ifndef DBG_MQLAPI_NOTRACE_ChartXYToTimePrice
                    #define ChartXYToTimePrice                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartXYToTimePrice,                       0)
            #endif
        #endif
        #ifndef ChartYOnDropped
                #ifndef DBG_MQLAPI_NOTRACE_ChartYOnDropped
                    #define ChartYOnDropped                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartYOnDropped,                          0)
            #endif
        #endif
        #ifndef CheckPointer
                #ifndef DBG_MQLAPI_NOTRACE_CheckPointer
                    #define CheckPointer                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CheckPointer,                             0)
            #endif
        #endif
        #ifndef ColorToARGB
                #ifndef DBG_MQLAPI_NOTRACE_ColorToARGB
                    #define ColorToARGB                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ColorToARGB,                              0)
            #endif
        #endif
        #ifndef ColorToString
                #ifndef DBG_MQLAPI_NOTRACE_ColorToString
                    #define ColorToString                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ColorToString,                            0)
            #endif
        #endif
        #ifndef CopyClose
                #ifndef DBG_MQLAPI_NOTRACE_CopyClose
                    #define CopyClose                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CopyClose,                                0)
            #endif
        #endif
        #ifndef CopyHigh
                #ifndef DBG_MQLAPI_NOTRACE_CopyHigh
                    #define CopyHigh                                                                                        DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CopyHigh,                                 0)
            #endif
        #endif
        #ifndef CopyLow
                #ifndef DBG_MQLAPI_NOTRACE_CopyLow
                    #define CopyLow                                                                                         DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CopyLow,                                  0)
            #endif
        #endif
        #ifndef CopyOpen
                #ifndef DBG_MQLAPI_NOTRACE_CopyOpen
                    #define CopyOpen                                                                                        DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CopyOpen,                                 0)
            #endif
        #endif
        #ifndef CopyRates
                #ifndef DBG_MQLAPI_NOTRACE_CopyRates
                    #define CopyRates                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CopyRates,                                0)
            #endif
        #endif
        #ifndef CopyRealVolume
                #ifndef DBG_MQLAPI_NOTRACE_CopyRealVolume
                    #define CopyRealVolume                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CopyRealVolume,                           0)
            #endif
        #endif
        #ifndef CopySpread
                #ifndef DBG_MQLAPI_NOTRACE_CopySpread
                    #define CopySpread                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CopySpread,                               0)
            #endif
        #endif
        #ifndef CopyTickVolume
                #ifndef DBG_MQLAPI_NOTRACE_CopyTickVolume
                    #define CopyTickVolume                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CopyTickVolume,                           0)
            #endif
        #endif
        #ifndef CopyTime
                #ifndef DBG_MQLAPI_NOTRACE_CopyTime
                    #define CopyTime                                                                                        DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CopyTime,                                 0)
            #endif
        #endif
        #ifndef cos
                #ifndef DBG_MQLAPI_NOTRACE_cos
                    #define cos                                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathCos,                                  DBG_MQL_API_TRACING_FUNCTION_ID_COS)
            #endif
        #endif
        #ifndef CryptDecode
                #ifndef DBG_MQLAPI_NOTRACE_CryptDecode
                    #define CryptDecode                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CryptDecode,                              0)
            #endif
        #endif
        #ifndef CryptEncode
                #ifndef DBG_MQLAPI_NOTRACE_CryptEncode
                    #define CryptEncode                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CryptEncode,                              0)
            #endif
        #endif
        #ifndef DoubleToString
                #ifndef DBG_MQLAPI_NOTRACE_DoubleToString
                    #define DoubleToString                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DoubleToString,                           0)
            #endif
        #endif
        #ifndef EnumToString
                #ifndef DBG_MQLAPI_NOTRACE_EnumToString
                    #define EnumToString                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_EnumToString,                             0)
            #endif
        #endif
        #ifndef EventChartCustom
                #ifndef DBG_MQLAPI_NOTRACE_EventChartCustom
                    #define EventChartCustom                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_EventChartCustom,                         0)
            #endif
        #endif
        #ifndef EventSetMillisecondTimer
                #ifndef DBG_MQLAPI_NOTRACE_EventSetMillisecondTimer
                    #define EventSetMillisecondTimer                                                                        DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_EventSetMillisecondTimer,                 0)
            #endif
        #endif
        #ifndef EventSetTimer
                #ifndef DBG_MQLAPI_NOTRACE_EventSetTimer
                    #define EventSetTimer                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_EventSetTimer,                            0)
            #endif
        #endif
        #ifndef exp
                #ifndef DBG_MQLAPI_NOTRACE_exp
                    #define exp                                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathExp,                                  DBG_MQL_API_TRACING_FUNCTION_ID_EXP)
            #endif
        #endif
        #ifndef fabs
                #ifndef DBG_MQLAPI_NOTRACE_fabs
                    #define fabs                                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathAbs,                                  DBG_MQL_API_TRACING_FUNCTION_ID_FABS)
            #endif
        #endif
        #ifndef FileCopy
                #ifndef DBG_MQLAPI_NOTRACE_FileCopy
                    #define FileCopy                                                                                        DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileCopy,                                 0)
            #endif
        #endif
        #ifndef FileDelete
                #ifndef DBG_MQLAPI_NOTRACE_FileDelete
                    #define FileDelete                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileDelete,                               0)
            #endif
        #endif
        #ifndef FileFindFirst
                #ifndef DBG_MQLAPI_NOTRACE_FileFindFirst
                    #define FileFindFirst                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileFindFirst,                            0)
            #endif
        #endif
        #ifndef FileFindNext
                #ifndef DBG_MQLAPI_NOTRACE_FileFindNext
                    #define FileFindNext                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileFindNext,                             0)
            #endif
        #endif
        #ifndef FileGetInteger
                #ifndef DBG_MQLAPI_NOTRACE_FileGetInteger
                    #define FileGetInteger                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileGetInteger,                           0)
            #endif
        #endif
        #ifndef FileIsEnding
                #ifndef DBG_MQLAPI_NOTRACE_FileIsEnding
                    #define FileIsEnding                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileIsEnding,                             0)
            #endif
        #endif
        #ifndef FileIsExist
                #ifndef DBG_MQLAPI_NOTRACE_FileIsExist
                    #define FileIsExist                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileIsExist,                              0)
            #endif
        #endif
        #ifndef FileIsLineEnding
                #ifndef DBG_MQLAPI_NOTRACE_FileIsLineEnding
                    #define FileIsLineEnding                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileIsLineEnding,                         0)
            #endif
        #endif
        #ifndef FileMove
                #ifndef DBG_MQLAPI_NOTRACE_FileMove
                    #define FileMove                                                                                        DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileMove,                                 0)
            #endif
        #endif
        #ifndef FileOpen
                #ifndef DBG_MQLAPI_NOTRACE_FileOpen
                    #define FileOpen                                                                                        DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileOpen,                                 0)
            #endif
        #endif
        #ifndef FileReadArray
                #ifndef DBG_MQLAPI_NOTRACE_FileReadArray
                    #define FileReadArray                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileReadArray,                            0)
            #endif
        #endif
        #ifndef FileReadBool
                #ifndef DBG_MQLAPI_NOTRACE_FileReadBool
                    #define FileReadBool                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileReadBool,                             0)
            #endif
        #endif
        #ifndef FileReadDatetime
                #ifndef DBG_MQLAPI_NOTRACE_FileReadDatetime
                    #define FileReadDatetime                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileReadDatetime,                         0)
            #endif
        #endif
        #ifndef FileReadDouble
                #ifndef DBG_MQLAPI_NOTRACE_FileReadDouble
                    #define FileReadDouble                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileReadDouble,                           0)
            #endif
        #endif
        #ifndef FileReadFloat
                #ifndef DBG_MQLAPI_NOTRACE_FileReadFloat
                    #define FileReadFloat                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileReadFloat,                            0)
            #endif
        #endif
        #ifndef FileReadInteger
                #ifndef DBG_MQLAPI_NOTRACE_FileReadInteger
                    #define FileReadInteger                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileReadInteger,                          0)
            #endif
        #endif
        #ifndef FileReadLong
                #ifndef DBG_MQLAPI_NOTRACE_FileReadLong
                    #define FileReadLong                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileReadLong,                             0)
            #endif
        #endif
        #ifndef FileReadNumber
                #ifndef DBG_MQLAPI_NOTRACE_FileReadNumber
                    #define FileReadNumber                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileReadNumber,                           0)
            #endif
        #endif
        #ifndef FileReadString
                #ifndef DBG_MQLAPI_NOTRACE_FileReadString
                    #define FileReadString                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileReadString,                           0)
            #endif
        #endif
        #ifndef FileReadStruct
                #ifndef DBG_MQLAPI_NOTRACE_FileReadStruct
                    #define FileReadStruct                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileReadStruct,                           0)
            #endif
        #endif
        #ifndef FileSeek
                #ifndef DBG_MQLAPI_NOTRACE_FileSeek
                    #define FileSeek                                                                                        DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileSeek,                                 0)
            #endif
        #endif
        #ifndef FileSize
                #ifndef DBG_MQLAPI_NOTRACE_FileSize
                    #define FileSize                                                                                        DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileSize,                                 0)
            #endif
        #endif
        #ifndef FileTell
                #ifndef DBG_MQLAPI_NOTRACE_FileTell
                    #define FileTell                                                                                        DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileTell,                                 0)
            #endif
        #endif
        #ifndef FileWrite
                #ifndef DBG_MQLAPI_NOTRACE_FileWrite
                    #define FileWrite                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileWrite,                                0)
            #endif
        #endif
        #ifndef FileWriteArray
                #ifndef DBG_MQLAPI_NOTRACE_FileWriteArray
                    #define FileWriteArray                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileWriteArray,                           0)
            #endif
        #endif
        #ifndef FileWriteDouble
                #ifndef DBG_MQLAPI_NOTRACE_FileWriteDouble
                    #define FileWriteDouble                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileWriteDouble,                          0)
            #endif
        #endif
        #ifndef FileWriteFloat
                #ifndef DBG_MQLAPI_NOTRACE_FileWriteFloat
                    #define FileWriteFloat                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileWriteFloat,                           0)
            #endif
        #endif
        #ifndef FileWriteInteger
                #ifndef DBG_MQLAPI_NOTRACE_FileWriteInteger
                    #define FileWriteInteger                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileWriteInteger,                         0)
            #endif
        #endif
        #ifndef FileWriteLong
                #ifndef DBG_MQLAPI_NOTRACE_FileWriteLong
                    #define FileWriteLong                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileWriteLong,                            0)
            #endif
        #endif
        #ifndef FileWriteString
                #ifndef DBG_MQLAPI_NOTRACE_FileWriteString
                    #define FileWriteString                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileWriteString,                          0)
            #endif
        #endif
        #ifndef FileWriteStruct
                #ifndef DBG_MQLAPI_NOTRACE_FileWriteStruct
                    #define FileWriteStruct                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileWriteStruct,                          0)
            #endif
        #endif
        #ifndef floor
                #ifndef DBG_MQLAPI_NOTRACE_floor
                    #define floor                                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathFloor,                                DBG_MQL_API_TRACING_FUNCTION_ID_FLOOR)
            #endif
        #endif
        #ifndef fmax
                #ifndef DBG_MQLAPI_NOTRACE_fmax
                    #define fmax                                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathMax,                                  DBG_MQL_API_TRACING_FUNCTION_ID_FMAX)
            #endif
        #endif
        #ifndef fmin
                #ifndef DBG_MQLAPI_NOTRACE_fmin
                    #define fmin                                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathMin,                                  DBG_MQL_API_TRACING_FUNCTION_ID_FMIN)
            #endif
        #endif
        #ifndef fmod
                #ifndef DBG_MQLAPI_NOTRACE_fmod
                    #define fmod                                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathMod,                                  DBG_MQL_API_TRACING_FUNCTION_ID_FMOD)
            #endif
        #endif
        #ifndef FolderClean
                #ifndef DBG_MQLAPI_NOTRACE_FolderClean
                    #define FolderClean                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FolderClean,                              0)
            #endif
        #endif
        #ifndef FolderCreate
                #ifndef DBG_MQLAPI_NOTRACE_FolderCreate
                    #define FolderCreate                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FolderCreate,                             0)
            #endif
        #endif
        #ifndef FolderDelete
                #ifndef DBG_MQLAPI_NOTRACE_FolderDelete
                    #define FolderDelete                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FolderDelete,                             0)
            #endif
        #endif
        #ifndef GetLastError
                #ifndef DBG_MQLAPI_NOTRACE_GetLastError
                    #define GetLastError                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_GetLastError,                             0)
            #endif
        #endif
        #ifndef GetMicrosecondCount
                #ifndef DBG_MQLAPI_NOTRACE_GetMicrosecondCount
                    #define GetMicrosecondCount                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_GetMicrosecondCount,                      0)
            #endif
        #endif
        #ifndef GetPointer
                #ifndef DBG_MQLAPI_NOTRACE_GetPointer
                    #define GetPointer                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_GetPointer,                               0)
            #endif
        #endif
        #ifndef GetTickCount
                #ifndef DBG_MQLAPI_NOTRACE_GetTickCount
                    #define GetTickCount                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_GetTickCount,                             0)
            #endif
        #endif
        #ifndef GlobalVariableCheck
                #ifndef DBG_MQLAPI_NOTRACE_GlobalVariableCheck
                    #define GlobalVariableCheck                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_GlobalVariableCheck,                      0)
            #endif
        #endif
        #ifndef GlobalVariableDel
                #ifndef DBG_MQLAPI_NOTRACE_GlobalVariableDel
                    #define GlobalVariableDel                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_GlobalVariableDel,                        0)
            #endif
        #endif
        #ifndef GlobalVariableGet
                #ifndef DBG_MQLAPI_NOTRACE_GlobalVariableGet
                    #define GlobalVariableGet                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_GlobalVariableGet,                        0)
            #endif
        #endif
        #ifndef GlobalVariableName
                #ifndef DBG_MQLAPI_NOTRACE_GlobalVariableName
                    #define GlobalVariableName                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_GlobalVariableName,                       0)
            #endif
        #endif
        #ifndef GlobalVariablesDeleteAll
                #ifndef DBG_MQLAPI_NOTRACE_GlobalVariablesDeleteAll
                    #define GlobalVariablesDeleteAll                                                                        DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_GlobalVariablesDeleteAll,                 0)
            #endif
        #endif
        #ifndef GlobalVariableSet
                #ifndef DBG_MQLAPI_NOTRACE_GlobalVariableSet
                    #define GlobalVariableSet                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_GlobalVariableSet,                        0)
            #endif
        #endif
        #ifndef GlobalVariableSetOnCondition
                #ifndef DBG_MQLAPI_NOTRACE_GlobalVariableSetOnCondition
                    #define GlobalVariableSetOnCondition                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_GlobalVariableSetOnCondition,             0)
            #endif
        #endif
        #ifndef GlobalVariablesTotal
                #ifndef DBG_MQLAPI_NOTRACE_GlobalVariablesTotal
                    #define GlobalVariablesTotal                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_GlobalVariablesTotal,                     0)
            #endif
        #endif
        #ifndef GlobalVariableTemp
                #ifndef DBG_MQLAPI_NOTRACE_GlobalVariableTemp
                    #define GlobalVariableTemp                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_GlobalVariableTemp,                       0)
            #endif
        #endif
        #ifndef GlobalVariableTime
                #ifndef DBG_MQLAPI_NOTRACE_GlobalVariableTime
                    #define GlobalVariableTime                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_GlobalVariableTime,                       0)
            #endif
        #endif
        #ifndef iBars
                #ifndef DBG_MQLAPI_NOTRACE_iBars
                    #define iBars                                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iBars,                                    0)
            #endif
        #endif
        #ifndef iBarShift
                #ifndef DBG_MQLAPI_NOTRACE_iBarShift
                    #define iBarShift                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iBarShift,                                0)
            #endif
        #endif
        #ifndef iClose
                #ifndef DBG_MQLAPI_NOTRACE_iClose
                    #define iClose                                                                                          DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iClose,                                   0)
            #endif
        #endif
        #ifndef iCustom
                #ifndef DBG_MQLAPI_NOTRACE_iCustom
                    #define iCustom                                                                                         DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iCustom,                                  0)
            #endif
        #endif
        #ifndef iHigh
                #ifndef DBG_MQLAPI_NOTRACE_iHigh
                    #define iHigh                                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iHigh,                                    0)
            #endif
        #endif
        #ifndef iHighest
                #ifndef DBG_MQLAPI_NOTRACE_iHighest
                    #define iHighest                                                                                        DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iHighest,                                 0)
            #endif
        #endif
        #ifndef iLow
                #ifndef DBG_MQLAPI_NOTRACE_iLow
                    #define iLow                                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iLow,                                     0)
            #endif
        #endif
        #ifndef iLowest
                #ifndef DBG_MQLAPI_NOTRACE_iLowest
                    #define iLowest                                                                                         DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iLowest,                                  0)
            #endif
        #endif
        #ifndef iOpen
                #ifndef DBG_MQLAPI_NOTRACE_iOpen
                    #define iOpen                                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iOpen,                                    0)
            #endif
        #endif
        #ifndef iTime
                #ifndef DBG_MQLAPI_NOTRACE_iTime
                    #define iTime                                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iTime,                                    0)
            #endif
        #endif
        #ifndef iVolume
                #ifndef DBG_MQLAPI_NOTRACE_iVolume
                    #define iVolume                                                                                         DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iVolume,                                  0)
            #endif
        #endif
        #ifndef iAC
                #ifndef DBG_MQLAPI_NOTRACE_iAC
                    #define iAC                                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iAC,                                      0)
            #endif
        #endif
        #ifndef iAD
                #ifndef DBG_MQLAPI_NOTRACE_iAD
                    #define iAD                                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iAD,                                      0)
            #endif
        #endif
        #ifndef iADX
                #ifndef DBG_MQLAPI_NOTRACE_iADX
                    #define iADX                                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iADX,                                     0)
            #endif
        #endif
        #ifndef iAlligator
                #ifndef DBG_MQLAPI_NOTRACE_iAlligator
                    #define iAlligator                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iAlligator,                               0)
            #endif
        #endif
        #ifndef iAO
                #ifndef DBG_MQLAPI_NOTRACE_iAO
                    #define iAO                                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iAO,                                      0)
            #endif
        #endif
        #ifndef iATR
                #ifndef DBG_MQLAPI_NOTRACE_iATR
                    #define iATR                                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iATR,                                     0)
            #endif
        #endif
        #ifndef iBands
                #ifndef DBG_MQLAPI_NOTRACE_iBands
                    #define iBands                                                                                          DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iBands,                                   0)
            #endif
        #endif
        #ifndef iBearsPower
                #ifndef DBG_MQLAPI_NOTRACE_iBearsPower
                    #define iBearsPower                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iBearsPower,                              0)
            #endif
        #endif
        #ifndef iBullsPower
                #ifndef DBG_MQLAPI_NOTRACE_iBullsPower
                    #define iBullsPower                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iBullsPower,                              0)
            #endif
        #endif
        #ifndef iBWMFI
                #ifndef DBG_MQLAPI_NOTRACE_iBWMFI
                    #define iBWMFI                                                                                          DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iBWMFI,                                   0)
            #endif
        #endif
        #ifndef iCCI
                #ifndef DBG_MQLAPI_NOTRACE_iCCI
                    #define iCCI                                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iCCI,                                     0)
            #endif
        #endif
        #ifndef iDeMarker
                #ifndef DBG_MQLAPI_NOTRACE_iDeMarker
                    #define iDeMarker                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iDeMarker,                                0)
            #endif
        #endif
        #ifndef iEnvelopes
                #ifndef DBG_MQLAPI_NOTRACE_iEnvelopes
                    #define iEnvelopes                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iEnvelopes,                               0)
            #endif
        #endif
        #ifndef iForce
                #ifndef DBG_MQLAPI_NOTRACE_iForce
                    #define iForce                                                                                          DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iForce,                                   0)
            #endif
        #endif
        #ifndef iFractals
                #ifndef DBG_MQLAPI_NOTRACE_iFractals
                    #define iFractals                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iFractals,                                0)
            #endif
        #endif
        #ifndef iGator
                #ifndef DBG_MQLAPI_NOTRACE_iGator
                    #define iGator                                                                                          DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iGator,                                   0)
            #endif
        #endif
        #ifndef iIchimoku
                #ifndef DBG_MQLAPI_NOTRACE_iIchimoku
                    #define iIchimoku                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iIchimoku,                                0)
            #endif
        #endif
        #ifndef iMA
                #ifndef DBG_MQLAPI_NOTRACE_iMA
                    #define iMA                                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iMA,                                      0)
            #endif
        #endif
        #ifndef iMACD
                #ifndef DBG_MQLAPI_NOTRACE_iMACD
                    #define iMACD                                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iMACD,                                    0)
            #endif
        #endif
        #ifndef iMFI
                #ifndef DBG_MQLAPI_NOTRACE_iMFI
                    #define iMFI                                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iMFI,                                     0)
            #endif
        #endif
        #ifndef iMomentum
                #ifndef DBG_MQLAPI_NOTRACE_iMomentum
                    #define iMomentum                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iMomentum,                                0)
            #endif
        #endif
        #ifndef IndicatorSetDouble
                #ifndef DBG_MQLAPI_NOTRACE_IndicatorSetDouble
                    #define IndicatorSetDouble                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_IndicatorSetDouble,                       0)
            #endif
        #endif
        #ifndef IndicatorSetInteger
                #ifndef DBG_MQLAPI_NOTRACE_IndicatorSetInteger
                    #define IndicatorSetInteger                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_IndicatorSetInteger,                      0)
            #endif
        #endif
        #ifndef IndicatorSetString
                #ifndef DBG_MQLAPI_NOTRACE_IndicatorSetString
                    #define IndicatorSetString                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_IndicatorSetString,                       0)
            #endif
        #endif
        #ifndef IntegerToString
                #ifndef DBG_MQLAPI_NOTRACE_IntegerToString
                    #define IntegerToString                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_IntegerToString,                          0)
            #endif
        #endif
        #ifndef iOBV
                #ifndef DBG_MQLAPI_NOTRACE_iOBV
                    #define iOBV                                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iOBV,                                     0)
            #endif
        #endif
        #ifndef iOsMA
                #ifndef DBG_MQLAPI_NOTRACE_iOsMA
                    #define iOsMA                                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iOsMA,                                    0)
            #endif
        #endif
        #ifndef iRSI
                #ifndef DBG_MQLAPI_NOTRACE_iRSI
                    #define iRSI                                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iRSI,                                     0)
            #endif
        #endif
        #ifndef iRVI
                #ifndef DBG_MQLAPI_NOTRACE_iRVI
                    #define iRVI                                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iRVI,                                     0)
            #endif
        #endif
        #ifndef iSAR
                #ifndef DBG_MQLAPI_NOTRACE_iSAR
                    #define iSAR                                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iSAR,                                     0)
            #endif
        #endif
        #ifndef IsStopped
                #ifndef DBG_MQLAPI_NOTRACE_IsStopped
                    #define IsStopped                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_IsStopped,                                0)
            #endif
        #endif
        #ifndef iStdDev
                #ifndef DBG_MQLAPI_NOTRACE_iStdDev
                    #define iStdDev                                                                                         DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iStdDev,                                  0)
            #endif
        #endif
        #ifndef iStochastic
                #ifndef DBG_MQLAPI_NOTRACE_iStochastic
                    #define iStochastic                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iStochastic,                              0)
            #endif
        #endif
        #ifndef iWPR
                #ifndef DBG_MQLAPI_NOTRACE_iWPR
                    #define iWPR                                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iWPR,                                     0)
            #endif
        #endif
        #ifndef log
                #ifndef DBG_MQLAPI_NOTRACE_log
                    #define log                                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathLog,                                  DBG_MQL_API_TRACING_FUNCTION_ID_LOG)
            #endif
        #endif
        #ifndef log10
                #ifndef DBG_MQLAPI_NOTRACE_log10
                    #define log10                                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathLog10,                                DBG_MQL_API_TRACING_FUNCTION_ID_LOG10)
            #endif
        #endif
        #ifndef MathAbs
                #ifndef DBG_MQLAPI_NOTRACE_MathAbs
                    #define MathAbs                                                                                         DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathAbs,                                  0)
            #endif
        #endif
        #ifndef MathArccos
                #ifndef DBG_MQLAPI_NOTRACE_MathArccos
                    #define MathArccos                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathArccos,                               0)
            #endif
        #endif
        #ifndef MathArcsin
                #ifndef DBG_MQLAPI_NOTRACE_MathArcsin
                    #define MathArcsin                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathArcsin,                               0)
            #endif
        #endif
        #ifndef MathArctan
                #ifndef DBG_MQLAPI_NOTRACE_MathArctan
                    #define MathArctan                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathArctan,                               0)
            #endif
        #endif
        #ifndef MathArctan2
                #ifndef DBG_MQLAPI_NOTRACE_MathArctan2
                    #define MathArctan2                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathArctan2,                              0)
            #endif
        #endif
        #ifndef MathClassify
                #ifndef DBG_MQLAPI_NOTRACE_MathClassify
                    #define MathClassify                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathClassify,                             0)
            #endif
        #endif
        #ifndef MathCeil
                #ifndef DBG_MQLAPI_NOTRACE_MathCeil
                    #define MathCeil                                                                                        DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathCeil,                                 0)
            #endif
        #endif
        #ifndef MathCos
                #ifndef DBG_MQLAPI_NOTRACE_MathCos
                    #define MathCos                                                                                         DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathCos,                                  0)
            #endif
        #endif
        #ifndef MathExp
                #ifndef DBG_MQLAPI_NOTRACE_MathExp
                    #define MathExp                                                                                         DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathExp,                                  0)
            #endif
        #endif
        #ifndef MathFloor
                #ifndef DBG_MQLAPI_NOTRACE_MathFloor
                    #define MathFloor                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathFloor,                                0)
            #endif
        #endif
        #ifndef MathIsValidNumber
                #ifndef DBG_MQLAPI_NOTRACE_MathIsValidNumber
                    #define MathIsValidNumber                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathIsValidNumber,                        0)
            #endif
        #endif
        #ifndef MathLog
                #ifndef DBG_MQLAPI_NOTRACE_MathLog
                    #define MathLog                                                                                         DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathLog,                                  0)
            #endif
        #endif
        #ifndef MathLog10
                #ifndef DBG_MQLAPI_NOTRACE_MathLog10
                    #define MathLog10                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathLog10,                                0)
            #endif
        #endif
        #ifndef MathMax
                #ifndef DBG_MQLAPI_NOTRACE_MathMax
                    #define MathMax                                                                                         DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathMax,                                  0)
            #endif
        #endif
        #ifndef MathMin
                #ifndef DBG_MQLAPI_NOTRACE_MathMin
                    #define MathMin                                                                                         DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathMin,                                  0)
            #endif
        #endif
        #ifndef MathMod
                #ifndef DBG_MQLAPI_NOTRACE_MathMod
                    #define MathMod                                                                                         DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathMod,                                  0)
            #endif
        #endif
        #ifndef MathPow
                #ifndef DBG_MQLAPI_NOTRACE_MathPow
                    #define MathPow                                                                                         DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathPow,                                  0)
            #endif
        #endif
        #ifndef MathRand
                #ifndef DBG_MQLAPI_NOTRACE_MathRand
                    #define MathRand                                                                                        DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathRand,                                 0)
            #endif
        #endif
        #ifndef MathRound
                #ifndef DBG_MQLAPI_NOTRACE_MathRound
                    #define MathRound                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathRound,                                0)
            #endif
        #endif
        #ifndef MathSin
                #ifndef DBG_MQLAPI_NOTRACE_MathSin
                    #define MathSin                                                                                         DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathSin,                                  0)
            #endif
        #endif
        #ifndef MathSqrt
                #ifndef DBG_MQLAPI_NOTRACE_MathSqrt
                    #define MathSqrt                                                                                        DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathSqrt,                                 0)
            #endif
        #endif
        #ifndef MathTan
                #ifndef DBG_MQLAPI_NOTRACE_MathTan
                    #define MathTan                                                                                         DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathTan,                                  0)
            #endif
        #endif
        #ifndef MathExpm1
                #ifndef DBG_MQLAPI_NOTRACE_MathExpm1
                    #define MathExpm1                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathExpm1,                                0)
            #endif
        #endif
        #ifndef MathLog1p
                #ifndef DBG_MQLAPI_NOTRACE_MathLog1p
                    #define MathLog1p                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathLog1p,                                0)
            #endif
        #endif
        #ifndef MathArccosh
                #ifndef DBG_MQLAPI_NOTRACE_MathArccosh
                    #define MathArccosh                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathArccosh,                              0)
            #endif
        #endif
        #ifndef MathArcsinh
                #ifndef DBG_MQLAPI_NOTRACE_MathArcsinh
                    #define MathArcsinh                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathArcsinh,                              0)
            #endif
        #endif
        #ifndef MathArctanh
                #ifndef DBG_MQLAPI_NOTRACE_MathArctanh
                    #define MathArctanh                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathArctanh,                              0)
            #endif
        #endif
        #ifndef MathCosh
                #ifndef DBG_MQLAPI_NOTRACE_MathCosh
                    #define MathCosh                                                                                        DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathCosh,                                 0)
            #endif
        #endif
        #ifndef MathSinh
                #ifndef DBG_MQLAPI_NOTRACE_MathSinh
                    #define MathSinh                                                                                        DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathSinh,                                 0)
            #endif
        #endif
        #ifndef MathSwap
                #ifndef DBG_MQLAPI_NOTRACE_MathSwap
                    #define MathSwap                                                                                        DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathSwap,                                 0)
            #endif
        #endif
        #ifndef MathTanh
                #ifndef DBG_MQLAPI_NOTRACE_MathTanh
                    #define MathTanh                                                                                        DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathTanh,                                 0)
            #endif
        #endif
        #ifndef MessageBox
                #ifndef DBG_MQLAPI_NOTRACE_MessageBox
                    #define MessageBox                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MessageBox,                               0)
            #endif
        #endif
        #ifndef MQLInfoString
                #ifndef DBG_MQLAPI_NOTRACE_MQLInfoString
                    #define MQLInfoString                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MQLInfoString,                            0)
            #endif
        #endif
        #ifndef NormalizeDouble
                #ifndef DBG_MQLAPI_NOTRACE_NormalizeDouble
                    #define NormalizeDouble                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_NormalizeDouble,                          0)
            #endif
        #endif
        #ifndef ObjectCreate
                #ifndef DBG_MQLAPI_NOTRACE_ObjectCreate
                    #define ObjectCreate                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ObjectCreate,                             0)
            #endif
        #endif
        #ifndef ObjectDelete
                #ifndef DBG_MQLAPI_NOTRACE_ObjectDelete
                    #define ObjectDelete                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ObjectDelete,                             0)
            #endif
        #endif
        #ifndef ObjectFind
                #ifndef DBG_MQLAPI_NOTRACE_ObjectFind
                    #define ObjectFind                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ObjectFind,                               0)
            #endif
        #endif
        #ifndef ObjectGetDouble
                #ifndef DBG_MQLAPI_NOTRACE_ObjectGetDouble
                    #define ObjectGetDouble                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ObjectGetDouble,                          0)
            #endif
        #endif
        #ifndef ObjectGetInteger
                #ifndef DBG_MQLAPI_NOTRACE_ObjectGetInteger
                    #define ObjectGetInteger                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ObjectGetInteger,                         0)
            #endif
        #endif
        #ifndef ObjectGetString
                #ifndef DBG_MQLAPI_NOTRACE_ObjectGetString
                    #define ObjectGetString                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ObjectGetString,                          0)
            #endif
        #endif
        #ifndef ObjectGetTimeByValue
                #ifndef DBG_MQLAPI_NOTRACE_ObjectGetTimeByValue
                    #define ObjectGetTimeByValue                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ObjectGetTimeByValue,                     0)
            #endif
        #endif
        #ifndef ObjectGetValueByTime
                #ifndef DBG_MQLAPI_NOTRACE_ObjectGetValueByTime
                    #define ObjectGetValueByTime                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ObjectGetValueByTime,                     0)
            #endif
        #endif
        #ifndef ObjectMove
                #ifndef DBG_MQLAPI_NOTRACE_ObjectMove
                    #define ObjectMove                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ObjectMove,                               0)
            #endif
        #endif
        #ifndef ObjectName
                #ifndef DBG_MQLAPI_NOTRACE_ObjectName
                    #define ObjectName                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ObjectName,                               0)
            #endif
        #endif
        #ifndef ObjectsDeleteAll
                #ifndef DBG_MQLAPI_NOTRACE_ObjectsDeleteAll
                    #define ObjectsDeleteAll                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ObjectsDeleteAll,                         0)
            #endif
        #endif
        #ifndef ObjectSetDouble
                #ifndef DBG_MQLAPI_NOTRACE_ObjectSetDouble
                    #define ObjectSetDouble                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ObjectSetDouble,                          0)
            #endif
        #endif
        #ifndef ObjectSetInteger
                #ifndef DBG_MQLAPI_NOTRACE_ObjectSetInteger
                    #define ObjectSetInteger                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ObjectSetInteger,                         0)
            #endif
        #endif
        #ifndef ObjectSetString
                #ifndef DBG_MQLAPI_NOTRACE_ObjectSetString
                    #define ObjectSetString                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ObjectSetString,                          0)
            #endif
        #endif
        #ifndef ObjectsTotal
                #ifndef DBG_MQLAPI_NOTRACE_ObjectsTotal
                    #define ObjectsTotal                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ObjectsTotal,                             0)
            #endif
        #endif
        #ifndef OrderGetDouble
                #ifndef DBG_MQLAPI_NOTRACE_OrderGetDouble
                    #define OrderGetDouble                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderGetDouble,                           0)
            #endif
        #endif
        #ifndef OrderSelect
                #ifndef DBG_MQLAPI_NOTRACE_OrderSelect
                    #define OrderSelect                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderSelect,                              0)
            #endif
        #endif
        #ifndef OrderSend
                #ifndef DBG_MQLAPI_NOTRACE_OrderSend
                    #define OrderSend                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderSend,                                0)
            #endif
        #endif
        #ifndef Period
                #ifndef DBG_MQLAPI_NOTRACE_Period
                    #define Period                                                                                          DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_Period,                                   0)
            #endif
        #endif
        #ifndef PeriodSeconds
                #ifndef DBG_MQLAPI_NOTRACE_PeriodSeconds
                    #define PeriodSeconds                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_PeriodSeconds,                            0)
            #endif
        #endif
        #ifndef PlaySound
                #ifndef DBG_MQLAPI_NOTRACE_PlaySound
                    #define PlaySound                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_PlaySound,                                0)
            #endif
        #endif
        #ifndef PlotIndexGetInteger
                #ifndef DBG_MQLAPI_NOTRACE_PlotIndexGetInteger
                    #define PlotIndexGetInteger                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_PlotIndexGetInteger,                      0)
            #endif
        #endif
        #ifndef PlotIndexSetDouble
                #ifndef DBG_MQLAPI_NOTRACE_PlotIndexSetDouble
                    #define PlotIndexSetDouble                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_PlotIndexSetDouble,                       0)
            #endif
        #endif
        #ifndef PlotIndexSetInteger
                #ifndef DBG_MQLAPI_NOTRACE_PlotIndexSetInteger
                    #define PlotIndexSetInteger                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_PlotIndexSetInteger,                      0)
            #endif
        #endif
        #ifndef PlotIndexSetString
                #ifndef DBG_MQLAPI_NOTRACE_PlotIndexSetString
                    #define PlotIndexSetString                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_PlotIndexSetString,                       0)
            #endif
        #endif
        #ifndef Point
                #ifndef DBG_MQLAPI_NOTRACE_Point
                    #define Point                                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_Point,                                    0)
            #endif
        #endif
        #ifndef pow
                #ifndef DBG_MQLAPI_NOTRACE_pow
                    #define pow                                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathPow,                                  DBG_MQL_API_TRACING_FUNCTION_ID_POW)
            #endif
        #endif
        #ifndef rand
                #ifndef DBG_MQLAPI_NOTRACE_rand
                    #define rand                                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathRand,                                 DBG_MQL_API_TRACING_FUNCTION_ID_RAND)
            #endif
        #endif
        #ifndef ResourceCreate
                #ifndef DBG_MQLAPI_NOTRACE_ResourceCreate
                    #define ResourceCreate                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ResourceCreate,                           0)
            #endif
        #endif
        #ifndef ResourceFree
                #ifndef DBG_MQLAPI_NOTRACE_ResourceFree
                    #define ResourceFree                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ResourceFree,                             0)
            #endif
        #endif
        #ifndef ResourceReadImage
                #ifndef DBG_MQLAPI_NOTRACE_ResourceReadImage
                    #define ResourceReadImage                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ResourceReadImage,                        0)
            #endif
        #endif
        #ifndef ResourceSave
                #ifndef DBG_MQLAPI_NOTRACE_ResourceSave
                    #define ResourceSave                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ResourceSave,                             0)
            #endif
        #endif
        #ifndef round
                #ifndef DBG_MQLAPI_NOTRACE_round
                    #define round                                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathRound,                                DBG_MQL_API_TRACING_FUNCTION_ID_ROUND)
            #endif
        #endif
        #ifndef SendFTP
                #ifndef DBG_MQLAPI_NOTRACE_SendFTP
                    #define SendFTP                                                                                         DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SendFTP,                                  0)
            #endif
        #endif
        #ifndef SendMail
                #ifndef DBG_MQLAPI_NOTRACE_SendMail
                    #define SendMail                                                                                        DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SendMail,                                 0)
            #endif
        #endif
        #ifndef SendNotification
                #ifndef DBG_MQLAPI_NOTRACE_SendNotification
                    #define SendNotification                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SendNotification,                         0)
            #endif
        #endif
        #ifndef SeriesInfoInteger
                #ifndef DBG_MQLAPI_NOTRACE_SeriesInfoInteger
                    #define SeriesInfoInteger                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SeriesInfoInteger,                        0)
            #endif
        #endif
        #ifndef SetIndexBuffer
                #ifndef DBG_MQLAPI_NOTRACE_SetIndexBuffer
                    #define SetIndexBuffer                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SetIndexBuffer,                           0)
            #endif
        #endif
        #ifndef ShortArrayToString
                #ifndef DBG_MQLAPI_NOTRACE_ShortArrayToString
                    #define ShortArrayToString                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ShortArrayToString,                       0)
            #endif
        #endif
        #ifndef ShortToString
                #ifndef DBG_MQLAPI_NOTRACE_ShortToString
                    #define ShortToString                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ShortToString,                            0)
            #endif
        #endif
        #ifndef SignalBaseGetDouble
                #ifndef DBG_MQLAPI_NOTRACE_SignalBaseGetDouble
                    #define SignalBaseGetDouble                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SignalBaseGetDouble,                      0)
            #endif
        #endif
        #ifndef SignalBaseGetInteger
                #ifndef DBG_MQLAPI_NOTRACE_SignalBaseGetInteger
                    #define SignalBaseGetInteger                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SignalBaseGetInteger,                     0)
            #endif
        #endif
        #ifndef SignalBaseGetString
                #ifndef DBG_MQLAPI_NOTRACE_SignalBaseGetString
                    #define SignalBaseGetString                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SignalBaseGetString,                      0)
            #endif
        #endif
        #ifndef SignalBaseSelect
                #ifndef DBG_MQLAPI_NOTRACE_SignalBaseSelect
                    #define SignalBaseSelect                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SignalBaseSelect,                         0)
            #endif
        #endif
        #ifndef SignalBaseTotal
                #ifndef DBG_MQLAPI_NOTRACE_SignalBaseTotal
                    #define SignalBaseTotal                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SignalBaseTotal,                          0)
            #endif
        #endif
        #ifndef SignalInfoGetDouble
                #ifndef DBG_MQLAPI_NOTRACE_SignalInfoGetDouble
                    #define SignalInfoGetDouble                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SignalInfoGetDouble,                      0)
            #endif
        #endif
        #ifndef SignalInfoGetInteger
                #ifndef DBG_MQLAPI_NOTRACE_SignalInfoGetInteger
                    #define SignalInfoGetInteger                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SignalInfoGetInteger,                     0)
            #endif
        #endif
        #ifndef SignalInfoGetString
                #ifndef DBG_MQLAPI_NOTRACE_SignalInfoGetString
                    #define SignalInfoGetString                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SignalInfoGetString,                      0)
            #endif
        #endif
        #ifndef SignalInfoSetDouble
                #ifndef DBG_MQLAPI_NOTRACE_SignalInfoSetDouble
                    #define SignalInfoSetDouble                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SignalInfoSetDouble,                      0)
            #endif
        #endif
        #ifndef SignalInfoSetInteger
                #ifndef DBG_MQLAPI_NOTRACE_SignalInfoSetInteger
                    #define SignalInfoSetInteger                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SignalInfoSetInteger,                     0)
            #endif
        #endif
        #ifndef SignalSubscribe
                #ifndef DBG_MQLAPI_NOTRACE_SignalSubscribe
                    #define SignalSubscribe                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SignalSubscribe,                          0)
            #endif
        #endif
        #ifndef SignalUnsubscribe
                #ifndef DBG_MQLAPI_NOTRACE_SignalUnsubscribe
                    #define SignalUnsubscribe                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SignalUnsubscribe,                        0)
            #endif
        #endif
        #ifndef sin
                #ifndef DBG_MQLAPI_NOTRACE_sin
                    #define sin                                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathSin,                                  DBG_MQL_API_TRACING_FUNCTION_ID_SIN)
            #endif
        #endif
        #ifndef sqrt
                #ifndef DBG_MQLAPI_NOTRACE_sqrt
                    #define sqrt                                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathSqrt,                                 DBG_MQL_API_TRACING_FUNCTION_ID_SQRT)
            #endif
        #endif
        #ifndef StringAdd
                #ifndef DBG_MQLAPI_NOTRACE_StringAdd
                    #define StringAdd                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StringAdd,                                0)
            #endif
        #endif
        #ifndef StringBufferLen
                #ifndef DBG_MQLAPI_NOTRACE_StringBufferLen
                    #define StringBufferLen                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StringBufferLen,                          0)
            #endif
        #endif
        #ifndef StringCompare
                #ifndef DBG_MQLAPI_NOTRACE_StringCompare
                    #define StringCompare                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StringCompare,                            0)
            #endif
        #endif
        #ifndef StringConcatenate
                #ifndef DBG_MQLAPI_NOTRACE_StringConcatenate
                    #define StringConcatenate                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StringConcatenate,                        0)
            #endif
        #endif
        #ifndef StringFill
                #ifndef DBG_MQLAPI_NOTRACE_StringFill
                    #define StringFill                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StringFill,                               0)
            #endif
        #endif
        #ifndef StringFind
                #ifndef DBG_MQLAPI_NOTRACE_StringFind
                    #define StringFind                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StringFind,                               0)
            #endif
        #endif
        #ifndef StringFormat
                #ifndef DBG_MQLAPI_NOTRACE_StringFormat
                    #define StringFormat                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_unify_input_format,                            DBG_MQL_API_TRACING_FUNCTION_ID_STRINGFORMAT)
            #endif
        #endif
        #ifndef StringGetCharacter
                #ifndef DBG_MQLAPI_NOTRACE_StringGetCharacter
                    #define StringGetCharacter                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StringGetCharacter,                       0)
            #endif
        #endif
        #ifndef StringInit
                #ifndef DBG_MQLAPI_NOTRACE_StringInit
                    #define StringInit                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StringInit,                               0)
            #endif
        #endif
        #ifndef StringLen
                #ifndef DBG_MQLAPI_NOTRACE_StringLen
                    #define StringLen                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StringLen,                                0)
            #endif
        #endif
        #ifndef StringReserve
                #ifndef DBG_MQLAPI_NOTRACE_StringReserve
                    #define StringReserve                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StringReserve,                            0)
            #endif
        #endif
        #ifndef StringReplace
                #ifndef DBG_MQLAPI_NOTRACE_StringReplace
                    #define StringReplace                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StringReplace,                            0)
            #endif
        #endif
        #ifndef StringSetCharacter
                #ifndef DBG_MQLAPI_NOTRACE_StringSetCharacter
                    #define StringSetCharacter                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StringSetCharacter,                       0)
            #endif
        #endif
        #ifndef StringSetLength
                #ifndef DBG_MQLAPI_NOTRACE_StringSetLength
                    #define StringSetLength                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StringSetLength,                          0)
            #endif
        #endif
        #ifndef StringSplit
                #ifndef DBG_MQLAPI_NOTRACE_StringSplit
                    #define StringSplit                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StringSplit,                              0)
            #endif
        #endif
        #ifndef StringSubstr
                #ifndef DBG_MQLAPI_NOTRACE_StringSubstr
                    #define StringSubstr                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StringSubstr,                             0)
            #endif
        #endif
        #ifndef StringToCharArray
                #ifndef DBG_MQLAPI_NOTRACE_StringToCharArray
                    #define StringToCharArray                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StringToCharArray,                        0)
            #endif
        #endif
        #ifndef StringToColor
                #ifndef DBG_MQLAPI_NOTRACE_StringToColor
                    #define StringToColor                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StringToColor,                            0)
            #endif
        #endif
        #ifndef StringToDouble
                #ifndef DBG_MQLAPI_NOTRACE_StringToDouble
                    #define StringToDouble                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StringToDouble,                           0)
            #endif
        #endif
        #ifndef StringToInteger
                #ifndef DBG_MQLAPI_NOTRACE_StringToInteger
                    #define StringToInteger                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StringToInteger,                          0)
            #endif
        #endif
        #ifndef StringToLower
                #ifndef DBG_MQLAPI_NOTRACE_StringToLower
                    #define StringToLower                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StringToLower,                            0)
            #endif
        #endif
        #ifndef StringToShortArray
                #ifndef DBG_MQLAPI_NOTRACE_StringToShortArray
                    #define StringToShortArray                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StringToShortArray,                       0)
            #endif
        #endif
        #ifndef StringToTime
                #ifndef DBG_MQLAPI_NOTRACE_StringToTime
                    #define StringToTime                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StringToTime,                             0)
            #endif
        #endif
        #ifndef StringToUpper
                #ifndef DBG_MQLAPI_NOTRACE_StringToUpper
                    #define StringToUpper                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StringToUpper,                            0)
            #endif
        #endif
        #ifndef StringTrimLeft
                #ifndef DBG_MQLAPI_NOTRACE_StringTrimLeft
                    #define StringTrimLeft                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StringTrimLeft,                           0)
            #endif
        #endif
        #ifndef StringTrimRight
                #ifndef DBG_MQLAPI_NOTRACE_StringTrimRight
                    #define StringTrimRight                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StringTrimRight,                          0)
            #endif
        #endif
        #ifndef StructToCharArray
                #ifndef DBG_MQLAPI_NOTRACE_StructToCharArray
                    #define StructToCharArray                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StructToCharArray,                        0)
            #endif
        #endif
        #ifndef StructToTime
                #ifndef DBG_MQLAPI_NOTRACE_StructToTime
                    #define StructToTime                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StructToTime,                             0)
            #endif
        #endif
        #ifndef Symbol
                #ifndef DBG_MQLAPI_NOTRACE_Symbol
                    #define Symbol                                                                                          DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_Symbol,                                   0)
            #endif
        #endif
        #ifndef SymbolExist
                #ifndef DBG_MQLAPI_NOTRACE_SymbolExist
                    #define SymbolExist                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SymbolExist,                              0)
            #endif
        #endif
        #ifndef SymbolInfoDouble
                #ifndef DBG_MQLAPI_NOTRACE_SymbolInfoDouble
                    #define SymbolInfoDouble                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SymbolInfoDouble,                         0)
            #endif
        #endif
        #ifndef SymbolInfoInteger
                #ifndef DBG_MQLAPI_NOTRACE_SymbolInfoInteger
                    #define SymbolInfoInteger                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SymbolInfoInteger,                        0)
            #endif
        #endif
        #ifndef SymbolInfoSessionQuote
                #ifndef DBG_MQLAPI_NOTRACE_SymbolInfoSessionQuote
                    #define SymbolInfoSessionQuote                                                                          DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SymbolInfoSessionQuote,                   0)
            #endif
        #endif
        #ifndef SymbolInfoSessionTrade
                #ifndef DBG_MQLAPI_NOTRACE_SymbolInfoSessionTrade
                    #define SymbolInfoSessionTrade                                                                          DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SymbolInfoSessionTrade,                   0)
            #endif
        #endif
        #ifndef SymbolInfoString
                #ifndef DBG_MQLAPI_NOTRACE_SymbolInfoString
                    #define SymbolInfoString                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SymbolInfoString,                         0)
            #endif
        #endif
        #ifndef SymbolInfoTick
                #ifndef DBG_MQLAPI_NOTRACE_SymbolInfoTick
                    #define SymbolInfoTick                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SymbolInfoTick,                           0)
            #endif
        #endif
        #ifndef SymbolIsSynchronized
                #ifndef DBG_MQLAPI_NOTRACE_SymbolIsSynchronized
                    #define SymbolIsSynchronized                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SymbolIsSynchronized,                     0)
            #endif
        #endif
        #ifndef SymbolName
                #ifndef DBG_MQLAPI_NOTRACE_SymbolName
                    #define SymbolName                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SymbolName,                               0)
            #endif
        #endif
        #ifndef SymbolSelect
                #ifndef DBG_MQLAPI_NOTRACE_SymbolSelect
                    #define SymbolSelect                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SymbolSelect,                             0)
            #endif
        #endif
        #ifndef SymbolsTotal
                #ifndef DBG_MQLAPI_NOTRACE_SymbolsTotal
                    #define SymbolsTotal                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SymbolsTotal,                             0)
            #endif
        #endif
        #ifndef tan
                #ifndef DBG_MQLAPI_NOTRACE_tan
                    #define tan                                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MathTan,                                  DBG_MQL_API_TRACING_FUNCTION_ID_TAN)
            #endif
        #endif
        #ifndef TerminalClose
                #ifndef DBG_MQLAPI_NOTRACE_TerminalClose
                    #define TerminalClose                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TerminalClose,                            0)
            #endif
        #endif
        #ifndef TerminalInfoDouble
                #ifndef DBG_MQLAPI_NOTRACE_TerminalInfoDouble
                    #define TerminalInfoDouble                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TerminalInfoDouble,                       0)
            #endif
        #endif
        #ifndef TerminalInfoString
                #ifndef DBG_MQLAPI_NOTRACE_TerminalInfoString
                    #define TerminalInfoString                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TerminalInfoString,                       0)
            #endif
        #endif
        #ifndef TesterStatistics
                #ifndef DBG_MQLAPI_NOTRACE_TesterStatistics
                    #define TesterStatistics                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TesterStatistics,                         0)
            #endif
        #endif
        #ifndef TextGetSize
                #ifndef DBG_MQLAPI_NOTRACE_TextGetSize
                    #define TextGetSize                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TextGetSize,                              0)
            #endif
        #endif
        #ifndef TextOut
                #ifndef DBG_MQLAPI_NOTRACE_TextOut
                    #define TextOut                                                                                         DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TextOut,                                  0)
            #endif
        #endif
        #ifndef TextSetFont
                #ifndef DBG_MQLAPI_NOTRACE_TextSetFont
                    #define TextSetFont                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TextSetFont,                              0)
            #endif
        #endif
        #ifndef TimeCurrent
                #ifndef DBG_MQLAPI_NOTRACE_TimeCurrent
                    #define TimeCurrent                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TimeCurrent,                              0)
            #endif
        #endif
        #ifndef TimeDaylightSavings
                #ifndef DBG_MQLAPI_NOTRACE_TimeDaylightSavings
                    #define TimeDaylightSavings                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TimeDaylightSavings,                      0)
            #endif
        #endif
        #ifndef TimeGMT
                #ifndef DBG_MQLAPI_NOTRACE_TimeGMT
                    #define TimeGMT                                                                                         DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TimeGMT,                                  0)
            #endif
        #endif
        #ifndef TimeGMTOffset
                #ifndef DBG_MQLAPI_NOTRACE_TimeGMTOffset
                    #define TimeGMTOffset                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TimeGMTOffset,                            0)
            #endif
        #endif
        #ifndef TimeLocal
                #ifndef DBG_MQLAPI_NOTRACE_TimeLocal
                    #define TimeLocal                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TimeLocal,                                0)
            #endif
        #endif
        #ifndef TimeToString
                #ifndef DBG_MQLAPI_NOTRACE_TimeToString
                    #define TimeToString                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TimeToString,                             0)
            #endif
        #endif
        #ifndef TimeToStruct
                #ifndef DBG_MQLAPI_NOTRACE_TimeToStruct
                    #define TimeToStruct                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TimeToStruct,                             0)
            #endif
        #endif
        #ifndef TranslateKey
                #ifndef DBG_MQLAPI_NOTRACE_TranslateKey
                    #define TranslateKey                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TranslateKey,                             0)
            #endif
        #endif
        #ifndef UninitializeReason
                #ifndef DBG_MQLAPI_NOTRACE_UninitializeReason
                    #define UninitializeReason                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_UninitializeReason,                       0)
            #endif
        #endif
        #ifndef WebRequest
                #ifndef DBG_MQLAPI_NOTRACE_WebRequest
                    #define WebRequest                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_WebRequest,                               0)
            #endif
        #endif

        // MQL4 exclusive functions
        #ifdef __MQL4__
            #ifndef AccountBalance
                #ifndef DBG_MQLAPI_NOTRACE_AccountBalance
                    #define AccountBalance                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_AccountBalance,                           0)
                #endif
            #endif
            #ifndef AccountCompany
                #ifndef DBG_MQLAPI_NOTRACE_AccountCompany
                    #define AccountCompany                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_AccountCompany,                           0)
                #endif
            #endif
            #ifndef AccountCredit
                #ifndef DBG_MQLAPI_NOTRACE_AccountCredit
                    #define AccountCredit                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_AccountCredit,                            0)
                #endif
            #endif
            #ifndef AccountCurrency
                #ifndef DBG_MQLAPI_NOTRACE_AccountCurrency
                    #define AccountCurrency                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_AccountCurrency,                          0)
                #endif
            #endif
            #ifndef AccountEquity
                #ifndef DBG_MQLAPI_NOTRACE_AccountEquity
                    #define AccountEquity                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_AccountEquity,                            0)
                #endif
            #endif
            #ifndef AccountFreeMargin
                #ifndef DBG_MQLAPI_NOTRACE_AccountFreeMargin
                    #define AccountFreeMargin                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_AccountFreeMargin,                        0)
                #endif
            #endif
            #ifndef AccountFreeMarginCheck
                #ifndef DBG_MQLAPI_NOTRACE_AccountFreeMarginCheck
                    #define AccountFreeMarginCheck                                                                          DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_AccountFreeMarginCheck,                   0)
                #endif
            #endif
            #ifndef AccountFreeMarginMode
                #ifndef DBG_MQLAPI_NOTRACE_AccountFreeMarginMode
                    #define AccountFreeMarginMode                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_AccountFreeMarginMode,                    0)
                #endif
            #endif
            #ifndef AccountLeverage
                #ifndef DBG_MQLAPI_NOTRACE_AccountLeverage
                    #define AccountLeverage                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_AccountLeverage,                          0)
                #endif
            #endif
            #ifndef AccountMargin
                #ifndef DBG_MQLAPI_NOTRACE_AccountMargin
                    #define AccountMargin                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_AccountMargin,                            0)
                #endif
            #endif
            #ifndef AccountName
                #ifndef DBG_MQLAPI_NOTRACE_AccountName
                    #define AccountName                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_AccountName,                              0)
                #endif
            #endif
            #ifndef AccountNumber
                #ifndef DBG_MQLAPI_NOTRACE_AccountNumber
                    #define AccountNumber                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_AccountNumber,                            0)
                #endif
            #endif
            #ifndef AccountProfit
                #ifndef DBG_MQLAPI_NOTRACE_AccountProfit
                    #define AccountProfit                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_AccountProfit,                            0)
                #endif
            #endif
            #ifndef AccountServer
                #ifndef DBG_MQLAPI_NOTRACE_AccountServer
                    #define AccountServer                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_AccountServer,                            0)
                #endif
            #endif
            #ifndef AccountStopoutLevel
                #ifndef DBG_MQLAPI_NOTRACE_AccountStopoutLevel
                    #define AccountStopoutLevel                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_AccountStopoutLevel,                      0)
                #endif
            #endif
            #ifndef AccountStopoutMode
                #ifndef DBG_MQLAPI_NOTRACE_AccountStopoutMode
                    #define AccountStopoutMode                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_AccountStopoutMode,                       0)
                #endif
            #endif
            #ifndef ArrayCopyRates
                #ifndef DBG_MQLAPI_NOTRACE_ArrayCopyRates
                    #define ArrayCopyRates                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ArrayCopyRates,                           0)
                #endif
            #endif
            #ifndef ArrayCopySeries
                #ifndef DBG_MQLAPI_NOTRACE_ArrayCopySeries
                    #define ArrayCopySeries                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ArrayCopySeries,                          0)
                #endif
            #endif
            #ifndef ArrayDimension
                #ifndef DBG_MQLAPI_NOTRACE_ArrayDimension
                    #define ArrayDimension                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ArrayDimension,                           0)
                #endif
            #endif
            #ifndef CharToStr
                #ifndef DBG_MQLAPI_NOTRACE_CharToStr
                    #define CharToStr                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CharToStr,                                0)
                #endif
            #endif
            #ifndef Day
                #ifndef DBG_MQLAPI_NOTRACE_Day
                    #define Day                                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_Day,                                      0)
                #endif
            #endif
            #ifndef DayOfWeek
                #ifndef DBG_MQLAPI_NOTRACE_DayOfWeek
                    #define DayOfWeek                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DayOfWeek,                                0)
                #endif
            #endif
            #ifndef DayOfYear
                #ifndef DBG_MQLAPI_NOTRACE_DayOfYear
                    #define DayOfYear                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DayOfYear,                                0)
                #endif
            #endif
            #ifndef DoubleToStr
                #ifndef DBG_MQLAPI_NOTRACE_DoubleToStr
                    #define DoubleToStr                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DoubleToStr,                              0)
                #endif
            #endif
            #ifndef FileOpenHistory
                #ifndef DBG_MQLAPI_NOTRACE_FileOpenHistory
                    #define FileOpenHistory                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileOpenHistory,                          0)
                #endif
            #endif
            #ifndef Hour
                #ifndef DBG_MQLAPI_NOTRACE_Hour
                    #define Hour                                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_Hour,                                     0)
                #endif
            #endif
            #ifndef iBandsOnArray
                #ifndef DBG_MQLAPI_NOTRACE_iBandsOnArray
                    #define iBandsOnArray                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iBandsOnArray,                            0)
                #endif
            #endif
            #ifndef iCCIOnArray
                #ifndef DBG_MQLAPI_NOTRACE_iCCIOnArray
                    #define iCCIOnArray                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iCCIOnArray,                              0)
                #endif
            #endif
            #ifndef iEnvelopesOnArray
                #ifndef DBG_MQLAPI_NOTRACE_iEnvelopesOnArray
                    #define iEnvelopesOnArray                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iEnvelopesOnArray,                        0)
                #endif
            #endif
            #ifndef iMAOnArray
                #ifndef DBG_MQLAPI_NOTRACE_iMAOnArray
                    #define iMAOnArray                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iMAOnArray,                               0)
                #endif
            #endif
            #ifndef iMomentumOnArray
                #ifndef DBG_MQLAPI_NOTRACE_iMomentumOnArray
                    #define iMomentumOnArray                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iMomentumOnArray,                         0)
                #endif
            #endif
            #ifndef IndicatorBuffers
                #ifndef DBG_MQLAPI_NOTRACE_IndicatorBuffers
                    #define IndicatorBuffers                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_IndicatorBuffers,                         0)
                #endif
            #endif
            #ifndef IndicatorCounted
                #ifndef DBG_MQLAPI_NOTRACE_IndicatorCounted
                    #define IndicatorCounted                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_IndicatorCounted,                         0)
                #endif
            #endif
            #ifndef iRSIOnArray
                #ifndef DBG_MQLAPI_NOTRACE_iRSIOnArray
                    #define iRSIOnArray                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iRSIOnArray,                              0)
                #endif
            #endif
            #ifndef IsConnected
                #ifndef DBG_MQLAPI_NOTRACE_IsConnected
                    #define IsConnected                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_IsConnected,                              0)
                #endif
            #endif
            #ifndef IsDemo
                #ifndef DBG_MQLAPI_NOTRACE_IsDemo
                    #define IsDemo                                                                                          DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_IsDemo,                                   0)
                #endif
            #endif
            #ifndef IsDllsAllowed
                #ifndef DBG_MQLAPI_NOTRACE_IsDllsAllowed
                    #define IsDllsAllowed                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_IsDllsAllowed,                            0)
                #endif
            #endif
            #ifndef IsExpertEnabled
                #ifndef DBG_MQLAPI_NOTRACE_IsExpertEnabled
                    #define IsExpertEnabled                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_IsExpertEnabled,                          0)
                #endif
            #endif
            #ifndef IsLibrariesAllowed
                #ifndef DBG_MQLAPI_NOTRACE_IsLibrariesAllowed
                    #define IsLibrariesAllowed                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_IsLibrariesAllowed,                       0)
                #endif
            #endif
            #ifndef IsOptimization
                #ifndef DBG_MQLAPI_NOTRACE_IsOptimization
                    #define IsOptimization                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_IsOptimization,                           0)
                #endif
            #endif
            #ifndef iStdDevOnArray
                #ifndef DBG_MQLAPI_NOTRACE_iStdDevOnArray
                    #define iStdDevOnArray                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iStdDevOnArray,                           0)
                #endif
            #endif
            #ifndef IsTesting
                #ifndef DBG_MQLAPI_NOTRACE_IsTesting
                    #define IsTesting                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_IsTesting,                                0)
                #endif
            #endif
            #ifndef IsTradeAllowed
                #ifndef DBG_MQLAPI_NOTRACE_IsTradeAllowed
                    #define IsTradeAllowed                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_IsTradeAllowed,                           0)
                #endif
            #endif
            #ifndef IsTradeContextBusy
                #ifndef DBG_MQLAPI_NOTRACE_IsTradeContextBusy
                    #define IsTradeContextBusy                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_IsTradeContextBusy,                       0)
                #endif
            #endif
            #ifndef IsVisualMode
                #ifndef DBG_MQLAPI_NOTRACE_IsVisualMode
                    #define IsVisualMode                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_IsVisualMode,                             0)
                #endif
            #endif
            #ifndef MarketInfo
                #ifndef DBG_MQLAPI_NOTRACE_MarketInfo
                    #define MarketInfo                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MarketInfo,                               0)
                #endif
            #endif
            #ifndef Minute
                #ifndef DBG_MQLAPI_NOTRACE_Minute
                    #define Minute                                                                                          DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_Minute,                                   0)
                #endif
            #endif
            #ifndef Month
                #ifndef DBG_MQLAPI_NOTRACE_Month
                    #define Month                                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_Month,                                    0)
                #endif
            #endif
            #ifndef ObjectDescription
                #ifndef DBG_MQLAPI_NOTRACE_ObjectDescription
                    #define ObjectDescription                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ObjectDescription,                        0)
                #endif
            #endif
            #ifndef ObjectGet
                #ifndef DBG_MQLAPI_NOTRACE_ObjectGet
                    #define ObjectGet                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ObjectGet,                                0)
                #endif
            #endif
            #ifndef ObjectGetFiboDescription
                #ifndef DBG_MQLAPI_NOTRACE_ObjectGetFiboDescription
                    #define ObjectGetFiboDescription                                                                        DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ObjectGetFiboDescription,                 0)
                #endif
            #endif
            #ifndef ObjectGetShiftByValue
                #ifndef DBG_MQLAPI_NOTRACE_ObjectGetShiftByValue
                    #define ObjectGetShiftByValue                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ObjectGetShiftByValue,                    0)
                #endif
            #endif
            #ifndef ObjectGetValueByShift
                #ifndef DBG_MQLAPI_NOTRACE_ObjectGetValueByShift
                    #define ObjectGetValueByShift                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ObjectGetValueByShift,                    0)
                #endif
            #endif
            #ifndef ObjectSet
                #ifndef DBG_MQLAPI_NOTRACE_ObjectSet
                    #define ObjectSet                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ObjectSet,                                0)
                #endif
            #endif
            #ifndef ObjectSetFiboDescription
                #ifndef DBG_MQLAPI_NOTRACE_ObjectSetFiboDescription
                    #define ObjectSetFiboDescription                                                                        DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ObjectSetFiboDescription,                 0)
                #endif
            #endif
            #ifndef ObjectSetText
                #ifndef DBG_MQLAPI_NOTRACE_ObjectSetText
                    #define ObjectSetText                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ObjectSetText,                            0)
                #endif
            #endif
            #ifndef ObjectType
                #ifndef DBG_MQLAPI_NOTRACE_ObjectType
                    #define ObjectType                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ObjectType,                               0)
                #endif
            #endif
            #ifndef OrderClose
                #ifndef DBG_MQLAPI_NOTRACE_OrderClose
                    #define OrderClose                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderClose,                               0)
                #endif
            #endif
            #ifndef OrderCloseBy
                #ifndef DBG_MQLAPI_NOTRACE_OrderCloseBy
                    #define OrderCloseBy                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderCloseBy,                             0)
                #endif
            #endif
            #ifndef OrderClosePrice
                #ifndef DBG_MQLAPI_NOTRACE_OrderClosePrice
                    #define OrderClosePrice                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderClosePrice,                          0)
                #endif
            #endif
            #ifndef OrderCloseTime
                #ifndef DBG_MQLAPI_NOTRACE_OrderCloseTime
                    #define OrderCloseTime                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderCloseTime,                           0)
                #endif
            #endif
            #ifndef OrderComment
                #ifndef DBG_MQLAPI_NOTRACE_OrderComment
                    #define OrderComment                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderComment,                             0)
                #endif
            #endif
            #ifndef OrderCommission
                #ifndef DBG_MQLAPI_NOTRACE_OrderCommission
                    #define OrderCommission                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderCommission,                          0)
                #endif
            #endif
            #ifndef OrderDelete
                #ifndef DBG_MQLAPI_NOTRACE_OrderDelete
                    #define OrderDelete                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderDelete,                              0)
                #endif
            #endif
            #ifndef OrderExpiration
                #ifndef DBG_MQLAPI_NOTRACE_OrderExpiration
                    #define OrderExpiration                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderExpiration,                          0)
                #endif
            #endif
            #ifndef OrderLots
                #ifndef DBG_MQLAPI_NOTRACE_OrderLots
                    #define OrderLots                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderLots,                                0)
                #endif
            #endif
            #ifndef OrderMagicNumber
                #ifndef DBG_MQLAPI_NOTRACE_OrderMagicNumber
                    #define OrderMagicNumber                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderMagicNumber,                         0)
                #endif
            #endif
            #ifndef OrderModify
                #ifndef DBG_MQLAPI_NOTRACE_OrderModify
                    #define OrderModify                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderModify,                              0)
                #endif
            #endif
            #ifndef OrderOpenPrice
                #ifndef DBG_MQLAPI_NOTRACE_OrderOpenPrice
                    #define OrderOpenPrice                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderOpenPrice,                           0)
                #endif
            #endif
            #ifndef OrderOpenTime
                #ifndef DBG_MQLAPI_NOTRACE_OrderOpenTime
                    #define OrderOpenTime                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderOpenTime,                            0)
                #endif
            #endif
            #ifndef OrderProfit
                #ifndef DBG_MQLAPI_NOTRACE_OrderProfit
                    #define OrderProfit                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderProfit,                              0)
                #endif
            #endif
            #ifndef OrdersHistoryTotal
                #ifndef DBG_MQLAPI_NOTRACE_OrdersHistoryTotal
                    #define OrdersHistoryTotal                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrdersHistoryTotal,                       0)
                #endif
            #endif
            #ifndef OrderStopLoss
                #ifndef DBG_MQLAPI_NOTRACE_OrderStopLoss
                    #define OrderStopLoss                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderStopLoss,                            0)
                #endif
            #endif
            #ifndef OrderSwap
                #ifndef DBG_MQLAPI_NOTRACE_OrderSwap
                    #define OrderSwap                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderSwap,                                0)
                #endif
            #endif
            #ifndef OrderSymbol
                #ifndef DBG_MQLAPI_NOTRACE_OrderSymbol
                    #define OrderSymbol                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderSymbol,                              0)
                #endif
            #endif
            #ifndef OrderTakeProfit
                #ifndef DBG_MQLAPI_NOTRACE_OrderTakeProfit
                    #define OrderTakeProfit                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderTakeProfit,                          0)
                #endif
            #endif
            #ifndef OrderTicket
                #ifndef DBG_MQLAPI_NOTRACE_OrderTicket
                    #define OrderTicket                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderTicket,                              0)
                #endif
            #endif
            #ifndef OrderType
                #ifndef DBG_MQLAPI_NOTRACE_OrderType
                    #define OrderType                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderType,                                0)
                #endif
            #endif
            #ifndef RefreshRates
                #ifndef DBG_MQLAPI_NOTRACE_RefreshRates
                    #define RefreshRates                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_RefreshRates,                             0)
                #endif
            #endif
            #ifndef Seconds
                #ifndef DBG_MQLAPI_NOTRACE_Seconds
                    #define Seconds                                                                                         DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_Seconds,                                  0)
                #endif
            #endif
            #ifndef StringGetChar
                #ifndef DBG_MQLAPI_NOTRACE_StringGetChar
                    #define StringGetChar                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StringGetChar,                            0)
                #endif
            #endif
            #ifndef StringSetChar
                #ifndef DBG_MQLAPI_NOTRACE_StringSetChar
                    #define StringSetChar                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StringSetChar,                            0)
                #endif
            #endif
            #ifndef StrToDouble
                #ifndef DBG_MQLAPI_NOTRACE_StrToDouble
                    #define StrToDouble                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StrToDouble,                              0)
                #endif
            #endif
            #ifndef StrToInteger
                #ifndef DBG_MQLAPI_NOTRACE_StrToInteger
                    #define StrToInteger                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StrToInteger,                             0)
                #endif
            #endif
            #ifndef StrToTime
                #ifndef DBG_MQLAPI_NOTRACE_StrToTime
                    #define StrToTime                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_StrToTime,                                0)
                #endif
            #endif
            #ifndef TerminalCompany
                #ifndef DBG_MQLAPI_NOTRACE_TerminalCompany
                    #define TerminalCompany                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TerminalCompany,                          0)
                #endif
            #endif
            #ifndef TerminalName
                #ifndef DBG_MQLAPI_NOTRACE_TerminalName
                    #define TerminalName                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TerminalName,                             0)
                #endif
            #endif
            #ifndef TerminalPath
                #ifndef DBG_MQLAPI_NOTRACE_TerminalPath
                    #define TerminalPath                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TerminalPath,                             0)
                #endif
            #endif
            #ifndef TimeDay
                #ifndef DBG_MQLAPI_NOTRACE_TimeDay
                    #define TimeDay                                                                                         DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TimeDay,                                  0)
                #endif
            #endif
            #ifndef TimeDayOfWeek
                #ifndef DBG_MQLAPI_NOTRACE_TimeDayOfWeek
                    #define TimeDayOfWeek                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TimeDayOfWeek,                            0)
                #endif
            #endif
            #ifndef TimeDayOfYear
                #ifndef DBG_MQLAPI_NOTRACE_TimeDayOfYear
                    #define TimeDayOfYear                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TimeDayOfYear,                            0)
                #endif
            #endif
            #ifndef TimeHour
                #ifndef DBG_MQLAPI_NOTRACE_TimeHour
                    #define TimeHour                                                                                        DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TimeHour,                                 0)
                #endif
            #endif
            #ifndef TimeMinute
                #ifndef DBG_MQLAPI_NOTRACE_TimeMinute
                    #define TimeMinute                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TimeMinute,                               0)
                #endif
            #endif
            #ifndef TimeMonth
                #ifndef DBG_MQLAPI_NOTRACE_TimeMonth
                    #define TimeMonth                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TimeMonth,                                0)
                #endif
            #endif
            #ifndef TimeSeconds
                #ifndef DBG_MQLAPI_NOTRACE_TimeSeconds
                    #define TimeSeconds                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TimeSeconds,                              0)
                #endif
            #endif
            #ifndef TimeToStr
                #ifndef DBG_MQLAPI_NOTRACE_TimeToStr
                    #define TimeToStr                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TimeToStr,                                0)
                #endif
            #endif
            #ifndef TimeYear
                #ifndef DBG_MQLAPI_NOTRACE_TimeYear
                    #define TimeYear                                                                                        DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TimeYear,                                 0)
                #endif
            #endif
            #ifndef WindowBarsPerChart
                #ifndef DBG_MQLAPI_NOTRACE_WindowBarsPerChart
                    #define WindowBarsPerChart                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_WindowBarsPerChart,                       0)
                #endif
            #endif
            #ifndef WindowExpertName
                #ifndef DBG_MQLAPI_NOTRACE_WindowExpertName
                    #define WindowExpertName                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_WindowExpertName,                         0)
                #endif
            #endif
            #ifndef WindowFind
                #ifndef DBG_MQLAPI_NOTRACE_WindowFind
                    #define WindowFind                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_WindowFind,                               0)
                #endif
            #endif
            #ifndef WindowFirstVisibleBar
                #ifndef DBG_MQLAPI_NOTRACE_WindowFirstVisibleBar
                    #define WindowFirstVisibleBar                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_WindowFirstVisibleBar,                    0)
                #endif
            #endif
            #ifndef WindowHandle
                #ifndef DBG_MQLAPI_NOTRACE_WindowHandle
                    #define WindowHandle                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_WindowHandle,                             0)
                #endif
            #endif
            #ifndef WindowIsVisible
                #ifndef DBG_MQLAPI_NOTRACE_WindowIsVisible
                    #define WindowIsVisible                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_WindowIsVisible,                          0)
                #endif
            #endif
            #ifndef WindowOnDropped
                #ifndef DBG_MQLAPI_NOTRACE_WindowOnDropped
                    #define WindowOnDropped                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_WindowOnDropped,                          0)
                #endif
            #endif
            #ifndef WindowPriceMax
                #ifndef DBG_MQLAPI_NOTRACE_WindowPriceMax
                    #define WindowPriceMax                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_WindowPriceMax,                           0)
                #endif
            #endif
            #ifndef WindowPriceMin
                #ifndef DBG_MQLAPI_NOTRACE_WindowPriceMin
                    #define WindowPriceMin                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_WindowPriceMin,                           0)
                #endif
            #endif
            #ifndef WindowPriceOnDropped
                #ifndef DBG_MQLAPI_NOTRACE_WindowPriceOnDropped
                    #define WindowPriceOnDropped                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_WindowPriceOnDropped,                     0)
                #endif
            #endif
            #ifndef WindowScreenShot
                #ifndef DBG_MQLAPI_NOTRACE_WindowScreenShot
                    #define WindowScreenShot                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_WindowScreenShot,                         0)
                #endif
            #endif
            #ifndef WindowsTotal
                #ifndef DBG_MQLAPI_NOTRACE_WindowsTotal
                    #define WindowsTotal                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_WindowsTotal,                             0)
                #endif
            #endif
            #ifndef WindowTimeOnDropped
                #ifndef DBG_MQLAPI_NOTRACE_WindowTimeOnDropped
                    #define WindowTimeOnDropped                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_WindowTimeOnDropped,                      0)
                #endif
            #endif
            #ifndef WindowXOnDropped
                #ifndef DBG_MQLAPI_NOTRACE_WindowXOnDropped
                    #define WindowXOnDropped                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_WindowXOnDropped,                         0)
                #endif
            #endif
            #ifndef WindowYOnDropped
                #ifndef DBG_MQLAPI_NOTRACE_WindowYOnDropped
                    #define WindowYOnDropped                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_WindowYOnDropped,                         0)
                #endif
            #endif
            #ifndef Year
                #ifndef DBG_MQLAPI_NOTRACE_Year
                    #define Year                                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_Year,                                     0)
                #endif
            #endif

        #endif

        // MQL5 exclusive functions
        #ifndef __MQL4__
            #ifndef AccountInfoInteger
                #ifndef DBG_MQLAPI_NOTRACE_AccountInfoInteger
                    #define AccountInfoInteger                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_AccountInfoInteger,                       0)
                #endif
            #endif
            #ifndef ArrayInsert
                #ifndef DBG_MQLAPI_NOTRACE_ArrayInsert
                    #define ArrayInsert                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ArrayInsert,                              0)
                #endif
            #endif
            #ifndef ArrayRemove
                #ifndef DBG_MQLAPI_NOTRACE_ArrayRemove
                    #define ArrayRemove                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ArrayRemove,                              0)
                #endif
            #endif
            #ifndef ArrayReverse
                #ifndef DBG_MQLAPI_NOTRACE_ArrayReverse
                    #define ArrayReverse                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ArrayReverse,                             0)
                #endif
            #endif
            #ifndef ArraySwap
                #ifndef DBG_MQLAPI_NOTRACE_ArraySwap
                    #define ArraySwap                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ArraySwap,                                0)
                #endif
            #endif
            #ifndef Bars
                #ifndef DBG_MQLAPI_NOTRACE_Bars
                    #define Bars                                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_Bars,                                     0)
                #endif
            #endif
            #ifndef BarsCalculated
                #ifndef DBG_MQLAPI_NOTRACE_BarsCalculated
                    #define BarsCalculated                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_BarsCalculated,                           0)
                #endif
            #endif
            #ifndef CalendarCountryById
                #ifndef DBG_MQLAPI_NOTRACE_CalendarCountryById
                    #define CalendarCountryById                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CalendarCountryById,                      0)
                #endif
            #endif
            #ifndef CalendarEventById
                #ifndef DBG_MQLAPI_NOTRACE_CalendarEventById
                    #define CalendarEventById                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CalendarEventById,                        0)
                #endif
            #endif
            #ifndef CalendarValueById
                #ifndef DBG_MQLAPI_NOTRACE_CalendarValueById
                    #define CalendarValueById                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CalendarValueById,                        0)
                #endif
            #endif
            #ifndef CalendarCountries
                #ifndef DBG_MQLAPI_NOTRACE_CalendarCountries
                    #define CalendarCountries                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CalendarCountries,                        0)
                #endif
            #endif
            #ifndef CalendarEventByCountry
                #ifndef DBG_MQLAPI_NOTRACE_CalendarEventByCountry
                    #define CalendarEventByCountry                                                                          DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CalendarEventByCountry,                   0)
                #endif
            #endif
            #ifndef CalendarEventByCurrency
                #ifndef DBG_MQLAPI_NOTRACE_CalendarEventByCurrency
                    #define CalendarEventByCurrency                                                                         DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CalendarEventByCurrency,                  0)
                #endif
            #endif
            #ifndef CalendarValueHistoryByEvent
                #ifndef DBG_MQLAPI_NOTRACE_CalendarValueHistoryByEvent
                    #define CalendarValueHistoryByEvent                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CalendarValueHistoryByEvent,              0)
                #endif
            #endif
            #ifndef CalendarValueHistory
                #ifndef DBG_MQLAPI_NOTRACE_CalendarValueHistory
                    #define CalendarValueHistory                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CalendarValueHistory,                     0)
                #endif
            #endif
            #ifndef CalendarValueLastByEvent
                #ifndef DBG_MQLAPI_NOTRACE_CalendarValueLastByEvent
                    #define CalendarValueLastByEvent                                                                        DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CalendarValueLastByEvent,                 0)
                #endif
            #endif
            #ifndef CalendarValueLast
                #ifndef DBG_MQLAPI_NOTRACE_CalendarValueLast
                    #define CalendarValueLast                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CalendarValueLast,                        0)
                #endif
            #endif
            #ifndef CharArrayToStruct
                #ifndef DBG_MQLAPI_NOTRACE_CharArrayToStruct
                    #define CharArrayToStruct                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CharArrayToStruct,                        0)
                #endif
            #endif
            #ifndef ChartIndicatorAdd
                #ifndef DBG_MQLAPI_NOTRACE_ChartIndicatorAdd
                    #define ChartIndicatorAdd                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartIndicatorAdd,                        0)
                #endif
            #endif
            #ifndef ChartIndicatorGet
                #ifndef DBG_MQLAPI_NOTRACE_ChartIndicatorGet
                    #define ChartIndicatorGet                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ChartIndicatorGet,                        0)
                #endif
            #endif
            #ifndef CLBufferCreate
                #ifndef DBG_MQLAPI_NOTRACE_CLBufferCreate
                    #define CLBufferCreate                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CLBufferCreate,                           0)
                #endif
            #endif
            #ifndef CLBufferRead
                #ifndef DBG_MQLAPI_NOTRACE_CLBufferRead
                    #define CLBufferRead                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CLBufferRead,                             0)
                #endif
            #endif
            #ifndef CLBufferWrite
                #ifndef DBG_MQLAPI_NOTRACE_CLBufferWrite
                    #define CLBufferWrite                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CLBufferWrite,                            0)
                #endif
            #endif
            #ifndef CLContextCreate
                #ifndef DBG_MQLAPI_NOTRACE_CLContextCreate
                    #define CLContextCreate                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CLContextCreate,                          0)
                #endif
            #endif
            #ifndef CLExecute
                #ifndef DBG_MQLAPI_NOTRACE_CLExecute
                    #define CLExecute                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CLExecute,                                0)
                #endif
            #endif
            #ifndef CLGetDeviceInfo
                #ifndef DBG_MQLAPI_NOTRACE_CLGetDeviceInfo
                    #define CLGetDeviceInfo                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CLGetDeviceInfo,                          0)
                #endif
            #endif
            #ifndef CLGetInfoString
                #ifndef DBG_MQLAPI_NOTRACE_CLGetInfoString
                    #define CLGetInfoString                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CLGetInfoString,                          0)
                #endif
            #endif
            #ifndef CLGetInfoInteger
                #ifndef DBG_MQLAPI_NOTRACE_CLGetInfoInteger
                    #define CLGetInfoInteger                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CLGetInfoInteger,                         0)
                #endif
            #endif
            #ifndef CLHandleType
                #ifndef DBG_MQLAPI_NOTRACE_CLHandleType
                    #define CLHandleType                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CLHandleType,                             0)
                #endif
            #endif
            #ifndef CLKernelCreate
                #ifndef DBG_MQLAPI_NOTRACE_CLKernelCreate
                    #define CLKernelCreate                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CLKernelCreate,                           0)
                #endif
            #endif
            #ifndef CLProgramCreate
                #ifndef DBG_MQLAPI_NOTRACE_CLProgramCreate
                    #define CLProgramCreate                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CLProgramCreate,                          0)
                #endif
            #endif
            #ifndef CLSetKernelArg
                #ifndef DBG_MQLAPI_NOTRACE_CLSetKernelArg
                    #define CLSetKernelArg                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CLSetKernelArg,                           0)
                #endif
            #endif
            #ifndef CLSetKernelArgMem
                #ifndef DBG_MQLAPI_NOTRACE_CLSetKernelArgMem
                    #define CLSetKernelArgMem                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CLSetKernelArgMem,                        0)
                #endif
            #endif
            #ifndef CLSetKernelArgMemLocal
                #ifndef DBG_MQLAPI_NOTRACE_CLSetKernelArgMemLocal
                    #define CLSetKernelArgMemLocal                                                                          DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CLSetKernelArgMemLocal,                   0)
                #endif
            #endif
            #ifndef CopyBuffer
                #ifndef DBG_MQLAPI_NOTRACE_CopyBuffer
                    #define CopyBuffer                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CopyBuffer,                               0)
                #endif
            #endif
            #ifndef CopySeries
                #ifndef DBG_MQLAPI_NOTRACE_CopySeries
                    #define CopySeries                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CopySeries,                               0)
                #endif
            #endif
            #ifndef CopyTicks
                #ifndef DBG_MQLAPI_NOTRACE_CopyTicks
                    #define CopyTicks                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CopyTicks,                                0)
                #endif
            #endif
            #ifndef CopyTicksRange
                #ifndef DBG_MQLAPI_NOTRACE_CopyTicksRange
                    #define CopyTicksRange                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CopyTicksRange,                           0)
                #endif
            #endif
            #ifndef CustomSymbolCreate
                #ifndef DBG_MQLAPI_NOTRACE_CustomSymbolCreate
                    #define CustomSymbolCreate                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CustomSymbolCreate,                       0)
                #endif
            #endif
            #ifndef CustomSymbolDelete
                #ifndef DBG_MQLAPI_NOTRACE_CustomSymbolDelete
                    #define CustomSymbolDelete                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CustomSymbolDelete,                       0)
                #endif
            #endif
            #ifndef CustomSymbolSetInteger
                #ifndef DBG_MQLAPI_NOTRACE_CustomSymbolSetInteger
                    #define CustomSymbolSetInteger                                                                          DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CustomSymbolSetInteger,                   0)
                #endif
            #endif
            #ifndef CustomSymbolSetDouble
                #ifndef DBG_MQLAPI_NOTRACE_CustomSymbolSetDouble
                    #define CustomSymbolSetDouble                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CustomSymbolSetDouble,                    0)
                #endif
            #endif
            #ifndef CustomSymbolSetString
                #ifndef DBG_MQLAPI_NOTRACE_CustomSymbolSetString
                    #define CustomSymbolSetString                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CustomSymbolSetString,                    0)
                #endif
            #endif
            #ifndef CustomSymbolSetMarginRate
                #ifndef DBG_MQLAPI_NOTRACE_CustomSymbolSetMarginRate
                    #define CustomSymbolSetMarginRate                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CustomSymbolSetMarginRate,                0)
                #endif
            #endif
            #ifndef CustomSymbolSetSessionQuote
                #ifndef DBG_MQLAPI_NOTRACE_CustomSymbolSetSessionQuote
                    #define CustomSymbolSetSessionQuote                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CustomSymbolSetSessionQuote,              0)
                #endif
            #endif
            #ifndef CustomSymbolSetSessionTrade
                #ifndef DBG_MQLAPI_NOTRACE_CustomSymbolSetSessionTrade
                    #define CustomSymbolSetSessionTrade                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CustomSymbolSetSessionTrade,              0)
                #endif
            #endif
            #ifndef CustomRatesDelete
                #ifndef DBG_MQLAPI_NOTRACE_CustomRatesDelete
                    #define CustomRatesDelete                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CustomRatesDelete,                        0)
                #endif
            #endif
            #ifndef CustomRatesReplace
                #ifndef DBG_MQLAPI_NOTRACE_CustomRatesReplace
                    #define CustomRatesReplace                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CustomRatesReplace,                       0)
                #endif
            #endif
            #ifndef CustomRatesUpdate
                #ifndef DBG_MQLAPI_NOTRACE_CustomRatesUpdate
                    #define CustomRatesUpdate                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CustomRatesUpdate,                        0)
                #endif
            #endif
            #ifndef CustomTicksAdd
                #ifndef DBG_MQLAPI_NOTRACE_CustomTicksAdd
                    #define CustomTicksAdd                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CustomTicksAdd,                           0)
                #endif
            #endif
            #ifndef CustomTicksDelete
                #ifndef DBG_MQLAPI_NOTRACE_CustomTicksDelete
                    #define CustomTicksDelete                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CustomTicksDelete,                        0)
                #endif
            #endif
            #ifndef CustomTicksReplace
                #ifndef DBG_MQLAPI_NOTRACE_CustomTicksReplace
                    #define CustomTicksReplace                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CustomTicksReplace,                       0)
                #endif
            #endif
            #ifndef CustomBookAdd
                #ifndef DBG_MQLAPI_NOTRACE_CustomBookAdd
                    #define CustomBookAdd                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_CustomBookAdd,                            0)
                #endif
            #endif
            #ifndef DatabaseOpen
                #ifndef DBG_MQLAPI_NOTRACE_DatabaseOpen
                    #define DatabaseOpen                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DatabaseOpen,                             0)
                #endif
            #endif
            #ifndef DatabaseImport
                #ifndef DBG_MQLAPI_NOTRACE_DatabaseImport
                    #define DatabaseImport                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DatabaseImport,                           0)
                #endif
            #endif
            #ifndef DatabaseExport
                #ifndef DBG_MQLAPI_NOTRACE_DatabaseExport
                    #define DatabaseExport                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DatabaseExport,                           0)
                #endif
            #endif
            #ifndef DatabasePrint
                #ifndef DBG_MQLAPI_NOTRACE_DatabasePrint
                    #define DatabasePrint                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DatabasePrint,                            0)
                #endif
            #endif
            #ifndef DatabaseTableExists
                #ifndef DBG_MQLAPI_NOTRACE_DatabaseTableExists
                    #define DatabaseTableExists                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DatabaseTableExists,                      0)
                #endif
            #endif
            #ifndef DatabaseExecute
                #ifndef DBG_MQLAPI_NOTRACE_DatabaseExecute
                    #define DatabaseExecute                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DatabaseExecute,                          0)
                #endif
            #endif
            #ifndef DatabasePrepare
                #ifndef DBG_MQLAPI_NOTRACE_DatabasePrepare
                    #define DatabasePrepare                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DatabasePrepare,                          0)
                #endif
            #endif
            #ifndef DatabaseReset
                #ifndef DBG_MQLAPI_NOTRACE_DatabaseReset
                    #define DatabaseReset                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DatabaseReset,                            0)
                #endif
            #endif
            #ifndef DatabaseBind
                #ifndef DBG_MQLAPI_NOTRACE_DatabaseBind
                    #define DatabaseBind                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DatabaseBind,                             0)
                #endif
            #endif
            #ifndef DatabaseBindArray
                #ifndef DBG_MQLAPI_NOTRACE_DatabaseBindArray
                    #define DatabaseBindArray                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DatabaseBindArray,                        0)
                #endif
            #endif
            #ifndef DatabaseRead
                #ifndef DBG_MQLAPI_NOTRACE_DatabaseRead
                    #define DatabaseRead                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DatabaseRead,                             0)
                #endif
            #endif
            #ifndef DatabaseReadBind
                #ifndef DBG_MQLAPI_NOTRACE_DatabaseReadBind
                    #define DatabaseReadBind                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DatabaseReadBind,                         0)
                #endif
            #endif
            #ifndef DatabaseTransactionBegin
                #ifndef DBG_MQLAPI_NOTRACE_DatabaseTransactionBegin
                    #define DatabaseTransactionBegin                                                                        DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DatabaseTransactionBegin,                 0)
                #endif
            #endif
            #ifndef DatabaseTransactionCommit
                #ifndef DBG_MQLAPI_NOTRACE_DatabaseTransactionCommit
                    #define DatabaseTransactionCommit                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DatabaseTransactionCommit,                0)
                #endif
            #endif
            #ifndef DatabaseTransactionRollback
                #ifndef DBG_MQLAPI_NOTRACE_DatabaseTransactionRollback
                    #define DatabaseTransactionRollback                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DatabaseTransactionRollback,              0)
                #endif
            #endif
            #ifndef DatabaseColumnsCount
                #ifndef DBG_MQLAPI_NOTRACE_DatabaseColumnsCount
                    #define DatabaseColumnsCount                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DatabaseColumnsCount,                     0)
                #endif
            #endif
            #ifndef DatabaseColumnName
                #ifndef DBG_MQLAPI_NOTRACE_DatabaseColumnName
                    #define DatabaseColumnName                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DatabaseColumnName,                       0)
                #endif
            #endif
            #ifndef DatabaseColumnType
                #ifndef DBG_MQLAPI_NOTRACE_DatabaseColumnType
                    #define DatabaseColumnType                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DatabaseColumnType,                       0)
                #endif
            #endif
            #ifndef DatabaseColumnSize
                #ifndef DBG_MQLAPI_NOTRACE_DatabaseColumnSize
                    #define DatabaseColumnSize                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DatabaseColumnSize,                       0)
                #endif
            #endif
            #ifndef DatabaseColumnText
                #ifndef DBG_MQLAPI_NOTRACE_DatabaseColumnText
                    #define DatabaseColumnText                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DatabaseColumnText,                       0)
                #endif
            #endif
            #ifndef DatabaseColumnInteger
                #ifndef DBG_MQLAPI_NOTRACE_DatabaseColumnInteger
                    #define DatabaseColumnInteger                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DatabaseColumnInteger,                    0)
                #endif
            #endif
            #ifndef DatabaseColumnLong
                #ifndef DBG_MQLAPI_NOTRACE_DatabaseColumnLong
                    #define DatabaseColumnLong                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DatabaseColumnLong,                       0)
                #endif
            #endif
            #ifndef DatabaseColumnDouble
                #ifndef DBG_MQLAPI_NOTRACE_DatabaseColumnDouble
                    #define DatabaseColumnDouble                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DatabaseColumnDouble,                     0)
                #endif
            #endif
            #ifndef DatabaseColumnBlob
                #ifndef DBG_MQLAPI_NOTRACE_DatabaseColumnBlob
                    #define DatabaseColumnBlob                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DatabaseColumnBlob,                       0)
                #endif
            #endif
            #ifndef Digits
                #ifndef DBG_MQLAPI_NOTRACE_Digits
                    #define Digits                                                                                          DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_Digits,                                   0)
                #endif
            #endif
            #ifndef DXContextCreate
                #ifndef DBG_MQLAPI_NOTRACE_DXContextCreate
                    #define DXContextCreate                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DXContextCreate,                          0)
                #endif
            #endif
            #ifndef DXContextSetSize
                #ifndef DBG_MQLAPI_NOTRACE_DXContextSetSize
                    #define DXContextSetSize                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DXContextSetSize,                         0)
                #endif
            #endif
            #ifndef DXContextGetSize
                #ifndef DBG_MQLAPI_NOTRACE_DXContextGetSize
                    #define DXContextGetSize                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DXContextGetSize,                         0)
                #endif
            #endif
            #ifndef DXContextClearColors
                #ifndef DBG_MQLAPI_NOTRACE_DXContextClearColors
                    #define DXContextClearColors                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DXContextClearColors,                     0)
                #endif
            #endif
            #ifndef DXContextClearDepth
                #ifndef DBG_MQLAPI_NOTRACE_DXContextClearDepth
                    #define DXContextClearDepth                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DXContextClearDepth,                      0)
                #endif
            #endif
            #ifndef DXContextGetColors
                #ifndef DBG_MQLAPI_NOTRACE_DXContextGetColors
                    #define DXContextGetColors                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DXContextGetColors,                       0)
                #endif
            #endif
            #ifndef DXContextGetDepth
                #ifndef DBG_MQLAPI_NOTRACE_DXContextGetDepth
                    #define DXContextGetDepth                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DXContextGetDepth,                        0)
                #endif
            #endif
            #ifndef DXBufferCreate
                #ifndef DBG_MQLAPI_NOTRACE_DXBufferCreate
                    #define DXBufferCreate                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DXBufferCreate,                           0)
                #endif
            #endif
            #ifndef DXTextureCreate
                #ifndef DBG_MQLAPI_NOTRACE_DXTextureCreate
                    #define DXTextureCreate                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DXTextureCreate,                          0)
                #endif
            #endif
            #ifndef DXInputCreate
                #ifndef DBG_MQLAPI_NOTRACE_DXInputCreate
                    #define DXInputCreate                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DXInputCreate,                            0)
                #endif
            #endif
            #ifndef DXInputSet
                #ifndef DBG_MQLAPI_NOTRACE_DXInputSet
                    #define DXInputSet                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DXInputSet,                               0)
                #endif
            #endif
            #ifndef DXShaderCreate
                #ifndef DBG_MQLAPI_NOTRACE_DXShaderCreate
                    #define DXShaderCreate                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DXShaderCreate,                           0)
                #endif
            #endif
            #ifndef DXShaderSetLayout
                #ifndef DBG_MQLAPI_NOTRACE_DXShaderSetLayout
                    #define DXShaderSetLayout                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DXShaderSetLayout,                        0)
                #endif
            #endif
            #ifndef DXShaderInputsSet
                #ifndef DBG_MQLAPI_NOTRACE_DXShaderInputsSet
                    #define DXShaderInputsSet                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DXShaderInputsSet,                        0)
                #endif
            #endif
            #ifndef DXShaderTexturesSet
                #ifndef DBG_MQLAPI_NOTRACE_DXShaderTexturesSet
                    #define DXShaderTexturesSet                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DXShaderTexturesSet,                      0)
                #endif
            #endif
            #ifndef DXDraw
                #ifndef DBG_MQLAPI_NOTRACE_DXDraw
                    #define DXDraw                                                                                          DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DXDraw,                                   0)
                #endif
            #endif
            #ifndef DXDrawIndexed
                #ifndef DBG_MQLAPI_NOTRACE_DXDrawIndexed
                    #define DXDrawIndexed                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DXDrawIndexed,                            0)
                #endif
            #endif
            #ifndef DXPrimiveTopologySet
                #ifndef DBG_MQLAPI_NOTRACE_DXPrimiveTopologySet
                    #define DXPrimiveTopologySet                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DXPrimiveTopologySet,                     0)
                #endif
            #endif
            #ifndef DXBufferSet
                #ifndef DBG_MQLAPI_NOTRACE_DXBufferSet
                    #define DXBufferSet                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DXBufferSet,                              0)
                #endif
            #endif
            #ifndef DXShaderSet
                #ifndef DBG_MQLAPI_NOTRACE_DXShaderSet
                    #define DXShaderSet                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DXShaderSet,                              0)
                #endif
            #endif
            #ifndef DXHandleType
                #ifndef DBG_MQLAPI_NOTRACE_DXHandleType
                    #define DXHandleType                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DXHandleType,                             0)
                #endif
            #endif
            #ifndef DXRelease
                #ifndef DBG_MQLAPI_NOTRACE_DXRelease
                    #define DXRelease                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_DXRelease,                                0)
                #endif
            #endif
            #ifndef FrameAdd
                #ifndef DBG_MQLAPI_NOTRACE_FrameAdd
                    #define FrameAdd                                                                                        DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FrameAdd,                                 0)
                #endif
            #endif
            #ifndef FrameFilter
                #ifndef DBG_MQLAPI_NOTRACE_FrameFilter
                    #define FrameFilter                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FrameFilter,                              0)
                #endif
            #endif
            #ifndef FrameFirst
                #ifndef DBG_MQLAPI_NOTRACE_FrameFirst
                    #define FrameFirst                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FrameFirst,                               0)
                #endif
            #endif
            #ifndef FrameInputs
                #ifndef DBG_MQLAPI_NOTRACE_FrameInputs
                    #define FrameInputs                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FrameInputs,                              0)
                #endif
            #endif
            #ifndef FrameNext
                #ifndef DBG_MQLAPI_NOTRACE_FrameNext
                    #define FrameNext                                                                                       DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FrameNext,                                0)
                #endif
            #endif
            #ifndef GetTickCount64
                #ifndef DBG_MQLAPI_NOTRACE_GetTickCount64
                    #define GetTickCount64                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_GetTickCount64,                           0)
                #endif
            #endif
            #ifndef HistoryDealGetDouble
                #ifndef DBG_MQLAPI_NOTRACE_HistoryDealGetDouble
                    #define HistoryDealGetDouble                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_HistoryDealGetDouble,                     0)
                #endif
            #endif
            #ifndef HistoryDealGetInteger
                #ifndef DBG_MQLAPI_NOTRACE_HistoryDealGetInteger
                    #define HistoryDealGetInteger                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_HistoryDealGetInteger,                    0)
                #endif
            #endif
            #ifndef HistoryDealGetString
                #ifndef DBG_MQLAPI_NOTRACE_HistoryDealGetString
                    #define HistoryDealGetString                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_HistoryDealGetString,                     0)
                #endif
            #endif
            #ifndef HistoryDealGetTicket
                #ifndef DBG_MQLAPI_NOTRACE_HistoryDealGetTicket
                    #define HistoryDealGetTicket                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_HistoryDealGetTicket,                     0)
                #endif
            #endif
            #ifndef HistoryDealSelect
                #ifndef DBG_MQLAPI_NOTRACE_HistoryDealSelect
                    #define HistoryDealSelect                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_HistoryDealSelect,                        0)
                #endif
            #endif
            #ifndef HistoryDealsTotal
                #ifndef DBG_MQLAPI_NOTRACE_HistoryDealsTotal
                    #define HistoryDealsTotal                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_HistoryDealsTotal,                        0)
                #endif
            #endif
            #ifndef HistoryOrderGetDouble
                #ifndef DBG_MQLAPI_NOTRACE_HistoryOrderGetDouble
                    #define HistoryOrderGetDouble                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_HistoryOrderGetDouble,                    0)
                #endif
            #endif
            #ifndef HistoryOrderGetInteger
                #ifndef DBG_MQLAPI_NOTRACE_HistoryOrderGetInteger
                    #define HistoryOrderGetInteger                                                                          DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_HistoryOrderGetInteger,                   0)
                #endif
            #endif
            #ifndef HistoryOrderGetString
                #ifndef DBG_MQLAPI_NOTRACE_HistoryOrderGetString
                    #define HistoryOrderGetString                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_HistoryOrderGetString,                    0)
                #endif
            #endif
            #ifndef HistoryOrderGetTicket
                #ifndef DBG_MQLAPI_NOTRACE_HistoryOrderGetTicket
                    #define HistoryOrderGetTicket                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_HistoryOrderGetTicket,                    0)
                #endif
            #endif
            #ifndef HistoryOrderSelect
                #ifndef DBG_MQLAPI_NOTRACE_HistoryOrderSelect
                    #define HistoryOrderSelect                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_HistoryOrderSelect,                       0)
                #endif
            #endif
            #ifndef HistoryOrdersTotal
                #ifndef DBG_MQLAPI_NOTRACE_HistoryOrdersTotal
                    #define HistoryOrdersTotal                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_HistoryOrdersTotal,                       0)
                #endif
            #endif
            #ifndef HistorySelect
                #ifndef DBG_MQLAPI_NOTRACE_HistorySelect
                    #define HistorySelect                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_HistorySelect,                            0)
                #endif
            #endif
            #ifndef HistorySelectByPosition
                #ifndef DBG_MQLAPI_NOTRACE_HistorySelectByPosition
                    #define HistorySelectByPosition                                                                         DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_HistorySelectByPosition,                  0)
                #endif
            #endif
            #ifndef iTickVolume
                #ifndef DBG_MQLAPI_NOTRACE_iTickVolume
                    #define iTickVolume                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iTickVolume,                              0)
                #endif
            #endif
            #ifndef iRealVolume
                #ifndef DBG_MQLAPI_NOTRACE_iRealVolume
                    #define iRealVolume                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iRealVolume,                              0)
                #endif
            #endif
            #ifndef iSpread
                #ifndef DBG_MQLAPI_NOTRACE_iSpread
                    #define iSpread                                                                                         DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iSpread,                                  0)
                #endif
            #endif
            #ifndef iADXWilder
                #ifndef DBG_MQLAPI_NOTRACE_iADXWilder
                    #define iADXWilder                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iADXWilder,                               0)
                #endif
            #endif
            #ifndef iAMA
                #ifndef DBG_MQLAPI_NOTRACE_iAMA
                    #define iAMA                                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iAMA,                                     0)
                #endif
            #endif
            #ifndef iChaikin
                #ifndef DBG_MQLAPI_NOTRACE_iChaikin
                    #define iChaikin                                                                                        DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iChaikin,                                 0)
                #endif
            #endif
            #ifndef iDEMA
                #ifndef DBG_MQLAPI_NOTRACE_iDEMA
                    #define iDEMA                                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iDEMA,                                    0)
                #endif
            #endif
            #ifndef iFrAMA
                #ifndef DBG_MQLAPI_NOTRACE_iFrAMA
                    #define iFrAMA                                                                                          DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iFrAMA,                                   0)
                #endif
            #endif
            #ifndef IndicatorCreate
                #ifndef DBG_MQLAPI_NOTRACE_IndicatorCreate
                    #define IndicatorCreate                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_IndicatorCreate,                          0)
                #endif
            #endif
            #ifndef IndicatorParameters
                #ifndef DBG_MQLAPI_NOTRACE_IndicatorParameters
                    #define IndicatorParameters                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_IndicatorParameters,                      0)
                #endif
            #endif
            #ifndef IndicatorRelease
                #ifndef DBG_MQLAPI_NOTRACE_IndicatorRelease
                    #define IndicatorRelease                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_IndicatorRelease,                         0)
                #endif
            #endif
            #ifndef iTEMA
                #ifndef DBG_MQLAPI_NOTRACE_iTEMA
                    #define iTEMA                                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iTEMA,                                    0)
                #endif
            #endif
            #ifndef iTriX
                #ifndef DBG_MQLAPI_NOTRACE_iTriX
                    #define iTriX                                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iTriX,                                    0)
                #endif
            #endif
            #ifndef iVIDyA
                #ifndef DBG_MQLAPI_NOTRACE_iVIDyA
                    #define iVIDyA                                                                                          DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iVIDyA,                                   0)
                #endif
            #endif
            #ifndef iVolumes
                #ifndef DBG_MQLAPI_NOTRACE_iVolumes
                    #define iVolumes                                                                                        DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_iVolumes,                                 0)
                #endif
            #endif
            #ifndef MarketBookAdd
                #ifndef DBG_MQLAPI_NOTRACE_MarketBookAdd
                    #define MarketBookAdd                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MarketBookAdd,                            0)
                #endif
            #endif
            #ifndef MarketBookGet
                #ifndef DBG_MQLAPI_NOTRACE_MarketBookGet
                    #define MarketBookGet                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MarketBookGet,                            0)
                #endif
            #endif
            #ifndef MarketBookRelease
                #ifndef DBG_MQLAPI_NOTRACE_MarketBookRelease
                    #define MarketBookRelease                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MarketBookRelease,                        0)
                #endif
            #endif
            #ifndef MQLInfoInteger
                #ifndef DBG_MQLAPI_NOTRACE_MQLInfoInteger
                    #define MQLInfoInteger                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_MQLInfoInteger,                           0)
                #endif
            #endif


            #ifndef OnnxCreate
                #ifndef DBG_MQLAPI_NOTRACE_OnnxCreate
                    #define OnnxCreate                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OnnxCreate,                               0)
                #endif
            #endif
            #ifndef OnnxCreateFromBuffer
                #ifndef DBG_MQLAPI_NOTRACE_OnnxCreateFromBuffer
                    #define OnnxCreateFromBuffer                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OnnxCreateFromBuffer,                     0)
                #endif
            #endif
            #ifndef OnnxRelease
                #ifndef DBG_MQLAPI_NOTRACE_OnnxRelease
                    #define OnnxRelease                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OnnxRelease,                              0)
                #endif
            #endif
            #ifndef OnnxRun
                #ifndef DBG_MQLAPI_NOTRACE_OnnxRun
                    #define OnnxRun                                                                                         DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OnnxRun,                                  0)
                #endif
            #endif
            #ifndef OnnxGetInputCount
                #ifndef DBG_MQLAPI_NOTRACE_OnnxGetInputCount
                    #define OnnxGetInputCount                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OnnxGetInputCount,                        0)
                #endif
            #endif
            #ifndef OnnxGetOutputCount
                #ifndef DBG_MQLAPI_NOTRACE_OnnxGetOutputCount
                    #define OnnxGetOutputCount                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OnnxGetOutputCount,                       0)
                #endif
            #endif
            #ifndef OnnxGetInputName
                #ifndef DBG_MQLAPI_NOTRACE_OnnxGetInputName
                    #define OnnxGetInputName                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OnnxGetInputName,                         0)
                #endif
            #endif
            #ifndef OnnxGetOutputName
                #ifndef DBG_MQLAPI_NOTRACE_OnnxGetOutputName
                    #define OnnxGetOutputName                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OnnxGetOutputName,                        0)
                #endif
            #endif
            #ifndef OnnxGetInputTypeInfo
                #ifndef DBG_MQLAPI_NOTRACE_OnnxGetInputTypeInfo
                    #define OnnxGetInputTypeInfo                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OnnxGetInputTypeInfo,                     0)
                #endif
            #endif
            #ifndef OnnxGetOutputTypeInfo
                #ifndef DBG_MQLAPI_NOTRACE_OnnxGetOutputTypeInfo
                    #define OnnxGetOutputTypeInfo                                                                           DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OnnxGetOutputTypeInfo,                    0)
                #endif
            #endif
            #ifndef OnnxSetInputShape
                #ifndef DBG_MQLAPI_NOTRACE_OnnxSetInputShape
                    #define OnnxSetInputShape                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OnnxSetInputShape,                        0)
                #endif
            #endif
            #ifndef OnnxSetOutputShape
                #ifndef DBG_MQLAPI_NOTRACE_OnnxSetOutputShape
                    #define OnnxSetOutputShape                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OnnxSetOutputShape,                       0)
                #endif
            #endif
            #ifndef OrderCalcMargin
                #ifndef DBG_MQLAPI_NOTRACE_OrderCalcMargin
                    #define OrderCalcMargin                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderCalcMargin,                          0)
                #endif
            #endif
            #ifndef OrderCalcProfit
                #ifndef DBG_MQLAPI_NOTRACE_OrderCalcProfit
                    #define OrderCalcProfit                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderCalcProfit,                          0)
                #endif
            #endif
            #ifndef OrderCheck
                #ifndef DBG_MQLAPI_NOTRACE_OrderCheck
                    #define OrderCheck                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderCheck,                               0)
                #endif
            #endif
            #ifndef OrderGetInteger
                #ifndef DBG_MQLAPI_NOTRACE_OrderGetInteger
                    #define OrderGetInteger                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderGetInteger,                          0)
                #endif
            #endif
            #ifndef OrderGetString
                #ifndef DBG_MQLAPI_NOTRACE_OrderGetString
                    #define OrderGetString                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderGetString,                           0)
                #endif
            #endif
            #ifndef OrderGetTicket
                #ifndef DBG_MQLAPI_NOTRACE_OrderGetTicket
                    #define OrderGetTicket                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderGetTicket,                           0)
                #endif
            #endif
            #ifndef OrderSendAsync
                #ifndef DBG_MQLAPI_NOTRACE_OrderSendAsync
                    #define OrderSendAsync                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderSendAsync,                           0)
                #endif
            #endif
            #ifndef OrdersTotal
                #ifndef DBG_MQLAPI_NOTRACE_OrdersTotal
                    #define OrdersTotal                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrdersTotal,                              0)
                #endif
            #endif
            #ifndef ParameterGetRange
                #ifndef DBG_MQLAPI_NOTRACE_ParameterGetRange
                    #define ParameterGetRange                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ParameterGetRange,                        0)
                #endif
            #endif
            #ifndef ParameterSetRange
                #ifndef DBG_MQLAPI_NOTRACE_ParameterSetRange
                    #define ParameterSetRange                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_ParameterSetRange,                        0)
                #endif
            #endif
            #ifndef PositionGetDouble
                #ifndef DBG_MQLAPI_NOTRACE_PositionGetDouble
                    #define PositionGetDouble                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_PositionGetDouble,                        0)
                #endif
            #endif
            #ifndef PositionGetInteger
                #ifndef DBG_MQLAPI_NOTRACE_PositionGetInteger
                    #define PositionGetInteger                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_PositionGetInteger,                       0)
                #endif
            #endif
            #ifndef PositionGetString
                #ifndef DBG_MQLAPI_NOTRACE_PositionGetString
                    #define PositionGetString                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_PositionGetString,                        0)
                #endif
            #endif
            #ifndef PositionGetSymbol
                #ifndef DBG_MQLAPI_NOTRACE_PositionGetSymbol
                    #define PositionGetSymbol                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_PositionGetSymbol,                        0)
                #endif
            #endif
            #ifndef PositionGetTicket
                #ifndef DBG_MQLAPI_NOTRACE_PositionGetTicket
                    #define PositionGetTicket                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_PositionGetTicket,                        0)
                #endif
            #endif
            #ifndef PositionSelect
                #ifndef DBG_MQLAPI_NOTRACE_PositionSelect
                    #define PositionSelect                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_PositionSelect,                           0)
                #endif
            #endif
            #ifndef PositionSelectByTicket
                #ifndef DBG_MQLAPI_NOTRACE_PositionSelectByTicket
                    #define PositionSelectByTicket                                                                          DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_PositionSelectByTicket,                   0)
                #endif
            #endif
            #ifndef PositionsTotal
                #ifndef DBG_MQLAPI_NOTRACE_PositionsTotal
                    #define PositionsTotal                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_PositionsTotal,                           0)
                #endif
            #endif
            #ifndef SocketCreate
                #ifndef DBG_MQLAPI_NOTRACE_SocketCreate
                    #define SocketCreate                                                                                    DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SocketCreate,                             0)
                #endif
            #endif
            #ifndef SocketClose
                #ifndef DBG_MQLAPI_NOTRACE_SocketClose
                    #define SocketClose                                                                                     DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SocketClose,                              0)
                #endif
            #endif
            #ifndef SocketConnect
                #ifndef DBG_MQLAPI_NOTRACE_SocketConnect
                    #define SocketConnect                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SocketConnect,                            0)
                #endif
            #endif
            #ifndef SocketIsConnected
                #ifndef DBG_MQLAPI_NOTRACE_SocketIsConnected
                    #define SocketIsConnected                                                                               DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SocketIsConnected,                        0)
                #endif
            #endif
            #ifndef SocketIsReadable
                #ifndef DBG_MQLAPI_NOTRACE_SocketIsReadable
                    #define SocketIsReadable                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SocketIsReadable,                         0)
                #endif
            #endif
            #ifndef SocketIsWritable
                #ifndef DBG_MQLAPI_NOTRACE_SocketIsWritable
                    #define SocketIsWritable                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SocketIsWritable,                         0)
                #endif
            #endif
            #ifndef SocketTimeouts
                #ifndef DBG_MQLAPI_NOTRACE_SocketTimeouts
                    #define SocketTimeouts                                                                                  DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SocketTimeouts,                           0)
                #endif
            #endif
            #ifndef SocketRead
                #ifndef DBG_MQLAPI_NOTRACE_SocketRead
                    #define SocketRead                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SocketRead,                               0)
                #endif
            #endif
            #ifndef SocketSend
                #ifndef DBG_MQLAPI_NOTRACE_SocketSend
                    #define SocketSend                                                                                      DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SocketSend,                               0)
                #endif
            #endif
            #ifndef SocketTlsHandshake
                #ifndef DBG_MQLAPI_NOTRACE_SocketTlsHandshake
                    #define SocketTlsHandshake                                                                              DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SocketTlsHandshake,                       0)
                #endif
            #endif
            #ifndef SocketTlsCertificate
                #ifndef DBG_MQLAPI_NOTRACE_SocketTlsCertificate
                    #define SocketTlsCertificate                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SocketTlsCertificate,                     0)
                #endif
            #endif
            #ifndef SocketTlsRead
                #ifndef DBG_MQLAPI_NOTRACE_SocketTlsRead
                    #define SocketTlsRead                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SocketTlsRead,                            0)
                #endif
            #endif
            #ifndef SocketTlsReadAvailable
                #ifndef DBG_MQLAPI_NOTRACE_SocketTlsReadAvailable
                    #define SocketTlsReadAvailable                                                                          DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SocketTlsReadAvailable,                   0)
                #endif
            #endif
            #ifndef SocketTlsSend
                #ifndef DBG_MQLAPI_NOTRACE_SocketTlsSend
                    #define SocketTlsSend                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SocketTlsSend,                            0)
                #endif
            #endif
            #ifndef SymbolInfoMarginRate
                #ifndef DBG_MQLAPI_NOTRACE_SymbolInfoMarginRate
                    #define SymbolInfoMarginRate                                                                            DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_SymbolInfoMarginRate,                     0)
                #endif
            #endif
            #ifndef TerminalInfoInteger
                #ifndef DBG_MQLAPI_NOTRACE_TerminalInfoInteger
                    #define TerminalInfoInteger                                                                             DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TerminalInfoInteger,                      0)
                #endif
            #endif
            #ifndef TesterDeposit
                #ifndef DBG_MQLAPI_NOTRACE_TesterDeposit
                    #define TesterDeposit                                                                                   DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TesterDeposit,                            0)
                #endif
            #endif
            #ifndef TesterWithdrawal
                #ifndef DBG_MQLAPI_NOTRACE_TesterWithdrawal
                    #define TesterWithdrawal                                                                                DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TesterWithdrawal,                         0)
                #endif
            #endif
            #ifndef TimeTradeServer
                #ifndef DBG_MQLAPI_NOTRACE_TimeTradeServer
                    #define TimeTradeServer                                                                                 DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TimeTradeServer,                          0)
                #endif
            #endif

        #endif



#endif
//
/////////////////////////////////////////////////////////////////////////////////////////////////////


//
// END Debugging support
//*********************************************************************************************************************************************************/
#endif // LIB_DBG_DEBUG_MQLAPI_TRACER_OVERWRITE_MACROS_MQH_INCLUDED
